SystemOrganization addCategory: #'SWT-Core-MVC'!
SystemOrganization addCategory: #'SWT-Core-MVC-Tests'!
SystemOrganization addCategory: #'SWT-Core-Widgets'!
SystemOrganization addCategory: #'SWT-Core-Widgets-Effects'!
SystemOrganization addCategory: #'SWT-Core-Widgets-Panels'!
SystemOrganization addCategory: #'SWT-Core-Widgets-Misc'!
SystemOrganization addCategory: #'SWT-Core-Application'!
SystemOrganization addCategory: #'SWT-Utilities'!
SystemOrganization addCategory: #'SWT-Examples'!
SystemOrganization addCategory: #'SWT-Examples-MVC'!
SystemOrganization addCategory: #'SWT-Examples-SocialShopping-View'!
SystemOrganization addCategory: #'SWT-Examples-SocialShopping-Model'!
SystemOrganization addCategory: #'SWT-Examples-SharedWhiteboard'!
SystemOrganization addCategory: #'SWT-Examples-Map'!

!S2SObject class methodsFor: '*SWT-views' stamp: 'dgd 11/9/2007 12:15'!
application
	^ self jsLiteral: 'app'! !

!S2SObject methodsFor: '*SWT-views' stamp: 'dgd 11/9/2007 12:15'!
application
	^ self jsLiteral: 'app'! !

S2SObject subclass: #SWTAbstractEffect
	instanceVariableNames: 'widget onStart onStep onStop running startedTime gentlyProgress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 10/16/2007 11:01'!
acelerate
	"Change the receiver's aceleration factor"
	^ self subclassResponsibility! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 6/8/2007 19:26'!
aceleration: aNumber
	"Change the receiver's aceleration factor"
	^ self subclassResponsibility! !

!SWTAbstractEffect methodsFor: 'testing' stamp: 'dgd 10/9/2007 20:07'!
affectsWidget: aWidget
	"Answer if the receiver affects the given widget"

	^ widget == aWidget.
! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 10/21/2007 14:55'!
currentProgress: now

	| result |

	gentlyProgress inlineIfTrue:[
			result := self gentlyProgress: now.
		]
		ifFalse:[
			result := self progress: now.
		].

	(result <= 0) inlineIfTrue:[^ 0].
	(result >= 1) inlineIfTrue:[^ 1].

	^ result! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 6/8/2007 18:47'!
defaultWidget: targetWidget
	"Use the given widget as the target ONLY if the target was not explicit set"

	widget isNil inlineIfTrue:[
		widget := targetWidget.
	].
! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 10/31/2007 11:10'!
doStep: now
"
	self
		assert: [running]
		errorMessage: 'Not running, invalid step'.
"
	onStep isNil inlineIfFalse:[
		onStep value: self value: now.
	].
! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 10/21/2007 14:58'!
gentlyProgress: now

	((self progress: now) >= 1)
		inlineIfTrue:[^ 1].

	^ self gently: (self progress: now) lowerBound: 0.6 upperBound: 0.85.
! !

!SWTAbstractEffect methodsFor: 'private' stamp: 'dgd 10/24/2006 17:22'!
gently: x lowerBound: lower upperBound: upper
	"FROM WonderlandStyle"

	"This method converts a linear proportion done to a slow in - slow out proportion. If x is less than A then the animation is in the slow in part, while if x is greater than B then the animation is in the slow out part."

	| a3 b3 c3 m b2 |
 
 	(x < lower) inlineIfTrue: [
		^ ((upper - 1) / (lower *  ((upper * upper) - (lower * upper) + lower - 1))) * x * x
	].

	(x > upper) inlineIfTrue: [
		a3 := 1 / ((upper * upper) - (lower * upper) + lower - 1).
		b3 := -2 * a3.
		c3 := 1 + a3.
		^ (a3 * x * x) + (b3 * x) + c3.
	].

	m := 2 * (upper - 1) / ((upper * upper) - (lower * upper) + lower - 1).
	b2 := (0 - m) * lower / 2.
	
	^ m * x + b2.
! !

!SWTAbstractEffect methodsFor: 'initialization' stamp: 'dgd 10/16/2007 14:34'!
initialize
	super initialize.

	running := false.
	gentlyProgress := true.
! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 6/9/2007 09:38'!
isDone: now
	"Answer if the receivers has finished its job"

	^ self subclassResponsibility! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 6/8/2007 10:50'!
onStart: aBlock

	onStart := aBlock
! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 6/8/2007 10:50'!
onStep: aBlock

	onStep := aBlock
! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 6/7/2007 19:13'!
onStop: aBlock

	onStop := aBlock
! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 7/1/2007 12:11'!
progress: now
	"Answer the progress (0 to 1) of the receiver, calculated from the startedTime"

"	^ ((now - startedTime) / self time) ""asFloat"
	^ self jsLiteral: '(now - self._startedTime) / self.time()'.
! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 10/9/2007 12:01'!
start
"
	self
		assert: [running not]
		errorMessage: 'Already started'.
"
	running := true.

	onStart isNil inlineIfFalse:[
		onStart value: widget.
	].

	startedTime := Time timestamp.
! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 6/14/2007 15:40'!
startForDefaultWidget

	self startFor: widget! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 6/14/2007 15:43'!
startForDefaultWidgetIn: delayMillisecondsNumber

	self startFor: widget in: delayMillisecondsNumber! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 10/9/2007 12:01'!
startFor: aWidget

	self defaultWidget: aWidget.

	aWidget scheduler startEffect: self at: Time timestamp.
! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 6/14/2007 15:44'!
startFor: aWidget in: delayMillisecondsNumber

	self defaultWidget: aWidget.

	aWidget scheduler startEffect: self in: delayMillisecondsNumber.
! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 6/6/2007 17:34'!
steps
	"Answer how many steps, the receiver, needs to complete its objetive"

	^ (self time / self stepTime) truncated! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 10/21/2007 19:26'!
stepTime
	"Answer the time to wait between steps"

	^ "50"25.
! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 6/14/2007 15:58'!
stop
	"The effect is stoping (and probably the last steps was not executed), so make the 'final' actions to ensure the object is in a valid shape"
"
	self
		assert: [running]
		errorMessage: 'Not running, invalid stop'.
"
	running := false.

	onStop isNil inlineIfFalse:[
		onStop value: widget.
	].

! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 6/6/2007 14:50'!
time
	"Answer the amount of time, in milliseconds, the receiver needs to complete"

	^ self subclassResponsibility! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 10/18/2007 12:45'!
updateStress: aNumber
	"Change the receiver's stress factor"
	^ self subclassResponsibility! !

!SWTAbstractEffect methodsFor: 'accessing' stamp: 'dgd 10/16/2007 14:38'!
useLinearProgress

	gentlyProgress := false.
! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 6/18/2007 12:19'!
widget

	^ widget.! !

!SWTAbstractEffect methodsFor: 'running' stamp: 'dgd 6/6/2007 15:32'!
widget: targetWidget

	widget := targetWidget.
! !

SWTAbstractEffect subclass: #SWTCompositeEffect
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

!SWTCompositeEffect class methodsFor: 'instance creation' stamp: 'dgd 6/6/2007 15:48'!
children: aCollection
	^ self new initializeChildren: aCollection! !

!SWTCompositeEffect methodsFor: 'accessing' stamp: 'dgd 10/16/2007 11:01'!
acelerate

	children inlineDo:[:each | each acelerate].
! !

!SWTCompositeEffect methodsFor: 'accessing' stamp: 'dgd 6/8/2007 19:26'!
aceleration: aNumber

	children inlineDo:[:each | each aceleration: aNumber].
! !

!SWTCompositeEffect methodsFor: 'testing' stamp: 'dgd 10/9/2007 20:17'!
affectsWidget: aWidget
	"Answer if the receiver affects the given widget"

	^ (super affectsWidget: aWidget) or: [ children anySatisfy:[:each | each affectsWidget: aWidget] ]
! !

!SWTCompositeEffect methodsFor: 'running' stamp: 'dgd 6/8/2007 18:41'!
defaultWidget: targetWidget

	super defaultWidget: targetWidget.

	children inlineDo:[:each | each defaultWidget: targetWidget].
! !

!SWTCompositeEffect methodsFor: 'initialization' stamp: 'dgd 6/6/2007 15:49'!
initializeChildren: aCollection
	children := aCollection! !

!SWTCompositeEffect methodsFor: 'accessing' stamp: 'dgd 10/18/2007 12:45'!
updateStress: aNumber
	"Change the receiver's stress factor"

	children inlineDo:[:each | each updateStress: aNumber].
! !

!SWTCompositeEffect methodsFor: 'running' stamp: 'dgd 6/8/2007 18:45'!
widget: targetWidget

	super widget: targetWidget.

	children inlineDo:[:each | each widget: targetWidget].
! !

SWTCompositeEffect subclass: #SWTParallelEffect
	instanceVariableNames: 'stopped'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

!SWTParallelEffect methodsFor: 'running' stamp: 'dgd 6/9/2007 09:37'!
doStep: now

	children inlineWithIndexDo:[:eachEffect :index | 
		(stopped at: index) inlineIfFalse:[
			eachEffect doStep: now.
			(eachEffect isDone: now) inlineIfTrue:[
				stopped at: index put: true.
				eachEffect stop.
			].
		].
	].

	super doStep: now.! !

!SWTParallelEffect methodsFor: 'running' stamp: 'dgd 6/14/2007 14:49'!
isDone: now

	stopped inlineDo: [:each |
		(each == true)
			inlineIfFalse: [^ false]
	].

	^ true.
! !

!SWTParallelEffect methodsFor: 'running' stamp: 'dgd 6/7/2007 16:07'!
start
	super start.

	stopped := Array new: children size withAll: false.
	children inlineDo:[:each | each start].
! !

!SWTParallelEffect methodsFor: 'running' stamp: 'dgd 6/7/2007 16:07'!
stop
	super stop.

	children inlineWithIndexDo:[:eachEffect :index |
			(stopped at: index) inlineIfFalse:[
				stopped at: index put: true.
				eachEffect stop.
			].
	].
! !

!SWTParallelEffect methodsFor: 'accessing' stamp: 'dgd 6/8/2007 19:29'!
time
	"Answer the amount of time, in milliseconds, the receiver needs to complete"

	children isEmpty inlineIfTrue:[^ 0].

	^ (children detectMax: [:each | each time ]) time! !

SWTCompositeEffect subclass: #SWTSequenceEffect
	instanceVariableNames: 'currentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

!SWTSequenceEffect methodsFor: 'running' stamp: 'dgd 6/9/2007 09:37'!
doStep: now

	| currentEffect |

	currentEffect := children at: currentIndex.

	currentEffect doStep: now.
	(currentEffect isDone: now) inlineIfTrue:[
		currentEffect stop.
		self nextEffect.
	].

	super doStep: now.
! !

!SWTSequenceEffect methodsFor: 'running' stamp: 'dgd 6/14/2007 14:51'!
isDone: now
	"^ currentIndex > children size"
	^ self jsLiteral: 'self._currentIndex > self._children.length'
! !

!SWTSequenceEffect methodsFor: 'private' stamp: 'dgd 10/20/2007 16:43'!
nextEffect

	currentIndex := currentIndex + 1.

	(currentIndex <= children size) inlineIfTrue: [
		(children at: currentIndex) start.
	].
! !

!SWTSequenceEffect methodsFor: 'running' stamp: 'dgd 6/6/2007 16:53'!
start
	super start.

	currentIndex := 0.
	self nextEffect.
! !

!SWTSequenceEffect methodsFor: 'running' stamp: 'dgd 6/6/2007 16:52'!
stop
	"The effect is stoping (and probably the last steps was not executed), so make the 'final' actions to ensure the object is in a valid shape"
	
	currentIndex to: children size do:[:index |
		(children at: index) stop.
	].

	super stop.
! !

!SWTSequenceEffect methodsFor: 'accessing' stamp: 'dgd 6/8/2007 19:29'!
time
	"Answer the amount of time, in milliseconds, the receiver needs to complete"

	^ children detectSum: [:each | each time ]! !

SWTAbstractEffect subclass: #SWTEffect
	instanceVariableNames: 'time aceleration stress stressFactor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

!SWTEffect class methodsFor: 'accessing' stamp: 'dgd 6/7/2007 09:30'!
defaultTime
	^ 750! !

!SWTEffect class methodsFor: 'instance creation' stamp: 'dgd 6/7/2007 09:55'!
doInOrder: aCollection

	^ SWTSequenceEffect children: aCollection! !

!SWTEffect class methodsFor: 'instance creation' stamp: 'dgd 6/7/2007 09:57'!
doTogether: aCollection

	^ SWTParallelEffect children: aCollection! !

!SWTEffect methodsFor: 'accessing' stamp: 'dgd 10/18/2007 12:18'!
acelerate
	aceleration := aceleration * 0.97.
! !

!SWTEffect methodsFor: 'accessing' stamp: 'dgd 6/8/2007 19:25'!
aceleration: aNumber
	aceleration := aNumber! !

!SWTEffect methodsFor: 'initialization' stamp: 'dgd 11/1/2007 09:40'!
initialize
	super initialize.

	time := self class defaultTime.

	aceleration := 1.

	stress := 0.
	stressFactor := 1.0 "anything raisedTo: 0 is 1".
! !

!SWTEffect methodsFor: 'running' stamp: 'dgd 6/14/2007 14:45'!
isDone: now
"
	^ (now - startedTime) >= self time
"
	^ self jsLiteral: '(now - self._startedTime) >= self.time()'! !

!SWTEffect methodsFor: 'accessing' stamp: 'dgd 11/1/2007 11:11'!
time
	"Answer the amount of time, in milliseconds, the receiver needs to complete"

	^ time * aceleration * stressFactor
"	^ self jsLiteral: 'self._time * self._aceleration * self._stressFactor'"
! !

!SWTEffect methodsFor: 'accessing' stamp: 'dgd 6/9/2007 10:37'!
time: aNumber
"
	(aNumber <= 100) inlineIfTrue:[
		self logWarning: 'WARNING: ' , self asString , ' has a very short lapse to realize the animation.'
	].
"
	time := aNumber! !

!SWTEffect methodsFor: 'initialization' stamp: 'dgd 11/1/2007 14:17'!
updateStress: aNumber

	"The strees can never be less than the current, otherwise strange situation can happens"
	(aNumber > stress) inlineIfTrue:[
		stress := aNumber.
		stressFactor := 0.97 raisedTo: stress.
	].
! !

SWTEffect subclass: #SWTPauseEffect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

!SWTPauseEffect class methodsFor: 'instance creation' stamp: 'dgd 6/7/2007 18:21'!
seconds: aNumber
	^ self time: aNumber * 1000! !

!SWTPauseEffect class methodsFor: 'instance creation' stamp: 'dgd 6/7/2007 18:21'!
time: aNumber
	^ self new time: aNumber; yourself! !

SWTEffect subclass: #SWTRangeEffect
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

SWTRangeEffect subclass: #SWTColorEffect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

!SWTColorEffect class methodsFor: 'instance creation' stamp: 'dgd 10/9/2007 09:07'!
highlight: toColor from: fromColor

	| halfTime |

	halfTime := (SWTEffect defaultTime / 2) rounded.

	^ SWTEffect doInOrder: {
			self from: fromColor	to: toColor		time: halfTime.
			self from: toColor		to: fromColor		time: halfTime.
		}.
! !

!SWTColorEffect methodsFor: 'private' stamp: 'dgd 6/7/2007 09:25'!
getWidgetRange
	"Answer the property of the receiver's widget"

	^ widget backgroundColor! !

!SWTColorEffect methodsFor: 'private' stamp: 'dgd 10/16/2007 14:33'!
rangeProgress: now

	^ to
			alphaMixed: (self currentProgress: now)
			with: from.
! !

!SWTColorEffect methodsFor: 'private' stamp: 'dgd 6/7/2007 09:24'!
setWidgetRange: currentObject 
	widget backgroundColor: currentObject! !

SWTRangeEffect subclass: #SWTExtentEffect
	instanceVariableNames: 'rotationStyle originalExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

!SWTExtentEffect class methodsFor: 'instance creation' stamp: 'dgd 11/1/2007 14:20'!
rotationAtVerticalCenterWidget: aWidget extent: widgetExtent time: timeNumber onTurn: turnBlock

	|  rotatedExtent bigExtent thirdTime eff |

	rotatedExtent := (widgetExtent * (0.1@1)) rounded.
	bigExtent := (widgetExtent * (1.1@1)) rounded.

	"halfTime := (timeNumber / 2) rounded. "
	thirdTime := (timeNumber / 3) rounded.
	"quarterTime := (timeNumber / 4) rounded."

"
	eff := SWTEffect doInOrder: {
										(self to: rotatedExtent time: halfTime)
											simulateRotationAtVerticalCenter: widgetExtent;
											useLinearProgress;
											onStop: turnBlock.
										(self to: widgetExtent time: halfTime)
											simulateRotationAtVerticalCenter: widgetExtent;
											useLinearProgress.
									}.
"
	eff := SWTEffect doInOrder: {
										(self to: rotatedExtent time: thirdTime)
											simulateRotationAtVerticalCenter: widgetExtent;
											useLinearProgress;
											onStop: turnBlock.
										(self to: bigExtent time: thirdTime)
											simulateRotationAtVerticalCenter: widgetExtent;
											useLinearProgress.
										(self to: widgetExtent time: thirdTime)
											simulateRotationAtVerticalCenter: widgetExtent;
											useLinearProgress.
									}.

	eff widget: aWidget.

	^ eff.
! !

!SWTExtentEffect class methodsFor: 'instance creation' stamp: 'dgd 10/18/2007 17:24'!
rotationAtVerticalCenterWidget: aWidget time: timeNumber onTurn: turnBlock

	^ self rotationAtVerticalCenterWidget: aWidget extent: aWidget extent time: timeNumber onTurn: turnBlock! !

!SWTExtentEffect methodsFor: 'running' stamp: 'dgd 11/1/2007 14:19'!
doStep: now

	| delta |

	super doStep: now.

	(rotationStyle = #VerticalCenter) inlineIfTrue:[
		delta := originalExtent x - widget width.
		widget deltaPosition: (delta / 2) rounded @ (delta / 8) rounded.
	].
! !

!SWTExtentEffect methodsFor: 'private' stamp: 'dgd 6/7/2007 09:25'!
getWidgetRange
	"Answer the property of the receiver's widget"

	^ widget extent! !

!SWTExtentEffect methodsFor: 'initialization' stamp: 'dgd 6/15/2007 12:51'!
initialize
	super initialize.

	rotationStyle := #Left.
	originalExtent := 0@0.
! !

!SWTExtentEffect methodsFor: 'private' stamp: 'dgd 6/8/2007 10:10'!
setWidgetRange: currentObject 
	widget extent: currentObject rounded! !

!SWTExtentEffect methodsFor: 'accessing' stamp: 'dgd 6/15/2007 14:27'!
simulateRotationAtVerticalCenter: originalExtentPoint
	rotationStyle := #VerticalCenter.
	originalExtent := originalExtentPoint.! !

!SWTExtentEffect methodsFor: 'running' stamp: 'dgd 6/15/2007 13:02'!
stop
	super stop.


"	(rotationStyle = #Left) inlineIfFalse:["
	(rotationStyle = #VerticalCenter) inlineIfTrue:[
		widget width = originalExtent x inlineIfTrue:[
			widget deltaPosition: 0@0.
		].
	].

	originalExtent := nil.
! !

SWTRangeEffect subclass: #SWTOpacityEffect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

!SWTOpacityEffect class methodsFor: 'instance creation' stamp: 'dgd 9/27/2006 17:55'!
appear
	^ self from: 0 to: 1! !

!SWTOpacityEffect class methodsFor: 'instance creation' stamp: 'dgd 9/27/2006 17:55'!
fade
	^ self from: 1 to: 0! !

!SWTOpacityEffect methodsFor: 'private' stamp: 'dgd 6/7/2007 09:27'!
getWidgetRange
	"Answer the property of the receiver's widget"

	^ widget opacity ifNil: [1]! !

!SWTOpacityEffect methodsFor: 'private' stamp: 'dgd 6/7/2007 09:24'!
setWidgetRange: currentObject 
	widget opacity: currentObject! !

SWTRangeEffect subclass: #SWTPositionEffect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Effects'!

!SWTPositionEffect class methodsFor: 'as yet unclassified' stamp: 'dgd 10/25/2007 17:52'!
from: fromPoint to: toPoint onHalf: onHalfBlock

	^ self from: fromPoint to: toPoint time: self defaultTime onHalf: onHalfBlock 
! !

!SWTPositionEffect class methodsFor: 'as yet unclassified' stamp: 'dgd 11/1/2007 09:39'!
from: fromPoint to: toPoint  time: timeNumber onHalf: onHalfBlock

"
	| halfPoint halfTime |

	halfPoint := ((toPoint + fromPoint) / 2) rounded.
	halfTime := (timeNumber / 2) rounded.

	^ SWTEffect doInOrder: {
									(self from: fromPoint to: halfPoint time: halfTime)
										onStop: onHalfBlock;
										useLinearProgress.
									(self from: halfPoint to: toPoint time: halfTime)
										useLinearProgress.
								}.
"

	| eff |

	eff := self from: fromPoint to: toPoint time: timeNumber.
"	eff useLinearProgress."

	eff onStep: [:effect :now |
		((effect progress: now) >= 0.5) inlineIfTrue:[
			effect onStep: nil.
			onHalfBlock value.
		].
		nil.
	].

	^ eff.
! !

!SWTPositionEffect methodsFor: 'private' stamp: 'dgd 6/7/2007 09:25'!
getWidgetRange
	"Answer the property of the receiver's widget"

	^ widget position! !

!SWTPositionEffect methodsFor: 'private' stamp: 'dgd 6/8/2007 10:07'!
setWidgetRange: currentObject 
	widget position: currentObject rounded! !

!SWTRangeEffect class methodsFor: 'instance creation' stamp: 'dgd 6/7/2007 08:48'!
from: fromObject

	^ self new initializeFrom: fromObject! !

!SWTRangeEffect class methodsFor: 'instance creation' stamp: 'dgd 6/7/2007 09:44'!
from: fromObject time: aNumber

	^ (self from: fromObject)
			time: aNumber;
			yourself! !

!SWTRangeEffect class methodsFor: 'instance creation' stamp: 'dgd 6/7/2007 08:49'!
from: fromObject to: toObject

	^ (self new initializeFrom: fromObject) initializeTo: toObject! !

!SWTRangeEffect class methodsFor: 'instance creation' stamp: 'dgd 6/7/2007 09:19'!
from: fromObject to: toObject time: aNumber

	^ (self from: fromObject to: toObject)
			time: aNumber;
			yourself! !

!SWTRangeEffect class methodsFor: 'instance creation' stamp: 'dgd 6/7/2007 08:48'!
to: toObject

	^ self new initializeTo: toObject! !

!SWTRangeEffect class methodsFor: 'instance creation' stamp: 'dgd 6/7/2007 09:44'!
to: toObject time: aNumber

	^ (self to: toObject)
			time: aNumber;
			yourself! !

!SWTRangeEffect methodsFor: 'running' stamp: 'dgd 6/8/2007 10:49'!
doStep: now

	self setWidgetRange: (self rangeProgress: now).

	super doStep: now.
! !

!SWTRangeEffect methodsFor: 'private' stamp: 'dgd 6/7/2007 09:24'!
getWidgetRange
	"Answer the property of the receiver's widget"

	^self subclassResponsibility! !

!SWTRangeEffect methodsFor: 'initialization' stamp: 'dgd 6/7/2007 08:48'!
initializeFrom: fromObject 
	from := fromObject! !

!SWTRangeEffect methodsFor: 'initialization' stamp: 'dgd 6/7/2007 08:48'!
initializeTo: toObject 
	to := toObject! !

!SWTRangeEffect methodsFor: 'printing' stamp: 'dgd 6/7/2007 09:34'!
printOn: aStream 
	"Append to the argument, aStream, a sequence of characters  
	that identifies the receiver."

	super printOn: aStream. 
	aStream
		nextPutAll: ' (';
		nextPutAll: from asString;
		nextPutAll: ' --> ';
		nextPutAll: to asString;
		nextPutAll: ')'.
! !

!SWTRangeEffect methodsFor: 'private' stamp: 'dgd 10/21/2007 14:55'!
rangeProgress: now

	| result pro |

	pro := self currentProgress: now.

	result := from + ((to - from) * pro).

	^ result.
! !

!SWTRangeEffect methodsFor: 'private' stamp: 'dgd 6/7/2007 09:24'!
setWidgetRange: currentObject 
	"Make the apropiate change in the receiver's widget"

	^self subclassResponsibility! !

!SWTRangeEffect methodsFor: 'running' stamp: 'dgd 6/7/2007 09:26'!
start

	from isNil
		inlineIfTrue:[ from := self getWidgetRange ].
	to isNil
		inlineIfTrue:[ to := self getWidgetRange ].

	super start.

	self setWidgetRange: from! !

!SWTRangeEffect methodsFor: 'running' stamp: 'dgd 6/7/2007 09:24'!
stop
	"The effect is stoping (and probably the last steps was not executed), so make the 'final' actions to ensure the object is in a valid shape"

	self setWidgetRange: to.
	super stop! !

S2SObject subclass: #SWTAbstractModel
	instanceVariableNames: 'asp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC'!

!SWTAbstractModel methodsFor: 'accessing' stamp: 'dgd 10/24/2006 17:10'!
aspectNamed: aString
	^ self aspects detect:[:each | each name = aString]! !

!SWTAbstractModel methodsFor: 'accessing' stamp: 'dgd 10/31/2007 14:41'!
aspects
	^ asp! !

!SWTAbstractModel methodsFor: 'views' stamp: 'dgd 10/31/2007 12:21'!
defaultView

	| baseColor view |

	baseColor := Color green muchLighter.

	view := SWTColumnPanel new.
	view
		model: self;
		backgroundColor: baseColor "darker";
		cellPadding: 2.

	self aspects do:[:eachAspect |
		| aspWidget |

		aspWidget := eachAspect defaultView.
		aspWidget defaultBackgroundColor: view backgroundColor.

		view
			addWidget: aspWidget
			label: eachAspect name.
	].

	^ view.
! !

!SWTAbstractModel methodsFor: 'printing' stamp: 'dgd 11/5/2007 16:18'!
printOn: aStream
	super printOn: aStream.

	self jsInSmalltalk: [^ self].

	asp isNil inlineIfFalse:[
		aStream nextPutAll: ' asp:'.
		"aStream nextPutAll: aspects  asString."
		aStream nextPutAll: (asp collect:[:each | each name]) asString.
	].
! !

!SWTAbstractModel methodsFor: 'accessing' stamp: 'dgd 10/9/2007 14:47'!
valueOfAspectNamed: aString
	^ (self aspectNamed: aString) value! !

!SWTAbstractModel methodsFor: 'events' stamp: 'dgd 10/25/2007 13:53'!
when: eventNameSymbol send: selector to: anObject withResultsOfSelectors: selectorsCollection eventCount: eventCount onConflictSend: onConflictSelector
	self subclassResponsibility! !

SWTAbstractModel subclass: #SWTModel
	instanceVariableNames: 'events eventsCounterMutex eventsCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC'!

!SWTModel class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 10/24/2006 18:02'!
jsClassesToInclude

	| result |
	
	result := Set new.

	result addAll: SWTAspect withAllSubclasses.
	result add: SWTRemoteModel.
	result add: SWTMessageSend.

	^ result
! !

!SWTModel methodsFor: 'accessing' stamp: 'dgd 11/15/2006 13:01'!
allInstVarNamesForAspects

	^  self allInstVarNames copyWithoutAll: self excludedInstVarNamesForAspects! !

!SWTModel methodsFor: 'accessing' stamp: 'dgd 10/31/2007 14:42'!
aspects
	"Answer the receiver's aspects"
	^ asp ifNil:[asp := self defaultAspects]! !

!SWTModel methodsFor: 'private' stamp: 'dgd 10/22/2007 19:19'!
countOfTriggeredEvent: eventNameSymbol

	| count |

	eventsCounterMutex critical:[
		count := eventsCounter isNil
								ifTrue:[ 0 ]
								ifFalse: [ count := eventsCounter at: eventNameSymbol ifAbsent:[0] ].
	].

	^ count! !

!SWTModel methodsFor: 'accessing' stamp: 'dgd 10/26/2007 13:55'!
defaultAspects
	"Anwer the default collections of aspects"

	| result selectors |

	result := OrderedCollection new.

	selectors := self allSelectors.

	self allInstVarNamesForAspects
		collect:[:each | self jsLiteral: 'each.allButFirst()' inSmalltalk:[each asSymbol] ]
		thenDo:[:each |
			(selectors includes: each) ifTrue: [
				| aspect |

self flag: #todo. "aspect dependiendo la clase, para colecciones".

				aspect := SWTAspect named: each model: self.
				(selectors includes: each asMutator) ifTrue:[
					aspect beReadWrite.
				].

				result add: aspect.
			].
		].

	^ result.
! !

!SWTModel methodsFor: 'accessing' stamp: 'dgd 11/15/2006 13:01'!
excludedInstVarNamesForAspects

	^  #('aspects' 'modelId' 'events')! !

!SWTModel methodsFor: 'initialization' stamp: 'dgd 10/22/2007 19:14'!
initialize

	super initialize.

	eventsCounterMutex := Semaphore forMutualExclusion.
! !

!SWTModel methodsFor: '- only smalltalk - serialization' stamp: 'dgd 10/24/2007 17:27'!
jsObjectToSerializeContext: aServerApplication 

	| remoteId |

	remoteId := aServerApplication idFor: self.

	^ self remoteModelClass
				remoteId: remoteId
				aspects: self aspects.
! !

!SWTModel methodsFor: 'private' stamp: 'dgd 11/6/2007 11:14'!
noteTriggeredEvent: eventNameSymbol
	"PRIVATE - keep the counters on event triggering, used in versioning"

	| newCount eventsToAvoid |

	"this events depends on the versioning counting of #modelChanged:,
	no need to keep statistics about them  -- dgd"
	eventsToAvoid := #(#addedElement #removedElement).
	(eventsToAvoid includes: eventNameSymbol) ifTrue:[
		^ self.
	].

	eventsCounterMutex critical:[
		eventsCounter isNil ifTrue:[
			eventsCounter := Dictionary new.
		].

		newCount := (eventsCounter at: eventNameSymbol ifAbsent:[0]) + 1.
		eventsCounter at: eventNameSymbol put: newCount.
	].

	^ newCount.
! !

!SWTModel methodsFor: '- only smalltalk - serialization' stamp: 'dgd 10/17/2006 12:51'!
remoteModelClass
	^ SWTRemoteModel! !

!SWTModel methodsFor: 'events' stamp: 'dgd 11/6/2007 11:02'!
removeActionsWithReceiver: anObject
	| newEvents |

	self jsInSmalltalk: [^ super removeActionsWithReceiver: anObject].

	events isNil ifTrue: [
		^ self.
	].

	newEvents := Dictionary new.

	events keysAndValuesDo: [:eventName :handlers |
		| newHandlers |

		newHandlers := handlers reject:[:each | each receiver = anObject].

		newHandlers isEmpty ifFalse:[
			newEvents at: eventName put: newHandlers.
		].
	].

	events := newEvents isEmpty
								ifTrue: [ nil ]
								ifFalse: [ newEvents ].
! !

!SWTModel methodsFor: 'events' stamp: 'dgd 11/6/2007 11:05'!
triggerEvent: eventNameSymbol

	self
		triggerEvent: eventNameSymbol
		withArguments: {}.
! !

!SWTModel methodsFor: 'events' stamp: 'dgd 11/6/2007 11:03'!
triggerEvent: eventNameSymbol withArguments: anArgumentList

	| handlers |

	(anArgumentList size > 3) ifTrue:[
		^ self error: 'distributed mvc supports only events with up to 3 arguments'.
	].

	self noteTriggeredEvent: eventNameSymbol.

	self jsInSmalltalk: [
		^ super triggerEvent: eventNameSymbol withArguments: anArgumentList.
	].

	events isNil ifTrue:[
		^ self
	].

	handlers := events
						at: eventNameSymbol
						ifAbsent:[^ self].

	handlers do:[:each | each valueWithArguments: anArgumentList].
! !

!SWTModel methodsFor: 'events' stamp: 'dgd 11/2/2007 16:30'!
triggerEvent: eventNameSymbol with: anObject

   ^self 
		triggerEvent: eventNameSymbol
		withArguments: { anObject }! !

!SWTModel methodsFor: 'events' stamp: 'dgd 10/24/2006 17:02'!
when: eventNameSymbol evaluate: aBlock

	| blocks |

	self jsInSmalltalk: [^ super when: eventNameSymbol evaluate: aBlock].

	events isNil ifTrue:[
		events := Dictionary new.
	].

	blocks := events
					at: eventNameSymbol
					ifAbsentPut:[OrderedCollection new].

	blocks add: aBlock.
! !

!SWTModel methodsFor: 'events' stamp: 'dgd 10/24/2006 17:02'!
when: eventNameSymbol send: selector to: anObject

	self jsInSmalltalk: [^ super when: eventNameSymbol send: selector to: anObject].

	self
		when: eventNameSymbol
		evaluate: (SWTMessageSend receiver: anObject selector: selector).
! !

!SWTModel methodsFor: 'events' stamp: 'dgd 10/25/2007 13:53'!
when: eventNameSymbol send: selector to: receiver withResultsOfSelectors: selectorsCollection eventCount: eventCount onConflictSend: onConflictSelector

self flag: #todo. "check this implementation with a model on the client side."

	self
		when: eventNameSymbol
		evaluate: [
			receiver
				perform: selector
				withArguments: (selectorsCollection collect:[:eachSelector | self perform: eachSelector]).
		].
! !

SWTModel subclass: #SWTOrderedCollection
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC'!

!SWTOrderedCollection class methodsFor: 'instance creation' stamp: 'dgd 11/2/2007 16:46'!
withAll: anOrderedCollection 
	^ self new initializeCollection: anOrderedCollection ! !

!SWTOrderedCollection methodsFor: 'adding' stamp: 'dgd 11/10/2007 13:29'!
addLast: newObject 
	"Add newObject to the end of the receiver. Answer newObject."

	collection addLast: newObject.
"	newPos := collection size."

	"updates the #modelChanged: counter as this event will be not fired, but the versioning uses this number to detect conflicts"
	self noteTriggeredEvent: #modelChanged:.
	self
		triggerEvent: #addedElement
		withArguments: { newObject. nil }.

	^ newObject
! !

!SWTOrderedCollection methodsFor: 'adding' stamp: 'dgd 11/2/2007 15:56'!
add: newObject 
	"Add newObject to the end of the receiver. Answer newObject."

	^ self addLast: newObject! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:39'!
allButFirst
	^ self class withAll: collection allButFirst! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:39'!
allButLast
	^ self class withAll: collection allButLast! !

!SWTOrderedCollection methodsFor: 'enumerating' stamp: 'dgd 11/2/2007 17:47'!
allSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for any element return false.
	Otherwise return true."

	^ collection allSatisfy: aBlock! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:53'!
anyOne
	^ collection anyOne! !

!SWTOrderedCollection methodsFor: 'enumerating' stamp: 'dgd 11/2/2007 17:48'!
anySatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns true for any element return true.
	Otherwise return false."

	^ collection anySatisfy: aBlock! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:31'!
at: anInteger 
	^ collection at: anInteger ! !

!SWTOrderedCollection methodsFor: 'private' stamp: 'dgd 11/5/2007 16:43'!
collection
	"private - only to be used from the aspect"

	^ collection! !

!SWTOrderedCollection methodsFor: 'enumerating' stamp: 'dgd 11/2/2007 17:49'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	^ self class withAll: (collection collect: aBlock)! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/5/2007 17:02'!
defaultAspects
	^ {SWTArrayAspect named: #collection model: self}! !

!SWTOrderedCollection methodsFor: 'enumerating' stamp: 'dgd 11/2/2007 17:49'!
detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ collection detect: aBlock! !

!SWTOrderedCollection methodsFor: 'enumerating' stamp: 'dgd 11/2/2007 17:50'!
detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	^ collection detect: aBlock ifNone: exceptionBlock ! !

!SWTOrderedCollection methodsFor: 'enumerating' stamp: 'dgd 11/2/2007 17:50'!
do: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument."

	^ collection do: aBlock.
! !

!SWTOrderedCollection methodsFor: 'private' stamp: 'dgd 11/2/2007 16:47'!
errorNotFound: anObject
	"Actually, this should raise a special Exception not just an error."

	self error: 'Object is not in the collection.'! !

!SWTOrderedCollection methodsFor: 'private' stamp: 'dgd 11/5/2007 16:30'!
errorOutOfBounds

	self error: 'indices are out of bounds'! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:32'!
first
	^ collection first! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:39'!
first: n
	^ self class withAll: (collection first: n)! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:35'!
fourth
	^ collection fourth! !

!SWTOrderedCollection methodsFor: 'initialization' stamp: 'dgd 11/2/2007 15:54'!
initialize

	super initialize.

	collection := OrderedCollection new.
! !

!SWTOrderedCollection methodsFor: 'initialization' stamp: 'dgd 11/2/2007 16:52'!
initializeCollection: anOrderedCollection 

	(anOrderedCollection isKindOf: SequenceableCollection) ifFalse:[
		^ self error: 'invalid collection type'.
	].

	collection := anOrderedCollection asOrderedCollection.
! !

!SWTOrderedCollection methodsFor: 'testing' stamp: 'dgd 11/2/2007 17:27'!
isEmpty
	^ collection isEmpty! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:32'!
last
	^ collection last! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:40'!
last: n
	^ self class withAll: (collection last: n)! !

!SWTOrderedCollection methodsFor: 'printing' stamp: 'dgd 11/5/2007 16:22'!
printOn: aStream
	aStream nextPutAll: 'SWT {'.

	collection
		do:[:each | aStream print: each]
		separatedBy:[aStream nextPutAll: '. '].

	aStream nextPutAll: '}'.
! !

!SWTOrderedCollection methodsFor: 'removing' stamp: 'dgd 11/2/2007 16:47'!
remove: oldObject 
	"Remove oldObject from the receiver's elements. Answer oldObject 
	unless no element is equal to oldObject, in which case, raise an error.
	ArrayedCollections cannot respond to this message."

	^ self remove: oldObject ifAbsent: [self errorNotFound: oldObject]! !

!SWTOrderedCollection methodsFor: 'removing' stamp: 'dgd 11/6/2007 11:04'!
remove: oldObject ifAbsent: exceptionBlock 
	"Remove oldObject from the receiver's elements. If several of the 
	elements are equal to oldObject, only one is removed. If no element is 
	equal to oldObject, answer the result of evaluating anExceptionBlock. 
	Otherwise, answer the argument, oldObject. ArrayedCollections cannot 
	respond to this message."

	| oldPos |

	oldPos := collection
					indexOf: oldObject
					ifAbsent: [ ^ exceptionBlock value ].

	collection remove: oldObject.

	"updates the #modelChanged: counter as this event will be not fired, but the versioning uses this number to detect conflicts"
	self noteTriggeredEvent: #modelChanged:.
	self
		triggerEvent: #removedElement
		with: oldPos.

	^ oldObject.
! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:32'!
second
	^ collection second! !

!SWTOrderedCollection methodsFor: 'enumerating' stamp: 'dgd 11/2/2007 17:50'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	^ collection select: aBlock! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:27'!
size
	^ collection size! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/5/2007 16:30'!
theOnlyOne
	self size = 1 ifFalse:[^ self errorOutOfBounds].
	^ self anyOne! !

!SWTOrderedCollection methodsFor: 'accessing' stamp: 'dgd 11/2/2007 17:32'!
third
	^ collection third! !

SWTModel subclass: #SWTSampleModel
	instanceVariableNames: 'foo bar yesNo list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-MVC'!

!SWTSampleModel methodsFor: 'accessing' stamp: 'dgd 10/15/2006 16:12'!
bar
	^ bar! !

!SWTSampleModel methodsFor: 'accessing' stamp: 'dgd 10/16/2006 17:20'!
bar: anObject

	(bar = anObject)
		ifTrue:[^ self].

	bar := anObject.

	self triggerEvent: #bar.
! !

!SWTSampleModel methodsFor: 'accessing' stamp: 'dgd 10/15/2006 16:10'!
foo
	^ foo! !

!SWTSampleModel methodsFor: 'initialization' stamp: 'dgd 11/23/2006 14:49'!
initialize
	super initialize.

	foo := 'Read Only String'.
	bar := 'ReadWrite String'.
	yesNo := false.
	list := OrderedCollection with: 'item 1' with: 'item 2'! !

!SWTSampleModel methodsFor: 'accessing' stamp: 'dgd 11/23/2006 14:49'!
list
	^ list! !

!SWTSampleModel methodsFor: 'accessing' stamp: 'dgd 10/25/2006 16:42'!
yesNo
	^ yesNo! !

!SWTSampleModel methodsFor: 'accessing' stamp: 'dgd 10/25/2006 17:10'!
yesNo: aBoolean
	yesNo := aBoolean.

	self triggerEvent: #yesNo.
! !

SWTAbstractModel subclass: #SWTRemoteModel
	instanceVariableNames: 'remoteId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC'!

!SWTRemoteModel class methodsFor: 'instance creation' stamp: 'dgd 10/31/2007 14:05'!
remoteId: anInteger
	"private - to be used in serialization"
	^ self remoteId: anInteger aspects: nil! !

!SWTRemoteModel class methodsFor: 'instance creation' stamp: 'dgd 10/15/2006 19:51'!
remoteId: anInteger aspects: aspectsCollection
	^ self new initializeRemoteId: anInteger aspects: aspectsCollection! !

!SWTRemoteModel methodsFor: 'initialization' stamp: 'dgd 10/31/2007 14:42'!
initializeRemoteId: anInteger aspects: aspectsCollection

	remoteId := anInteger.

	asp := aspectsCollection.
"
	aspects do:[:each | each setModel: self].
"! !

!SWTRemoteModel methodsFor: 'message handling' stamp: 'dgd 10/15/2006 20:30'!
perform: selector
	^ self serverSide
				modelId: remoteId
				perform: selector.! !

!SWTRemoteModel methodsFor: 'message handling' stamp: 'dgd 10/10/2007 15:45'!
perform: selector with: anObject
	^ self serverSide
"async"		modelId: remoteId
				perform: selector
				with: anObject.! !

!SWTRemoteModel methodsFor: 'printing' stamp: 'dgd 10/26/2007 13:32'!
printOn: aStream
	aStream nextPutAll:' remoteId:' , remoteId asString ,', '.

	super printOn: aStream.

! !

!SWTRemoteModel methodsFor: 'accessing' stamp: 'dgd 10/10/2007 15:59'!
remoteId
	^ remoteId! !

!SWTRemoteModel methodsFor: 'events' stamp: 'dgd 11/3/2007 12:33'!
removeActionsWithReceiver: anObject

	self application unregisterModel: anObject.

	self serverSide asyncMode: [
"
		self serverSide
				modelId: remoteId
				removeActionsWithJsReceiverId: anObject id.
"
		self serverSide
				mId: remoteId
				rAWRId: anObject id.
	].
! !

!SWTRemoteModel methodsFor: 'private' stamp: 'dgd 10/16/2006 15:22'!
serverSide
	^ self application serverSide! !

!SWTRemoteModel methodsFor: 'events' stamp: 'dgd 10/25/2007 13:51'!
when: eventNameSymbol send: selector to: anObject

	self
		when: eventNameSymbol
		send: selector
		to: anObject
		withResultsOfSelectors: nil
		eventCount: nil
		onConflictSend: nil! !

!SWTRemoteModel methodsFor: 'events' stamp: 'dgd 11/3/2007 12:41'!
when: eventNameSymbol send: selector to: anObject withResultsOfSelectors: selectorsCollection eventCount: eventCount onConflictSend: onConflictSelector

	self application registerModel: anObject.

	self serverSide asyncMode: [
"
			self serverSide
						modelId: remoteId
						when: eventNameSymbol
						send: selector
						toJsObjectId: anObject id
						withResultsOfSelectors: selectorsCollection
						eventCount: eventCount
						onConflictSend: onConflictSelector
"
			self serverSide
						mId: remoteId
						w: eventNameSymbol
						s: selector
						tOId: anObject id
						wRS: selectorsCollection
						eC: eventCount
						oCS: onConflictSelector

	].! !

!SWTRemoteModel methodsFor: 'comparing' stamp: 'dgd 10/18/2007 10:11'!
= aRemoteModel
	^ (self class = aRemoteModel class)
			and: [self remoteId = aRemoteModel remoteId]! !

S2SObject subclass: #SWTAspect
	instanceVariableNames: 'name model getter setter eventName getterForEdit readOnly isConnectedToModel cached onChange changeEventCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC'!

SWTAspect subclass: #SWTArrayAspect
	instanceVariableNames: 'onAddedElement onRemovedElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC'!

!SWTArrayAspect class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 11/5/2007 17:02'!
jsPreSource
	^ '
function _oca(nameSymbol, readOnlyBoolean, eventCount) {
	return ST.SWTArrayAspect.name_readOnly_eventCount_(nameSymbol, readOnlyBoolean, eventCount);
}
'! !

!SWTArrayAspect methodsFor: 'events' stamp: 'dgd 11/10/2007 13:32'!
addedElement: newElement at: newPosition

"	self log: self asString , ': new element (' , newElement asString , ') at ' , newPosition asString."

	newPosition isNil ifTrue:[
			cached add: newElement.
		]
		ifFalse:[
			cached add: newElement beforeIndex: newPosition.

			self flag: #todo.
			self logError: 'check this implementation'.
		].

	onAddedElement isNil inlineIfTrue: [
		^ self
	].

	onAddedElement inlineDo:[:each | each value: newElement value: newPosition].
! !

!SWTArrayAspect methodsFor: 'events' stamp: 'dgd 11/5/2007 18:44'!
connectToModel

	super connectToModel.

	self model
			when: #addedElement
			send: #addedElement:at:
			to: self
			withResultsOfSelectors: nil
			eventCount: nil
			onConflictSend: nil.

	self model
			when: #removedElement
			send: #removedElement:
			to: self
			withResultsOfSelectors: nil
			eventCount: nil
			onConflictSend: nil.
! !

!SWTArrayAspect methodsFor: 'views' stamp: 'dgd 11/6/2007 09:04'!
defaultView

	| viewClass view |

	viewClass := self value defaultViewClassForArray.

	view := viewClass forArrayAspect: self.

	^ view! !

!SWTArrayAspect methodsFor: '- only smalltalk - serialization' stamp: 'dgd 11/6/2007 09:22'!
jsInstanciateOn: aStream

	aStream nextPutAll: '_oca('.
	name jsInstanciateOn: aStream.
	aStream nextPutAll: ','.
	readOnly jsInstanciateOn: aStream.
	aStream nextPutAll: ','.
	changeEventCount jsInstanciateOn: aStream.
	aStream nextPutAll: ')'.
! !

!SWTArrayAspect methodsFor: '- only smalltalk - serialization' stamp: 'dgd 11/5/2007 18:42'!
jsInstVarNamesToSerialize
	^ super jsInstVarNamesToSerialize copyWithoutAll: #('onAddedElement' 'onRemovedElement')
! !

!SWTArrayAspect methodsFor: 'private' stamp: 'dgd 11/5/2007 19:01'!
needsSubscriptionToModel
	"Answer if the receiver is subscribed to changes in model"

	^ super needsSubscriptionToModel
			or: [ onAddedElement notNil and:[onAddedElement notEmpty] ]
			or: [ onAddedElement notNil and:[onAddedElement notEmpty] ].
! !

!SWTArrayAspect methodsFor: 'events' stamp: 'dgd 11/5/2007 18:56'!
onAddedElementSend: selector to: receiver
	"registers a block, to evaluate, when onAddedElement event occurs"

	model isNil inlineIfTrue:[
		^ self error: 'The receiver has not model'.
	].

	"is very first handler?"
	onAddedElement isNil inlineIfTrue: [
		onAddedElement := OrderedCollection new.

		self ensureConnectionToModel.
	].

	onAddedElement add: (SWTMessageSend receiver: receiver selector: selector).
! !

!SWTArrayAspect methodsFor: 'events' stamp: 'dgd 11/5/2007 18:56'!
onRemovedElementSend: selector to: receiver
	"registers a block, to evaluate, when onRemovedElement event occurs"

	model isNil inlineIfTrue:[
		^ self error: 'The receiver has not model'.
	].

	"is very first handler?"
	onRemovedElement isNil inlineIfTrue: [
		onRemovedElement := OrderedCollection new.

		self ensureConnectionToModel.
	].

	onRemovedElement add: (SWTMessageSend receiver: receiver selector: selector).
! !

!SWTArrayAspect methodsFor: 'events' stamp: 'dgd 11/5/2007 19:02'!
removeActionsWithReceiver: anObject

	super removeActionsWithReceiver: anObject.

	onAddedElement isNil inlineIfFalse:[
		onAddedElement := onAddedElement reject:[:each | each receiver = anObject].

		onAddedElement isEmpty inlineIfTrue:[
			onAddedElement := nil.
		].
	].

	onRemovedElement isNil inlineIfFalse:[
		onRemovedElement := onRemovedElement reject:[:each | each receiver = anObject].

		onRemovedElement isEmpty inlineIfTrue:[
			onRemovedElement := nil.
		].
	].

	self needsSubscriptionToModel inlineIfFalse:[
		cached := nil.
		self model removeActionsWithReceiver: self.
	].
! !

!SWTArrayAspect methodsFor: 'events' stamp: 'dgd 11/5/2007 19:25'!
removedElement: oldPosition

"	self log: self asString , ': removed element at at ' , oldPosition asString."

	cached removeIndex: oldPosition.

	onRemovedElement isNil inlineIfTrue: [
		^ self
	].

	onRemovedElement inlineDo:[:each | each value: oldPosition].
! !

!SWTAspect class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 11/5/2007 16:46'!
jsPreSource
	^ '
function _a(nameSymbol, readOnlyBoolean, eventCount) {
	return ST.SWTAspect.name_readOnly_eventCount_(nameSymbol, readOnlyBoolean, eventCount);
}
'! !

!SWTAspect class methodsFor: 'instance creation' stamp: 'dgd 10/24/2006 19:07'!
named: nameSymbol model: anObject
	"Answer a new instance of the receiver"
	^ self named: nameSymbol model: anObject eventName: nil! !

!SWTAspect class methodsFor: 'instance creation' stamp: 'dgd 10/24/2006 19:07'!
named: nameSymbol model: anObject eventName: eventSymbol
	"Answer a new instance of the receiver"
	^ self new initializeName: nameSymbol model: anObject eventName: eventSymbol! !

!SWTAspect class methodsFor: 'instance creation' stamp: 'dgd 10/24/2007 16:44'!
name: nameSymbol model: anObject getter: getterSymbol setter: setterSymbol getterForEdit: getterForEditSymbol eventName: eventNameSymbol readOnly: readOnlyBoolean cachedValue: valueObject eventCount: eventCount

	^ self new
			initializeName: nameSymbol
				model: anObject
				getter: getterSymbol
				setter: setterSymbol
				getterForEdit: getterForEditSymbol
				eventName: eventNameSymbol
				readOnly: readOnlyBoolean
				cachedValue: valueObject
				eventCount: eventCount.
! !

!SWTAspect class methodsFor: 'instance creation' stamp: 'dgd 10/31/2007 13:51'!
name: nameSymbol readOnly: readOnlyBoolean eventCount: eventCount

	"private - to be used from the serialization mechanism"

	^ self
			name: nameSymbol
			model: nil
			getter: nil
			setter: nil
			getterForEdit: nil
			eventName: nil
			readOnly: readOnlyBoolean
			cachedValue: nil
			eventCount: eventCount.
! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/15/2006 15:53'!
beReadOnly
	"Change the receiver to be read-only"
	readOnly := true.! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/15/2006 15:53'!
beReadWrite
	"Change the receiver to be read-white"
	readOnly := false! !

!SWTAspect methodsFor: 'events' stamp: 'dgd 11/6/2007 11:19'!
conflict: newValueObject

	(cached = newValueObject) inlineIfFalse:[
		self modelChanged: newValueObject.
	].! !

!SWTAspect methodsFor: 'events' stamp: 'dgd 11/6/2007 11:19'!
connectToModel

	self model
			when: self eventName
			send: #modelChanged:
			to: self
			withResultsOfSelectors: { self getter }
			eventCount: changeEventCount
			onConflictSend: #conflict:.
! !

!SWTAspect methodsFor: 'views' stamp: 'dgd 10/27/2007 19:04'!
defaultView

	| viewClass view |

	viewClass := self value defaultViewClass.

	view := viewClass forAspect: self.

	^ view! !

!SWTAspect methodsFor: 'events' stamp: 'dgd 11/5/2007 18:55'!
ensureConnectionToModel

	isConnectedToModel inlineIfTrue:[^ self].
	isConnectedToModel := true.
	self connectToModel.! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/15/2006 15:45'!
eventName
	"Answer the receiver's eventName"
	^ eventName ifNil: [self name]! !

!SWTAspect methodsFor: 'evaluating' stamp: 'dgd 10/31/2007 14:42'!
freshValue
	"Evaluate the receiver"

	cached := nil. "invalidate the cache, force fresh value from model"

	^ self value
! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/15/2006 15:45'!
getter
	"Answer the receiver's getter"
	^ getter ifNil: [self name]! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/17/2006 13:28'!
getterForEdit
	"Answer the receiver's getterForEdit"
	^ getterForEdit ifNil: [self getter]! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/17/2006 13:28'!
getterForEdit: aSymbol
	"Change the receiver's getterForEdit"
	getterForEdit := aSymbol.
! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/15/2006 15:55'!
getter: aSymbol
	"Change the receiver's getter"
	getter := aSymbol.
! !

!SWTAspect methodsFor: 'initialization' stamp: 'dgd 11/5/2007 18:55'!
initialize
	"Initialize the receiver"
	super initialize.

	readOnly := true.
	isConnectedToModel := false.
! !

!SWTAspect methodsFor: 'initialization' stamp: 'dgd 10/24/2006 19:34'!
initializeName: nameSymbol model: anObject eventName: eventSymbol
	"Initialize the receiver's name, model and eventName in a shot"

	name := nameSymbol.
	model := anObject.
	eventName := eventSymbol.
! !

!SWTAspect methodsFor: 'private' stamp: 'dgd 11/6/2007 09:22'!
initializeName: nameSymbol model: anObject getter: getterSymbol setter: setterSymbol getterForEdit: getterForEditSymbol eventName: eventNameSymbol readOnly: readOnlyBoolean cachedValue: valueObject eventCount: eventCountInteger

	name := nameSymbol.
	model := anObject.
	getter := getterSymbol.
	setter := setterSymbol.
	getterForEdit := getterForEditSymbol.
	eventName := eventNameSymbol.
	readOnly := readOnlyBoolean.
	cached := valueObject.
	changeEventCount := eventCountInteger.
! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/15/2006 15:51'!
isReadOnly
	"Answer if the receiver's is read only"
	^ readOnly! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/15/2006 16:01'!
isReadWrite
	"Answer if the receiver's is read-write"
	^ self isReadOnly not! !

!SWTAspect methodsFor: 'private' stamp: 'dgd 11/5/2007 18:57'!
isSubscribedToModel
	"Answer if the receiver is subscribed to changes in model"

	^ isConnectedToModel! !

!SWTAspect methodsFor: '- only smalltalk - serialization' stamp: 'dgd 11/6/2007 09:22'!
jsInstanciateOn: aStream

	aStream nextPutAll: '_a('.
	name jsInstanciateOn: aStream.
	aStream nextPutAll: ','.
	readOnly jsInstanciateOn: aStream.
	aStream nextPutAll: ','.
	changeEventCount jsInstanciateOn: aStream.
	aStream nextPutAll: ')'.
! !

!SWTAspect methodsFor: '- only smalltalk - serialization' stamp: 'dgd 11/6/2007 09:23'!
jsInstVarNamesToSerialize
	^ super jsInstVarNamesToSerialize copyWithoutAll: #('onChange' 'name' 'readOnly' 'changeEventCount' 'isConnectedToModel')
! !

!SWTAspect methodsFor: '- only smalltalk - serialization' stamp: 'dgd 10/24/2007 17:21'!
jsObjectToSerializeContext: contextObject

	| freshValue freshEventCount |

	freshValue := self freshValue.
	freshEventCount := model countOfTriggeredEvent: self eventName.

	^ self class 
			name: name
			model: model
			getter: getter
			setter: setter
			getterForEdit: getterForEdit
			eventName: eventName
			readOnly: readOnly
			cachedValue: freshValue
			eventCount: freshEventCount.
! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/24/2006 18:04'!
model
	"Answer the receiver's model"
	^ model! !

!SWTAspect methodsFor: 'events' stamp: 'dgd 11/6/2007 09:22'!
modelChanged: newValueObject
	"The model has changed, update the cachedValue and propagates the events"
	
	| val |

	cached := newValueObject.
	changeEventCount := nil.

	onChange isNil inlineIfTrue: [
		^ self
	].

	val := self value.
	onChange inlineDo:[:each | each value: val].
! !

!SWTAspect methodsFor: 'evaluating' stamp: 'dgd 10/24/2006 18:09'!
modelValue
	"Evaluate the receiver"

	^ self model perform: self getter
! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/15/2006 15:45'!
name
	"Answer the receiver's name"
	^ name! !

!SWTAspect methodsFor: 'private' stamp: 'dgd 11/5/2007 19:01'!
needsSubscriptionToModel
	"Answer if the receiver is subscribed to changes in model"

	^ onChange notNil and:[onChange notEmpty].! !

!SWTAspect methodsFor: 'events' stamp: 'dgd 11/5/2007 18:56'!
onChangeSend: selector to: receiver
	"registers a block, to evaluate, when onChange event occurs"

	model isNil inlineIfTrue:[
		^ self error: 'The receiver has not model'.
	].

	"is very first handler?"
	onChange isNil inlineIfTrue: [
		onChange := OrderedCollection new.

		self ensureConnectionToModel.
	].

	onChange add: (SWTMessageSend receiver: receiver selector: selector).
! !

!SWTAspect methodsFor: 'printing' stamp: 'dgd 11/6/2007 09:23'!
printOn: aStream
	super printOn: aStream.

	aStream nextPutAll: ' name:'.
	aStream nextPutAll: name asString.

	aStream nextPutAll: ' model:('.
	self model printOn: aStream.
	aStream nextPutAll: ')'.

	aStream nextPutAll: (self isReadOnly ifTrue:[', ReadOnly'] ifFalse:[', Read-Write']).

	cached isNil ifFalse:[
		aStream nextPutAll: ', cachedValue:('.
		aStream nextPutAll: cached asString.
		aStream nextPutAll: ')'.
	].

	changeEventCount isNil ifFalse:[
		aStream nextPutAll: ', eventCount:'.
		aStream nextPutAll: changeEventCount asString.
	].
! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/15/2006 19:52'!
readOnly: aBoolean
	"Change the receiver to be read-only"
	readOnly := aBoolean.! !

!SWTAspect methodsFor: 'events' stamp: 'dgd 11/5/2007 19:02'!
removeActionsWithReceiver: anObject

	self jsInSmalltalk: [
		super removeActionsWithReceiver: anObject
	].

	model isNil inlineIfTrue:[
		^ self error: 'The receiver has not model'.
	].

	onChange isNil inlineIfFalse: [

		onChange := onChange reject:[:each | each receiver = anObject].

		onChange isEmpty inlineIfTrue:[
			onChange := nil.
		].

		self needsSubscriptionToModel inlineIfFalse:[
			cached := nil.
			self model removeActionsWithReceiver: self.
		].
	].
! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/15/2006 16:19'!
setter
	"Answer the receiver's setter"
	^ setter ifNil: [self name asMutator]! !

!SWTAspect methodsFor: 'accessing' stamp: 'dgd 10/24/2006 19:24'!
setter: aSymbol
	"Change the receiver's setter"
	setter := aSymbol.
	setter isNil inlineIfFalse:[
		self beReadWrite.
	].! !

!SWTAspect methodsFor: 'evaluating' stamp: 'dgd 10/31/2007 14:43'!
value
	"Evaluate the receiver"

	^ cached ifNil: [
			| newValue |

			newValue := self modelValue.

			"If the receiver is connected to the model, the value can be cached cause the receiver will receive events when the model changes"
			self isSubscribedToModel ifTrue:[
				cached := newValue.
			].

			newValue
		].
! !

!SWTAspect methodsFor: 'evaluating' stamp: 'dgd 10/24/2006 19:25'!
valueForEdit

	getterForEdit isNil
			inlineIfTrue:[^ self value].
	
	^ self model perform: self getterForEdit.
! !

!SWTAspect methodsFor: 'evaluating' stamp: 'dgd 10/25/2006 13:33'!
value: anObject
	"Change the receiver's value"


	self isReadWrite inlineIfTrue:[
"		(anObject = self value) inlineIfFalse:["
			self model perform: self setter with: anObject.
"		]."
	].
! !

S2SObject subclass: #SWTCellMap
	instanceVariableNames: 'map position widget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Misc'!

!SWTCellMap class methodsFor: 'instance creation' stamp: 'dgd 12/12/2006 14:54'!
map: aMap position: aPoint
	^ self new initializeMap: aMap position: aPoint! !

!SWTCellMap methodsFor: 'events' stamp: 'dgd 12/13/2006 16:05'!
applicationJustConnected

	self widget src: self imageSrc.
! !

!SWTCellMap methodsFor: 'layouting' stamp: 'dgd 12/15/2006 11:25'!
calculatePosition

	| relPos |

	relPos := position - map positionFrom.

	^ (relPos * self extentForCells) + self relativePosition! !

!SWTCellMap methodsFor: 'private' stamp: 'dgd 12/13/2006 16:31'!
connectedImageSrc

	^ '/hook/map?listener_id=' , self application listenerId asString, '&x=' , position x asString , '&y=' , position y asString , '&z=' , map zoom asString.! !

!SWTCellMap methodsFor: 'private' stamp: 'dgd 12/15/2006 12:33'!
createWidget

	| cellWidget |

	cellWidget := SWTImage src: self imageSrc.

	cellWidget
		beAbsolute;
"		border: 1;"
		extent: self extentForCells.

	^ cellWidget.
! !

!SWTCellMap methodsFor: 'private' stamp: 'dgd 12/13/2006 15:01'!
disconnectedImageSrc

"	^ 'overlay.png'"
	^ 'blank.gif'
! !

!SWTCellMap methodsFor: 'layouting' stamp: 'dgd 12/12/2006 15:09'!
extentForCells
	^ map extentForCells! !

!SWTCellMap methodsFor: 'private' stamp: 'dgd 12/13/2006 16:06'!
imageSrc

	^ self isConnected
				ifTrue:[self connectedImageSrc]
				ifFalse:[self disconnectedImageSrc].! !

!SWTCellMap methodsFor: 'initialization' stamp: 'dgd 12/12/2006 14:55'!
initializeMap: aMap position: aPoint
	map := aMap.
	position := aPoint.! !

!SWTCellMap methodsFor: 'private' stamp: 'dgd 12/13/2006 16:06'!
isConnected
	^ self application notNil and:[self application isConnected]
! !

!SWTCellMap methodsFor: 'layouting' stamp: 'dgd 12/12/2006 15:15'!
layout
	self widget position: self calculatePosition! !

!SWTCellMap methodsFor: 'accessing' stamp: 'dgd 12/15/2006 11:00'!
position
	^ position! !

!SWTCellMap methodsFor: 'printing' stamp: 'dgd 12/15/2006 11:20'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: ' position:';
		print: position.
! !

!SWTCellMap methodsFor: 'layouting' stamp: 'dgd 12/12/2006 15:20'!
relativePosition
	^ map relativePosition! !

!SWTCellMap methodsFor: 'accessing' stamp: 'dgd 12/12/2006 15:21'!
widget
	widget isNil ifTrue:[
		widget := self createWidget.
		self layout.
	].

	^ widget! !

S2SObject subclass: #SWTClientApplication
	instanceVariableNames: 'listenerId rootWidget serverSide cometIFrame disconnectedStepCounter models asynchronousRPCQueue scheduler isStepping lastWhen busyCommand busyOverlay disconnectedOverlay lastRPCTimestamp lagStatistics rpcStatistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 10/31/2007 12:24'!
allJsClasses

	| allJsClasses |

	allJsClasses := Set new.

	self processClass: self on: allJsClasses.

	^ allJsClasses

"
CGMVCClientApplication allJsClasses size.
CGMVCClientApplication OLDallJsClasses size.

CGMVCClientApplication OLDallJsClasses removeAll: CGMVCClientApplication allJsClasses ; yourself.

S2STranslator instance allJsSourceFor: (CGMVCClientApplication OLDallJsClasses removeAll: CGMVCClientApplication allJsClasses ; yourself)
"
! !

!SWTClientApplication class methodsFor: 'configuration' stamp: 'dgd 9/1/2006 19:13'!
applicationName
	^ self name asString! !

!SWTClientApplication class methodsFor: 'configuration' stamp: 'dgd 11/28/2006 17:58'!
baseColor
	^ Color yellow muchLighter! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 11/9/2007 12:16'!
handMadeJavascriptSource

	| steps |

	steps := self javascriptSteps.

	^ '
<script type="text/javascript">
	document.writeln(''' , self handMadeProgress , ''');

	// No var, to use delete
	ExpectedLoadSteps = ' , steps asString , ';
	LoadStep = 0;

	// This sintax, to use delete
	setPercentAndMessage = function(message) {
		var percent = Math.min(LoadStep / ExpectedLoadSteps * 100, 100);

		var barW = document.getElementById("barW");
		var messageW = document.getElementById("messageW");

		barW.style.width = percent + "%";
		barW.innerHTML = "<font color=''white''><b>&nbsp;" + Math.round(percent) + "%</b></font>";

		var msg;
		msg = message + " (" + LoadStep + "/" + ExpectedLoadSteps + ")";
		messageW.innerHTML = msg;

		window.status = "Loading: " + Math.round(percent) + "%   - " + msg + "...";
	}

	setPercentAndMessage("");

	// This sintax, to use delete
	doLoadStep = function(name) {
		LoadStep++;

		setPercentAndMessage(name);
				
		if (LoadStep == ExpectedLoadSteps) {
			// cleanup the document
			document.body.innerHTML = '''';
			window.status = "";

			// removes initial objects, no more needed after loading.
			delete LoadStep;
			delete ExpectedLoadSteps;
			delete doLoadStep;
			delete setPercentAndMessage;
		}
	}
</script>

<script type="text/javascript">
	var app = null;

	function fullLoaded() {
		// Do something, all resources (including scripts) where loaded

		// Creates the app...
		app = ' , self jsClassName , '.__new__();

		// ...and let the party begins!!
		app.initializeApplication();
		app.connect();
	}

	function unload() {
		if (app) {
			app.finalize();
			app = null;
		}
	}

	function resized() {
		if (app) {
			app.resized();
		}
	}

	function scrolled() {
		if (app) {
			app.scrolled();
		}
	}
</script>
'! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 10/22/2007 16:47'!
handMadeProgress

	| stream color |

	color := self baseColor.

	stream := String new writeStream.

	stream nextPutAll: '<div style="padding: 10px; height: 100%; background-color: #' , color muchLighter asColorString , ';">'.
	stream nextPutAll: 	'<h2>', self applicationName , '</h2>'.
"	stream nextPutAll: 	'<br>'."
	stream nextPutAll: 	'<div style="position: relative; left: 20%; top: 20%; width: 60%; background-color: #' , color asColorString , '; border: 2px solid #' , color muchDarker asColorString , ';">'.
	stream nextPutAll: 		'<b>&nbsp;&nbsp;cargando...</b>'.
	stream nextPutAll: 		'<center>'.
	stream nextPutAll: 			'<img src="/resources/ajax-loader.gif" width="35" height="35">'.
	stream nextPutAll: 			'<i><b><font size="-1"><p id="messageW">message</p></font></b></i>'.
	stream nextPutAll: 		'</center>'.
	stream nextPutAll: 		'<div style="position: relative; left: 5%; width: 90%; background-color: #' , color muchLighter asColorString , '; border: 1px solid #' , color twiceLighter muchDarker muchDarker asColorString , ';">'.
	stream nextPutAll: 			'<div id="barW" style="width:0%; background-color: #' , color muchDarker asColorString , ';">'.
	stream nextPutAll: 				'-'.
	stream nextPutAll: 			'</div>'.
	stream nextPutAll: 		'</div>'.
	stream nextPutAll: 		'<p>&nbsp;</p>'.
	stream nextPutAll: 	'</div>'.
	stream nextPutAll: '</div>'.

	^ stream contents.

! !

!SWTClientApplication class methodsFor: '- only smalltalk - configuration' stamp: 'dgd 9/25/2006 15:26'!
headInclude
	^ ''! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 10/22/2007 15:47'!
htmlSourceWith: serverApplicationIncludeString

	^ '
<html>
	<head>
		<meta http-equiv="pragma"			content="no-cache">
		<meta http-equiv="cache-control"	content="no-cache, must-revalidate, no-store">
		<meta http-equiv="expires"			content="-1">

		<title>' , self applicationName , '</title>

		<style>
' , self htmlStyle withBlanksTrimmed , '
		</style>

<!!-- style type="text/css">
#soundmanager-debug {
 /* SM2 debug container (optional, makes debug more useable) */
 position:absolute;right:0px;top:0px;width:50em;height:18em;overflow:auto;background:#fff;margin:1em;padding:1em;border:1px solid #999;font-family:"lucida console",verdana,tahoma,"sans serif";font-size:x-small;line-height:1.5em;opacity:0.9;filter:alpha(opacity=90);
}
</style -->
<script type="text/javascript" src="/resources/soundmanager/script/soundmanager2.js"></script>
<script type="text/javascript">

soundManager.debugMode = false; // disable debug output

soundManager.url = "/resources/soundmanager/soundmanager2.swf";

soundManager.onload = function() {
	soundManager.createSound("intro", "/resources/soundmanager/demo/mpc/audio/AMB_HHOP.mp3");
	soundManager.play("intro");

	soundManager.createSound("click", "/resources/soundmanager/demo/button-0.mp3");
	soundManager.createSound("click2", "/resources/soundmanager/demo/button-1.mp3");
}

</script>

		<!!-- Canvas emulation for IE -->
		<!!--[if IE]><script src="/resources/excanvas.js" type="text/javascript"></script><!![endif]-->

		<!!-- client application include -->
' , self headInclude withBlanksTrimmed , '

		<!!-- hand made javascript source -->
' , self handMadeJavascriptSource withBlanksTrimmed , '

		<!!-- generated javascript source -->
' , self includeJavascriptSource withBlanksTrimmed , '

		<!!-- server application Include -->
' , serverApplicationIncludeString withBlanksTrimmed , '
	</head>

	<body onLoad="fullLoaded()" onUnload="unload()" onResize="resized()" onScroll="scrolled()">
		<span id="SoundSpan"></span>

	</body>
</html>
'! !

!SWTClientApplication class methodsFor: '- only smalltalk - configuration' stamp: 'dgd 11/7/2006 10:06'!
htmlStyle
	^ '
html {
	height: 100%;
	border: 0px;
}

body {
	height: 100%;
	margin: 0px;
	background-color: #FFFFFF;
	cursor: default;
}


.outerpair1 {
	background: url(resources/upperrightfade.png) right top no-repeat;
} 

.outerpair2 {
	background: url(resources/lowerleftfade.png) left bottom no-repeat;
	padding-top: 8px;
	padding-left: 8px;
}

.shadowbox {
	background: url(resources/shadow.png) bottom right;
}

.innerbox {
	position: relative;
	left: -8px;
	top: -8px;
}
'
! !

!SWTClientApplication class methodsFor: '- only smalltalk - configuration' stamp: 'dgd 6/7/2007 17:31'!
includeEmbeddedJavascript
	^ true! !

!SWTClientApplication class methodsFor: '- only smalltalk - configuration' stamp: 'dgd 9/1/2006 20:01'!
includeJavascriptInSteps
	^ true! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:16'!
includeJavascriptSource

	| stream |

	stream := String new writeStream.

	self includeJavascriptInSteps ifTrue:[
		| classes |

		stream nextPutAll: ('<!!-- Include JavaScript in {1} steps (__pre__, classes and  __post__) -->' format: {self javascriptSteps}); cr.

		stream nextPutAll: '<!!-- First the pre  -->'; cr.
		self includeJavascriptSource: '__pre__' on: stream.

		stream nextPutAll: '<!!-- Then the classes  -->'; cr.
		classes := self allJsClasses asSortedCollection:[:x :y | x jsGoesBefore: y].
		classes do:[:each |
			self includeJavascriptSource: each jsClassName on: stream.
		].

		stream nextPutAll: '<!!-- Finally the post  -->'; cr.
		self includeJavascriptSource: '__post__' on: stream.
	]
	ifFalse: [
		stream nextPutAll: '<!!-- Include all JavaScript code in a shot -->'; cr.
		self includeJavascriptSource: '__all__' on: stream.
	].

	^ stream contents.
! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:50'!
includeJavascriptSource: sourceNameString on: stream

	self includeEmbeddedJavascript ifTrue: [
		stream nextPutAll: '<!!-- Embedded: "' , sourceNameString , '" -->'; cr.
		stream nextPutAll: '<script type=''text/javascript''>'; cr.
		stream nextPutAll: (self updateLoadProgressIndicator: sourceNameString).
		stream nextPutAll: (self sourceForClass: sourceNameString) withoutTrailingBlanks; cr.
		stream nextPutAll: '</script>'; cr; cr.
	]
	ifFalse: [
		stream nextPutAll: '<script type=''text/javascript'' src=''/JavascriptSource/' , self name , '/' , sourceNameString , '.js''></script>'; cr
	]
! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:57'!
isValidClassName: sourceName

	(#('__all__' '__pre__' '__post__') includes: sourceName)
		ifTrue:[^ true].
		
	^ self allJsClasses anySatisfy:[:each | each jsClassName = sourceName]! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:12'!
javascriptSteps
	^ self includeJavascriptInSteps
					ifTrue: [self allJsClasses size + (2 "__pree__ and __post__")]
					ifFalse:[1].
! !

!SWTClientApplication class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 11/9/2007 12:17'!
jsPreSource
	^ '
/* Client Application Utilities */
var agt = navigator.userAgent.toLowerCase();
var is_ie = ((agt.indexOf("msie") !!= -1) && (agt.indexOf("opera") == -1));


function createXmlHttp() {
	var xmlhttp = false;

	/*@cc_on @*/
	/*@if (@_jscript_version >= 5)
	// JScript gives us Conditional compilation, we can cope with old IE versions.
	// and security blocked creation of the objects.
	try {
		xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
	} catch (e) {
		try {
			xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (E) {
			xmlhttp = false;
		}
	}
	@end @*/
      
	if (!!xmlhttp && typeof XMLHttpRequest!!="undefined") {
		try {
			xmlhttp = new XMLHttpRequest();
		} catch (e) {
			xmlhttp = false;
		}
	}
      
	if (!!xmlhttp && window.createRequest) {
 		try {
			xmlhttp = window.createRequest();
		} catch (e) {
			xmlhttp = false;
		}
	}

	return xmlhttp;
}

function invokeJsonRPCMethod(method, params, async, loged, invokeId, listenerId) {
	var reqDictionary = Dictionary.__new__();

	reqDictionary.at_put_("listener_id",	listenerId);
	reqDictionary.at_put_("id",				invokeId);
	reqDictionary.at_put_("method",		method);
	reqDictionary.at_put_("params",		params);
	reqDictionary.at_put_("async",			async);

	var jsonRequest = reqDictionary.asJSONString();

	if (loged) {
		app.log_( "Request:" + jsonRequest );
	}

	var xmlhttp = createXmlHttp();
	if (!!xmlhttp) {
		app.logError_( "Error trying to create an XmlHttp request." );
		return;
	}

	xmlhttp.open("POST", "/SocketServer?random=" + Math.random().toString(), async);
	if (async) {
		xmlhttp.onreadystatechange = function() {
				if (xmlhttp.readyState == 4) {
					var response = top.eval( "(" + xmlhttp.responseText + ")");
					if (loged) {
						app.log_( "Response:" + xmlhttp.responseText );
					}
				}
			};
		xmlhttp.send( jsonRequest );

		return true;
	}
	else {
		xmlhttp.send( jsonRequest );

		var response = top.eval( "(" + xmlhttp.responseText + ")");
		if (loged) {
			app.log_( "Response:" + xmlhttp.responseText );
		}

		return response["result"];
	}
}
'! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 10/31/2007 08:37'!
OLDallJsClasses

	| result |

	result := Set new.

	result addAll: S2SObjectExtension jsWithAllClassesToInclude.
	result addAll: S2STime jsWithAllClassesToInclude.

	result addAll: SWTWidget jsWithAllClassesToInclude.
	result addAll: S2SObjectWithProperties jsWithAllClassesToInclude.
	SWTWidget allSubclasses do:[:each |
		result addAll: each jsWithAllClassesToInclude.
	].

	result addAll: SWTServerApplicationProxy jsWithAllClassesToInclude.
	result addAll: SWTStackCommand jsWithAllClassesToInclude.

	result addAll: SWTScheduler jsWithAllClassesToInclude.
"	result addAll: SWTAlarm jsWithAllClassesToInclude."

	self = SWTClientApplication ifFalse:[
		result addAll: SWTClientApplication jsWithAllClassesToInclude.
	].

	result addAll: self jsWithAllClassesToInclude.

	^ result

"
CGMVCClientApplication allJsClasses size.
"
! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 10/31/2007 10:21'!
processClass: aClass on: classesSet
	"private - process class, if corresponds"

	(classesSet includes: aClass)							ifTrue:[^ self].
	(aClass isBehavior)										ifFalse:[^ self].
	(aClass includesBehavior: S2SObjectExtension)	ifFalse:[^ self].


	classesSet add: aClass.

	self processReferencedClassesOn:  aClass on: classesSet.
	self processReferencedClassesOn:  aClass class on: classesSet.

	aClass jsSuperclasses do:[:relatedClass |
		self processClass: relatedClass on: classesSet.
	].
	aClass jsClassesToInclude do:[:relatedClass |
		self processClass: relatedClass on: classesSet.
	].

"
CGMVCClientApplication allJsClasses size.
CGMVCClientApplication OLDallJsClasses size.

CGMVCClientApplication OLDallJsClasses removeAll: CGMVCClientApplication allJsClasses ; yourself
"
! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 10/31/2007 10:20'!
processReferencedClassesOn: aClass on: classesSet
	"private - process all the classes referenced from methods"

	aClass methodDict values do:[:method |
		| referencedClasses |

		referencedClasses := method allLiterals
												select: [:each | each isVariableBinding ]
												thenCollect: [:each | each value ].

		referencedClasses do:[:referencedClass |
			self processClass: referencedClass on: classesSet.
		].
	].
! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 9/1/2006 19:19'!
sourceForClass: sourceName
	^ self sourceForClass: sourceName selector: nil! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 7/1/2007 11:57'!
sourceForClass: sourceName selector: selectorName 

	| translator |

	translator := S2STranslator instance.

""
	translator showSmalltalkSource: false.
	translator showMethodComments: false.
""

	^ translator
			cachedSourceForClass: sourceName
			selector: selectorName
			allClasses: [ self allJsClasses ].
! !

!SWTClientApplication class methodsFor: '- only smalltalk - private' stamp: 'dgd 12/1/2006 16:07'!
updateLoadProgressIndicator: sourceName

	^ 'try { doLoadStep(''' , sourceName , '''); } catch(err) { }
'! !

!SWTClientApplication methodsFor: 'deferred ui messaging' stamp: 'dgd 11/5/2007 17:22'!
addDeferredUIMessage: valuableObject
	scheduler addDeferredUIMessage: valuableObject
! !

!SWTClientApplication methodsFor: 'deferred ui messaging' stamp: 'dgd 11/5/2007 17:22'!
addDeferredUIMessage: valuableObject at: scheduledTimeNumber
	scheduler addDeferredUIMessage: valuableObject at: scheduledTimeNumber! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 11/28/2006 18:06'!
baseColor
	^ self class baseColor! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 11/10/2007 12:38'!
busyOff
	"swith the receiver to non-busy state"

	busyCommand unDoIt.
! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 11/10/2007 12:38'!
busyOn
	"swith the receiver to busy state"

	busyCommand doIt.
! !

!SWTClientApplication methodsFor: 'events' stamp: 'dgd 11/10/2007 12:40'!
busy: aBoolean
	"the receiver changes the busy status"

"	self log: 'client ' , (aBoolean ifTrue:['busy'] ifFalse:['nonbusy'])."

	aBoolean
		ifTrue:[ self createBusyOverlay ]
		ifFalse:[ self destroyBusyOverlay ].
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 11/11/2007 16:14'!
clearLagStatisticsCounters

	lastRPCTimestamp := nil.

	lagStatistics isNil inlineIfFalse:[
		lagStatistics clear.
	].
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 11/11/2007 16:14'!
clearStatisticsCounters

	self clearLagStatisticsCounters.

	rpcStatistics isNil inlineIfFalse:[
		rpcStatistics clear.
	].
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 10/8/2006 14:00'!
cometIFrame
	"PRIVATE - Answer the receiver's comet-iframe, create it if needed"

	cometIFrame isNil ifTrue:[
		cometIFrame := SWTIFramePanel new.
		cometIFrame
			extent: 0@0;
			visible: false;
			border: 0.

		cometIFrame onLoad: [:event | 
					self isConnected ifTrue:[
						self justDisconnected.
					].
				].

		self rootWidget addWidget: cometIFrame.
	].

	^ cometIFrame! !

!SWTClientApplication methodsFor: 'connection/disconnection' stamp: 'dgd 10/8/2006 13:59'!
connect
	self log: 'Connecting...'.
	self windowStatus: 'Connecting...'.
	self plainReconnect.
! !

!SWTClientApplication methodsFor: 'connection/disconnection' stamp: 'dgd 4/24/2007 17:03'!
connectUI

	self windowStatus: ' - '.
	self destroyDisconnectedOverlay.

	self rootWidget connectUI.
"
	self playSoundNamed: '/resources/beep.wav'.
"! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 10/22/2007 17:48'!
createBusyOverlay

	"creates a transparent 'overlay' to intercept the (mouse) events to the UI"

	busyOverlay isNil inlineIfFalse: [ ^ self. ].

	busyOverlay := SWTPanel new.

	busyOverlay
		zIndex: 999998;
		beAbsolute;
		topLeft: self rootWidget scrollTopLeft;
		width: 100 percent;
		height: 100 percent;
		backgroundColor: Color white;
		opacity: 0;
		onMouseDown: [:event |
				self flag: #todo. "Not nice, look for another way to give busy feedback"
				busyOverlay
							highlight: Color red;
							opacity: 0.4;
							animateOpacityTo: 0.
			].

	self rootWidget addWidget: busyOverlay.
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 11/10/2007 12:27'!
createDisconnectedOverlay
	| msg whiteBox |

	disconnectedOverlay isNil inlineIfFalse: [ ^ self. ].

	msg := SWTText contents: self disconnectedMessage.
	msg
			color: Color red twiceDarker;
			fontFamily: 'serif';
			fontSize: 'large';
			bold.

	whiteBox := SWTPanel withAllWidgets: { msg }.
	whiteBox
		border: 2;
		borderColor: Color black;
		zIndex: 999999;
		beAbsolute;
		topLeft: self rootWidget scrollTopLeft + (70 @ 70);
		padding: 50;
		backgroundColor: Color lightYellow.

	disconnectedOverlay := SWTPanel new.
	disconnectedOverlay
		zIndex: 999999;
		beAbsolute;
		topLeft: self rootWidget scrollTopLeft;
		width: 100 percent;
		height: 100 percent;
		backgroundColor: Color black;
		opacity: 0.7.
	disconnectedOverlay onCleanUp:[:event | whiteBox ensureRemoval ].

	self rootWidget addWidget: disconnectedOverlay.
	self rootWidget addWidget: whiteBox.
! !

!SWTClientApplication methodsFor: 'configuration' stamp: 'dgd 9/3/2006 16:25'!
createRootWidget
	"create the root widgets for the receiver"
	^ SWTRootPanel default! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 10/22/2007 11:06'!
destroyBusyOverlay

	busyOverlay isNil inlineIfTrue: [ ^ self. ].

	busyOverlay remove.
	busyOverlay := nil.
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 10/22/2007 14:58'!
destroyDisconnectedOverlay

	disconnectedOverlay isNil inlineIfTrue: [ ^ self. ].

	disconnectedOverlay remove.
	disconnectedOverlay := nil.
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 6/20/2007 10:49'!
disconnectedMessage

"	^ 'EL SERVIDOR SE HA DESCONECTADO'"
	^ 'El servidor se ha desconectado'
! !

!SWTClientApplication methodsFor: 'connection/disconnection' stamp: 'dgd 4/24/2007 17:03'!
disconnectUI
	self log: '* DISCONNECTED *'.
	self windowStatus: '* DISCONNECTED *'.
	self rootWidget disconnectUI.
	self createDisconnectedOverlay.
! !

!SWTClientApplication methodsFor: 'running' stamp: 'dgd 7/1/2007 19:57'!
finalize
	"The application is being finalized, please cleanup your garbage"

	self log: 'Stoppinp stepping mechanism...'.
	self stopStepping.

	self log: 'Cleanning up the root widget...'.
	self rootWidget cleanUp.
! !

!SWTClientApplication methodsFor: 'initialization' stamp: 'dgd 11/10/2007 12:42'!
initialize
	super initialize.

	isStepping := false.

	lastWhen := 0.

	busyCommand := SWTStackCommand
												do: [ self busy: true ]
												unDo: [ self busy: false ].
! !

!SWTClientApplication methodsFor: 'initialization' stamp: 'dgd 6/14/2007 16:26'!
initializeApplication
	"Initialize the receiver"

	scheduler := SWTScheduler new.

	disconnectedStepCounter := 0.
	listenerId := 0.

	serverSide := SWTServerApplicationProxy clientApplication: self.

	self log: 'Initializing widgets...'.
	self windowStatus: 'Initializing widgets...'.
	self initializeWidgets.

	self log: 'Disconnecting UI...'.
	self windowStatus: 'Disconnecting UI...'.
	"self disconnectUI."
	self rootWidget disconnectUI.

	self log: 'Starting stepping mechanism...'.
	self windowStatus: 'Starting stepping mechanism...'.
	self startStepping.

	self resized.
! !

!SWTClientApplication methodsFor: 'configuration' stamp: 'dgd 10/9/2007 12:43'!
initializeWidgets
	"Initialize the receiver's widgets"

	| root |

	root := self rootWidget.

	root backgroundColor: Color red muchLighter muchLighter.

	root addWidget: (SWTHeader level: 2 contents: 'Overwrite method SWTClientApplication>>initializeWidgets').
	root lastWidget
		color: Color red.
! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 10/19/2007 13:29'!
interEventDelay
	"answer the delay between event and event"

	^ 5! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 11/11/2007 15:58'!
invokeJsonRPCMethod: selector arguments: args asynchronous: asyncBoolean invokeId: invokeId

	| listId result |

	(self testInvokeJsonRPCMethod: selector arguments: args asynchronous: asyncBoolean)
		inlineIfFalse:[ ^ self ].

	self isBusy inlineIfTrue:[
		self log: 'server-side invokation while the client is busy. (#' , selector , ' ' , args asString , ')'.
	].

	self isQueuing inlineIfTrue: [
		asyncBoolean inlineIfTrue:[
			self queueAsynchronousRPCMethod: selector arguments: args.
			^ self
		]
		ifFalse: [
			self log: 'synchronous rpc while the application is in "Queuing Mode". (#' , selector , ' ' , args asString , ')'.
		].
	].

	listId := self listenerId.

	lastRPCTimestamp := Time timestamp.

	result := self jsLiteral: 'invokeJsonRPCMethod(selector, args, asyncBoolean, /* loged */ false, invokeId, listId)'.

	rpcStatistics isNil inlineIfTrue:[
		rpcStatistics := S2SStatisticsCollector name: 'rpc'.
	].
	rpcStatistics sum: (Time timestamp - lastRPCTimestamp).

	^ result
! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 11/10/2007 12:39'!
isBusy
	"Answer if the application is in busy state"

	^ busyCommand isActive.
! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 6/14/2007 13:44'!
isConnected
	"Answer if the receiver is connected or not"

"	^ listenerId notNil and:[listenerId ~= 0]."

	^ self jsLiteral: '(self._listenerId !!= null) && (self._listenerId !!= 0)'
! !

!SWTClientApplication methodsFor: 'rpc queuing' stamp: 'dgd 10/25/2006 15:41'!
isolatedAsynchronousRPCMethods: aBlock
	self startQueuing.
	aBlock value.
	self stopQueuing.
! !

!SWTClientApplication methodsFor: 'rpc queuing' stamp: 'dgd 10/25/2006 15:38'!
isQueuing
	^ asynchronousRPCQueue notNil! !

!SWTClientApplication methodsFor: 'stepping' stamp: 'dgd 6/19/2007 15:32'!
isStepping

	^ isStepping! !

!SWTClientApplication methodsFor: 'connection/disconnection' stamp: 'dgd 11/7/2007 16:41'!
justConnected

	self log: 'Just connected to ' , self remoteAddress asString , ':', self remotePort asString, ' (#' , self listenerId asString , ')'.

	self connectUI.
! !

!SWTClientApplication methodsFor: 'connection/disconnection' stamp: 'dgd 11/7/2007 16:34'!
justConnectedListenerId: anInteger

	listenerId := anInteger.

	self justConnected.
! !

!SWTClientApplication methodsFor: 'connection/disconnection' stamp: 'dgd 9/20/2006 13:05'!
justDisconnected

	listenerId := 0.

	self log: 'Just disconnected!! '.
	self disconnectUI.
! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 9/20/2006 13:39'!
listenerId
	"Answer the receiver's listenerId"

	^ listenerId! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 10/18/2007 10:03'!
modelId: id

	| objectCounter |

	models isNil ifTrue:[
		^ nil
	].

	objectCounter := models
								at: id
								ifAbsent:[
									self logError: 'not found a model with id # ' , id asString.
									^ nil
								].

	^ objectCounter first.
! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 10/19/2007 13:27'!
nextWhen
	"fires the events coded in the given collection of eventsArgs"

	| now |

	now := Time timestamp.

	(lastWhen < now) inlineIfTrue:[
			lastWhen := now.
		]
		ifFalse:[
			lastWhen := lastWhen + self interEventDelay.
		].

	^ lastWhen.
! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 11/2/2007 16:32'!
onModelId: receiverId perform: selector arguments: args
	"fires the event with the given arguments"

	| receiver |

	receiver := self modelId: receiverId.
"
	self log: 'onModelId:  #' , receiverId asString , ' (' , receiver asString, ')
	perform: #' , selector , '
	args: ' , args asString.
"
	receiver perform: selector withArguments: args
! !

!SWTClientApplication methodsFor: 'connection/disconnection' stamp: 'dgd 6/19/2007 15:04'!
plainReconnect

	| appName random newSrc |

	appName := self jsLiteral: 'ServerApplicationName'.
	random := self jsLiteral: 'Math.random().toString()'.

	newSrc := '/SocketServer?application=' , appName , '&random=' , random.

	self cometIFrame src: newSrc.
! !

!SWTClientApplication methodsFor: 'sounding' stamp: 'dgd 6/13/2007 17:59'!
playSoundNamed: aString

	| soundSpan |

	soundSpan := self jsLiteral: 'document.getElementById("SoundSpan")'.

	self
		assert: [soundSpan notNil]
		errorMessage: 'SoundSpan is not present'.

	soundSpan
		jsSet: #innerHTML
		to: '<embed src="' , aString , '" hidden="true" volume="100" autostart="true" loop="false" playcount="1" mastersound></embed>'.
! !

!SWTClientApplication methodsFor: 'rpc queuing' stamp: 'dgd 10/25/2006 15:19'!
queueAsynchronousRPCMethod: selector arguments: args
	asynchronousRPCQueue add: {selector. args}! !

!SWTClientApplication methodsFor: 'stepping' stamp: 'dgd 11/9/2007 12:16'!
queueStep
	"PRIVATE"

	| stepTime |

	stepTime := 10"self stepTime".
	self jsLiteral: 'setTimeout(''if (app) { app.step() }'', stepTime)'.
! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 11/11/2007 15:49'!
receiveEvents: eventArgsCollection
	"fires the events coded in the given collection of eventsArgs"

	| last |
"
	(eventArgsCollection size > 1) inlineIfTrue:[
			self log: 'received ' , eventArgsCollection size asString , ' events in a group'.
		].
"
	lastRPCTimestamp isNil inlineIfFalse:[
		| lag |
		lag := Time timestamp - lastRPCTimestamp.
		lastRPCTimestamp := nil.

		lagStatistics isNil inlineIfTrue:[
			lagStatistics := S2SStatisticsCollector name: 'lag'.
		].
		lagStatistics sum: lag.
	].

	self busyOn.

	eventArgsCollection do:[:eventArgs |
		scheduler
				addDeferredUIMessage: [
						self 
							receiveEvent: eventArgs first
							selector: eventArgs second
							receiver: eventArgs third
							arguments: eventArgs fourth.
				]
				at: (last := self nextWhen).
	].

	scheduler
			addDeferredUIMessage: [ self busyOff ]
			at: last.
! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 11/6/2007 08:52'!
receiveEvent: eventName selector: selector receiver: receiverId arguments: args
	"fires the event with the given arguments"


	self flag: #todo. "eventName seems to be useless here"

"
	self log: 'received remote event: #' , eventName , '
	receiver: #' , receiverId asString , '
	selector: #' , selector , '
	args: ' , args asString.
"
"	self log: 'received remote event: #' , eventName , ', receiver: #' , receiverId asString , ', selector: #' , selector , ', args: ' , args asString."

	self onModelId: receiverId perform: selector arguments: args.
! !

!SWTClientApplication methodsFor: 'connection/disconnection' stamp: 'dgd 9/26/2006 12:05'!
reconnect

	self log: 'Trying to reconnect...'.
	self windowStatus: 'Trying to reconnect...'.
	self plainReconnect.
! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 10/18/2007 10:03'!
registerModel: anObject

	| objectCounter |

	models isNil ifTrue:[
		models := Dictionary new.
	].

	objectCounter := models
								at: anObject id
								ifAbsentPut:[ 
"									self log: 'registering model for the first time ' , anObject asString."
									{anObject. 0}
								].

	objectCounter at: 2 put: objectCounter second + 1.
! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 11/7/2007 16:41'!
remoteAddress

	| result colonPos slashPos |

	result := self jsLiteral:'document.location.href'.

	(result beginsWith: 'http://') ifTrue:[
		result := result allButFirst: 7.
	].

	colonPos := result indexOf: $:.
	colonPos isZero ifFalse:[
		result := result first: colonPos - 1.
	].

	slashPos := result indexOf: $/.
	slashPos isZero ifFalse:[
		result := result first: slashPos - 1.
	].

	^ result.
! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 11/7/2007 16:41'!
remotePort

	| result colonPos slashPos |

	result := self jsLiteral:'document.location.href'.

	(result beginsWith: 'http://') ifTrue:[
		result := result allButFirst: 7.
	].

	colonPos := result indexOf: $:.
	colonPos isZero ifTrue:[^ 80].

	result := result allButFirst: colonPos.

	slashPos := result indexOf: $/.
	slashPos isZero ifFalse:[
		result := result first: slashPos - 1.
	].
	
	^ result.
! !

!SWTClientApplication methodsFor: 'events' stamp: 'dgd 7/1/2007 11:15'!
resized
	"The browser windows has been resized, notify the root widget"

	self rootWidget resized.
! !

!SWTClientApplication methodsFor: 'configuration' stamp: 'dgd 11/7/2007 16:46'!
resourcesDirectory
	^'resources/'! !

!SWTClientApplication methodsFor: 'configuration' stamp: 'dgd 11/7/2007 16:48'!
resourcesPort
	"Answer the port to use un resource url handling.

	It allows an easy way to server static content from a webserver running on a different port.

	default is to server the resources from the same port than the application"

	^ nil
! !

!SWTClientApplication methodsFor: 'configuration' stamp: 'dgd 11/7/2007 16:49'!
resourcesUrl

	| resPort |

	resPort := self resourcesPort.
	resPort isNil inlineIfTrue:[
		^ self resourcesDirectory.
	].

	^ 'http://' , self remoteAddress , ':' , self resourcesPort asString , '/' , self resourcesDirectory.
! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 10/3/2006 11:49'!
rootPanel
	"Answer the receiver's root panel"

	^ self rootWidget! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 10/3/2006 12:22'!
rootWidget
	"Answer the receiver's root widget"

	rootWidget isNil inlineIfTrue:[
		rootWidget := self createRootWidget.
		rootWidget beRootIn: self.
	].

	^ rootWidget! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 6/12/2007 11:37'!
scheduler
	^ scheduler! !

!SWTClientApplication methodsFor: 'events' stamp: 'dgd 11/7/2007 18:06'!
scrolled
	"The browser windows has been scrolled, notify the root widget"

	busyOverlay isNil inlineIfFalse:[
		busyOverlay  topLeft: self rootWidget scrollTopLeft.
	].
	disconnectedOverlay isNil inlineIfFalse:[
		disconnectedOverlay  topLeft: self rootWidget scrollTopLeft.
	].

	self rootWidget scrolled.
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 11/11/2007 16:01'!
serverHasContacted

"	self log: 'server has contacted'."

	self tryToSendStatistics.
! !

!SWTClientApplication methodsFor: 'accessing' stamp: 'dgd 8/31/2006 20:25'!
serverSide
	"Answer the receiver's server side counterpart"

	^ serverSide! !

!SWTClientApplication methodsFor: 'rpc queuing' stamp: 'dgd 10/25/2006 15:38'!
startQueuing
	asynchronousRPCQueue := OrderedCollection new.
! !

!SWTClientApplication methodsFor: 'stepping' stamp: 'dgd 6/19/2007 15:32'!
startStepping
	"Put working the application stepping mechanism"

	self isStepping inlineIfTrue:[
		^ self.
	].

	isStepping := true.
	self queueStep.
! !

!SWTClientApplication methodsFor: 'stepping' stamp: 'dgd 6/19/2007 15:39'!
step
	"Do some periodic activity."

	isStepping inlineIfFalse:[^ self].


	"self isConnected inlineIfFalse:["
	(self jsLiteral: '(self._listenerId == null) || (self._listenerId == 0)') inlineIfTrue:[
		disconnectedStepCounter := disconnectedStepCounter + 1.

		(disconnectedStepCounter > 1000) inlineIfTrue:[
			self reconnect.
			disconnectedStepCounter := 0.
		]. 
	].

	scheduler  isNil inlineIfFalse:[
		scheduler doOneCycle.
	].

	self queueStep.
! !

!SWTClientApplication methodsFor: 'stepping' stamp: 'dgd 6/14/2007 17:56'!
stepTime
	^ 5! !

!SWTClientApplication methodsFor: 'rpc queuing' stamp: 'dgd 10/15/2007 11:31'!
stopQueuing

	| queue |

	queue := asynchronousRPCQueue.
	asynchronousRPCQueue := nil.

	queue isEmpty inlineIfFalse:[ 
		self serverSide performAsynchronousRPCQueue: queue.
	].
! !

!SWTClientApplication methodsFor: 'stepping' stamp: 'dgd 6/19/2007 15:19'!
stopStepping
	"Stop the application stepping mechanism"

	isStepping := false.! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 11/9/2007 12:35'!
testInvokeJsonRPCMethod: selector arguments: args asynchronous: asyncBoolean
	"PRIVATE - Answer if the receiver is in shape to make an RPC method invokation"

	self isConnected inlineIfFalse:[
		self log: 'Can''t invoke server-side methods while disconnected. (#' , selector , ' ' , args asString , ')'.
		^ false.
	].
"
	self isOperational inlineIfFalse:[
		self log: 'Can''t invoke server-side methods, client is not operational. (#' , selector , ' ' , args asString , ')'.
		^ false.
	].
"
	^ true.
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 11/11/2007 16:05'!
tryToSendLagStatistics
	"try to send the lag statistics to server"

	lagStatistics isNil inlineIfTrue: [ ^ self ].
	lagStatistics hasData inlineIfFalse: [ ^ self ].


	self log: 'sending lag statistics back to the server'.
	self serverSide noteClientLag: lagStatistics average.
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 11/11/2007 16:05'!
tryToSendRpcStatistics
	"try to send the lag statistics to server"

	rpcStatistics isNil inlineIfTrue: [ ^ self ].
	rpcStatistics hasData inlineIfFalse: [ ^ self ].


	self log: 'sending rpc statistics back to the server'.
	self serverSide noteClientRpcTime: rpcStatistics average.
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 11/11/2007 16:10'!
tryToSendStatistics
	"try to send the statistics to server"

	self isBusy inlineIfTrue: [ ^ self ].

	self tryToSendRpcStatistics.
	self tryToSendLagStatistics.
	self clearStatisticsCounters.
! !

!SWTClientApplication methodsFor: 'remote mvc' stamp: 'dgd 10/18/2007 10:03'!
unregisterModel: anObject

	| objectCounter counter |

	models isNil ifTrue:[
		^ self
	].

	objectCounter := models
								at: anObject id
								ifAbsent:[ ^ self ].

	counter := objectCounter second - 1.

	(counter < 1) ifTrue: [ 
"			self log: 'zero count, removing ' , anObject asString."
			models removeKey: anObject id.
		]
		ifFalse: [ objectCounter at: 2 put: counter ].
! !

!SWTClientApplication methodsFor: 'private' stamp: 'dgd 11/11/2007 13:50'!
windowStatus: aString

	self jsLiteral: 'window.status = aString'! !

SWTClientApplication subclass: #SWTControlPanelClientApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTControlPanelClientApplication class methodsFor: 'configuration' stamp: 'dgd 10/31/2006 12:42'!
applicationName
	^ 'SWT Control Panel'! !

!SWTControlPanelClientApplication methodsFor: 'configuration' stamp: 'dgd 10/31/2006 12:41'!
initializeWidgets
	"Initialize the receiver's widgets"

	| root  |

	root := self rootWidget.
	root addWidget: (SWTHeader level: 2 contents: self class applicationName).
	root addHorizontalRule.

	root addWidget:(SWTButton caption: 'reset st2js translator' onClick:[:event | self serverSide resetS2STranslator ]).
	root addWidget:(SWTButton caption: 'reset runner' onClick:[:event | self serverSide resetRunner ]).
	root addWidget:(SWTButton caption: 'save image' onClick:[:event | self serverSide saveImage ]).
	root addHorizontalRule.
! !

SWTClientApplication subclass: #SWTEffectsClientApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

!SWTEffectsClientApplication class methodsFor: 'configuration' stamp: 'dgd 6/6/2007 15:38'!
applicationName
	^ 'Visual Effects Demo'! !

!SWTEffectsClientApplication methodsFor: 'configuration' stamp: 'dgd 6/14/2007 15:16'!
createBall

	| ball effe ballExtent |

	ball := SWTImage src: 'ball.png'.

	ballExtent := 64@60.

	ball
		beAbsolute;
		topLeft: 20@200;
		extent: ballExtent.

	self rootWidget addWidget: ball.

	ball onClick: [:event | 
		effe := SWTEffect doTogether: {
						SWTEffect doInOrder: {
							SWTExtentEffect to: ballExtent * (1@1.2) time: 400.
							SWTExtentEffect to: ballExtent * (1.2@1) time: 400.
							SWTExtentEffect to: ballExtent time: 400.
						}.
						SWTEffect doInOrder: {
							SWTPositionEffect to: 500@200 time: 400.
							SWTPositionEffect to: 200@0 time: 400.
							SWTPositionEffect to: 20@200 time: 400.
						}.
				}.

		"ball effect: effe."
		effe startFor: ball.
	].
! !

!SWTEffectsClientApplication methodsFor: 'configuration' stamp: 'dgd 6/14/2007 15:15'!
createBlueBox

	| blueBox effe |

	blueBox := SWTPanel new.

	blueBox
		beAbsolute;
		topLeft: 100@100;
		extent: 80@80;
		backgroundColor: Color blue.

	self rootWidget addWidget: blueBox.

	blueBox onClick: [:event | 
		effe := SWTEffect doTogether: {
						SWTEffect doInOrder: {
							SWTExtentEffect to: 200@20 time: 1500.
							SWTExtentEffect to: 80@80 time: 1500.
						}.
						SWTEffect doInOrder: {
							SWTColorEffect to: Color yellow time: 1000.
							SWTColorEffect to: Color blue time: 2000.
						}.
						SWTEffect doInOrder: {
							SWTPositionEffect to: 400@100.
							SWTPositionEffect to: 200@500.
							SWTPositionEffect to: 100@100.
						}.
				}.

		"blueBox effect: effe."
		effe startFor: blueBox.
	].
! !

!SWTEffectsClientApplication methodsFor: 'configuration' stamp: 'dgd 6/14/2007 15:11'!
createRedBox

	| redBox effe |

	redBox := SWTPanel new.
	redBox
		beAbsolute;
		topLeft: 10@100;
		extent: 80@80;
		backgroundColor: Color red.

	self rootWidget addWidget: redBox.

	redBox onClick: [:event | 
		effe := SWTEffect doInOrder: {
						SWTEffect doTogether: {
							SWTExtentEffect to: 120@60 time: 1000.
							SWTPositionEffect to: 200@300.
							SWTColorEffect to: Color green time: 500.
						}.
						SWTPauseEffect seconds: 0.25.
						SWTEffect doTogether: {
							SWTExtentEffect to: 50@100.
							SWTPositionEffect to: 400@10.
							SWTOpacityEffect to: 0.2.
						}.
						SWTEffect doTogether: {
							SWTExtentEffect to: 80@80.
							SWTPositionEffect to: 10@100 time: 1200.
							SWTColorEffect to: Color red time: 1200.
							SWTOpacityEffect to: 1 time: 1200.
						}.
				}.

		effe onStart: [ redBox addDropShadow. redBox zIndex: 10. ].
		effe onStop: [ redBox removeDropShadow ].

		"redBox effect: effe".
		effe startFor: redBox.
	].
! !

!SWTEffectsClientApplication methodsFor: 'configuration' stamp: 'dgd 6/8/2007 09:52'!
initializeWidgets
	"Initialize the receiver's widgets"

	| root |

	root := self rootWidget.

	root addWidget: (SWTHeader level: 2 contents: self class applicationName).
	root addWidget: (SWTText contents: 'click on the objects bellow to fire the demo effects').

	self createRedBox.
	self createBlueBox.
	self createBall.
! !

SWTClientApplication subclass: #SWTExampleClientApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

!SWTExampleClientApplication class methodsFor: 'configuration' stamp: 'dgd 9/4/2006 12:34'!
applicationName
	^ 'Example Application'! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 10/12/2006 12:01'!
addNewEditInPlaceText

	| root |

	root := self rootWidget.

	root addWidget: (SWTEditInPlaceText contents: 'Edit-in-place text (with background color), click on me to edit').
	root lastWidget
			width: 100 percent;
			backgroundColor: Color yellow muchLighter.
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 10/12/2006 12:01'!
createButtons

	| root button |

	root := self rootWidget.

	root addHorizontalRule.
	root addWidget: (SWTHeader level: 2 contents: 'Buttons').
	root addWidget: (SWTButton caption: 'inspect event' onClick: [:event | event inspect]).
	root addWidget: (SWTButton caption: 'inspect root panel' onClick: [:event | root inspect]).

	root addWidget: (button := SWTButton caption: 'button with several event handlers').

	button onClick: [:event | event inspect].
	button onClick: [:event | self inform: '2st handler: ' , event asString].
	button onClick: [:event | self inform: '3rd handler: ' , event asString].

	button 
			color: Color blue;
			backgroundColor: Color blue muchLighter.

	button onFocus: [:event |
		event source
			color: Color red;
			backgroundColor: Color red muchLighter
	].

	button onBlur: [:event |
		event source
			color: Color blue;
			backgroundColor: Color blue muchLighter
	].

! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 10/12/2006 12:01'!
createEditableTexts

	| root |

	root := self rootWidget.

	root addHorizontalRule.
	root addWidget: (SWTHeader level: 2 contents: 'Edit-In-Place texts').

	root addWidget: (SWTEditInPlaceText contents: 'One edit-in-place text, click on me to edit').
	root addBreak.

	root addWidget: (SWTEditInPlaceText contents: 'Another edit-in-place text (with background color), double click on me to edit').
	root lastWidget
			editOnDblClick;
			backgroundColor: Color blue muchLighter.
	root addBreak.

	root addWidget: (SWTEditInPlaceText contents: 'Just another edit-in-place text (with background color), move mouse over me to edit').
	root lastWidget
			editOnMouseOver;
			backgroundColor: Color red muchLighter.
	root addBreak.

	root addWidget: (SWTEditInPlaceText contents: 'And just another edit-in-place text (with background color), move mouse over me to edit').
	root lastWidget
			editOnMouseOver;
			backgroundColor: Color green muchLighter.
	root addBreak.

	root addWidget: (SWTButton caption: 'add a new edit-in-place text' onClick: [:event | self addNewEditInPlaceText]).
	root lastWidget backgroundColor: Color yellow muchLighter.
	root addBreak.
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 10/12/2006 12:01'!
createFlashers
	| root |

	root := self rootWidget.

	root addHorizontalRule.

	root addWidget: (SWTHeader level: 2 contents: 'Flashers').

	root addWidget: SWTFlasher new.

	root addWidget: SWTFlasher new.
	root lastWidget
		onColor: Color yellow;
		offColor: Color blue;
		delay: 1000.
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 10/12/2006 12:01'!
createHeaders

	| root |

	root := self rootWidget.

	root addHorizontalRule.
	root addWidget: (SWTHeader level: 1 contents: 'header level 1 (double-click on me)').

	root lastWidget color: Color black.
	root lastWidget onDblClick: [:event |
		| newColor |

		newColor := (event source color = Color black)
								ifTrue: [Color red]
								ifFalse: [Color black].

		event source color: newColor.
	].

	root addWidget: (SWTHeader level: 2 contents: 'header level 2 (move mouse over me)').
	root lastWidget
		onMouseOver: [:event | event source backgroundColor: Color green];
		onMouseOut: [:event | event source backgroundColor: Color white].

	root addWidget: (SWTHeader level: 3 contents: 'header level 3').
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 9/26/2006 11:47'!
createMoreInterestingWidgets

	| root |

	root := self rootWidget.

	root addHorizontalRule.

	root addWidget: (SWTHeader level: 2 contents: 'More interesting widgets').

	root addWidget: (SWTHeader level: 3 contents: 'Server-Side message sending (see Squeak transcript)').
	root addWidget: (SWTButton caption: 'self serverSide foo' onClick: [:event | self serverSide foo]).
	root addWidget: (SWTButton caption: 'self serverSide bar: 1' onClick: [:event | self serverSide bar: 1]).
	root addWidget: (SWTButton caption: 'self serverSide bar: ''a''' onClick: [:event | self serverSide bar: 'a']).

	root addWidget: (SWTHeader level: 3 contents: 'Server-Side message sending with impact on the client side').
	root addWidget: (SWTButton caption: 'self serverSide ping' onClick: [:event | self serverSide ping]).
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 10/12/2006 12:01'!
createSimpleTexts

	| root |

	root := self rootWidget.

	root addHorizontalRule.
	root addWidget: (SWTHeader level: 2 contents: 'Simple texts').

	root addWidget: (SWTText contents: 'some plain text.').

	root addWidget: (SWTText contents: 'text in red.').
	root lastWidget
			color: Color red.

	root addWidget: (SWTText contents: 'text in blue/green.').
	root lastWidget
			color: Color blue;
			backgroundColor: Color green.

	root addBreak.
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 9/28/2006 18:14'!
createSounds
	| root |

	root := self rootWidget.

	root addHorizontalRule.

	root addWidget: ( SWTHeader level: 2 contents: 'Sound playing' ).

	root addWidget: ( SWTButton caption: 'beep'			onClick: [:event | self playSoundNamed: '/resources/beep.wav'] ).
	root addWidget: ( SWTButton caption: 'boing'			onClick: [:event | self playSoundNamed: '/resources/boing.wav'] ).
	root addWidget: ( SWTButton caption: 'can crush'	onClick: [:event | self playSoundNamed: '/resources/can_crush.wav'] ).
	root addWidget: ( SWTButton caption: 'knocking'		onClick: [:event | self playSoundNamed: '/resources/knocking.wav'] ).
	root addWidget: ( SWTButton caption: 'success'		onClick: [:event | self playSoundNamed: '/resources/success.wav'] ).
! !

!SWTExampleClientApplication methodsFor: 'private' stamp: 'dgd 10/12/2006 12:01'!
createWindows

	| root |

	root := self rootWidget.

	root addWidget: (SWTWindow title: 'Window A').
	root lastWidget
		backgroundColor: Color lightGreen;
		topLeft: 20@10.

	root addWidget: (SWTWindow title: 'Window B').
	root lastWidget
		backgroundColor: Color lightRed;
		topLeft: 60@150.

	root addWidget: (SWTWindow title: 'Window C').
	root lastWidget
		topLeft: 230@40;
		extent: 200@200.

	root addWidget: (SWTWindow title: 'Window D').
	root lastWidget
		backgroundColor: Color lightBlue;
		opacity: 1;
		topLeft: 260@220;
		extent: 400@150.
! !

!SWTExampleClientApplication methodsFor: 'configuration' stamp: 'dgd 9/30/2006 13:00'!
initializeWidgets
	"Initialize the receiver's widgets"

	| root |

	root := self rootWidget.

	root addWidget: (SWTText contents: 'press CTRL + SHIFT + ALT + Double-Click, on the document, to inspect the application object').
	root onDblClick:[:event |
		(event ctrlKey and:[event shiftKey]  and:[event altKey]) ifTrue:[
			self inspect.
		]
	].
	root addBreak.

	self createSimpleTexts.
	self createHeaders.
	self createButtons.
	self createEditableTexts.

	self createMoreInterestingWidgets.

	self createSounds.

	self createFlashers.

	self createWindows.
! !

!SWTExampleClientApplication methodsFor: 'tests' stamp: 'dgd 10/9/2007 11:21'!
pong
	self inform: 'pong!!'! !

SWTClientApplication subclass: #SWTMapClientApplication
	instanceVariableNames: 'map'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-Map'!

!SWTMapClientApplication class methodsFor: 'configuration' stamp: 'dgd 12/12/2006 12:37'!
applicationName
	^ 'Map'! !

!SWTMapClientApplication class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 12/12/2006 14:59'!
jsClassesToInclude
	^ { SWTCellMap }! !

!SWTMapClientApplication methodsFor: 'connection/disconnection' stamp: 'dgd 12/15/2006 10:15'!
applicationJustConnected: formExtentPoint

	map initializeFormExtent: formExtentPoint.
! !

!SWTMapClientApplication methodsFor: 'configuration' stamp: 'dgd 12/15/2006 12:42'!
initializeWidgets
	"Initialize the receiver's widgets"

	|  column |

	column := SWTColumnPanel new.

	column
		addWidget: ( SWTHeader level: 2 contents: self class applicationName );
		addWidget: ( self toolbar );
		addWidget: ( map := SWTMap new ).

	column
		width: 100 percent;
		height: 100 percent;
"		cellPadding: 5;"
		cellsHeight: {1 percent. 1 percent. 98 percent }.

	self rootWidget addWidget: column.
! !

!SWTMapClientApplication methodsFor: 'configuration' stamp: 'dgd 12/15/2006 14:15'!
toolbar

	| zoomRow moveRow |

	zoomRow := SWTRowPanel new.
	zoomRow addWidget: (SWTText contents: 'zoom:').
	zoomRow addWidget: (SWTButton caption: '10%' onClick:[:event | map zoom: 0.1]).
	zoomRow addWidget: (SWTButton caption: '20%' onClick:[:event | map zoom: 0.2]).
	zoomRow addWidget: (SWTButton caption: '30%' onClick:[:event | map zoom: 0.3]).
	zoomRow addWidget: (SWTButton caption: '40%' onClick:[:event | map zoom: 0.4]).
	zoomRow addWidget: (SWTButton caption: '50%' onClick:[:event | map zoom: 0.5]).
	zoomRow addWidget: (SWTButton caption: '60%' onClick:[:event | map zoom: 0.6]).
	zoomRow addWidget: (SWTButton caption: '70%' onClick:[:event | map zoom: 0.7]).
	zoomRow addWidget: (SWTButton caption: '80%' onClick:[:event | map zoom: 0.8]).
	zoomRow addWidget: (SWTButton caption: '90%' onClick:[:event | map zoom: 0.9]).
	zoomRow addWidget: (SWTButton caption: '100%' onClick:[:event | map zoom: 1.0]).

	moveRow := SWTRowPanel new.
	moveRow addWidget: (SWTText contents: 'position:').
	moveRow addWidget: (SWTButton caption: '<' onClick:[:event | map moveLeft ]).
	moveRow addWidget: (SWTButton caption: '>' onClick:[:event | map moveRight ]).
	moveRow addWidget: (SWTButton caption: '/\' onClick:[:event | map moveUp ]).
	moveRow addWidget: (SWTButton caption: '\/' onClick:[:event | map moveDown ]).

	^ SWTColumnPanel withAllWidgets: {zoomRow. moveRow}.
! !

SWTClientApplication subclass: #SWTMVCClientApplication
	instanceVariableNames: 'currentObject mainPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-MVC'!

!SWTMVCClientApplication class methodsFor: 'configuration' stamp: 'dgd 10/15/2006 16:41'!
applicationName
	^ 'Web 2.0 MVC'! !

!SWTMVCClientApplication class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 10/15/2006 16:49'!
jsClassesToInclude
	^ {SWTSampleModel}! !

!SWTMVCClientApplication methodsFor: 'accessing' stamp: 'dgd 10/9/2007 09:11'!
createWindowViewFor: anObject title: aString

	| window view |

	window := SWTWindow title: aString.

	view := anObject defaultView.

	mainPanel addWidget: window.

	window addContentsWidget: view.
	window backgroundColor: view backgroundColor.

	^ window
! !

!SWTMVCClientApplication methodsFor: 'accessing' stamp: 'dgd 11/8/2006 13:08'!
currentObject: anObject

	currentObject isNil ifFalse:[
		currentObject aspects do:[:eachAspect |
			eachAspect removeActionsWithReceiver: mainPanel.
		]
	].

	currentObject := anObject.

	self isolatedAsynchronousRPCMethods: [
		mainPanel clearWidgets.

		self createWindowViewFor: currentObject title: 'View 1'.
		self createWindowViewFor: currentObject title: 'View 2'.
		self createWindowViewFor: currentObject title: 'View 3'.
		self createWindowViewFor: currentObject title: 'View 4'.
	].

	mainPanel arrangeWindows.

	currentObject aspects do:[:eachAspect |
		eachAspect onChangeSend: #arrangeWindows to: mainPanel.
	].

"
	mainPanel addWidget: (SWTHeader level: 3 contents: 'View 1').
	mainPanel addWidget: currentObject defaultView.
	mainPanel addWidget: (SWTHeader level: 3 contents: 'View 2').
	mainPanel addWidget: currentObject defaultView.
"! !

!SWTMVCClientApplication methodsFor: 'configuration' stamp: 'dgd 11/7/2006 10:09'!
initializeWidgets
	"Initialize the receiver's widgets"

	| root  |

	root := self rootWidget.
	root addWidget: (SWTHeader level: 2 contents: self class applicationName).
	root addHorizontalRule.
"
	root addWidget: (toolbarPanel := SWTPanel new).
	root lastWidget
		padding: 0.5 percent;
		backgroundColor: Color green muchLighter;
		width: 99 percent.

	toolbarPanel addWidget:(SWTButton caption: 'cascade windows' onClick:[:event | mainPanel cascadeWindows ]).
	toolbarPanel addWidget:(SWTButton caption: 'arrange windows' onClick:[:event | mainPanel arrangeWindows ]).
"
	root addWidget: (mainPanel := SWTPanel new).
! !

!SWTMVCClientApplication methodsFor: 'connection/disconnection' stamp: 'dgd 10/16/2006 17:25'!
justConnected
	super justConnected.

"	self currentObject: SWTSampleModel new."
	self currentObject: self serverSide model.
! !

SWTClientApplication subclass: #SWTPingPongClientApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

!SWTPingPongClientApplication class methodsFor: 'configuration' stamp: 'dgd 9/5/2006 20:04'!
applicationName
	^ 'Ping Pong'! !

!SWTPingPongClientApplication methodsFor: 'configuration' stamp: 'dgd 9/5/2006 20:08'!
initializeWidgets
	"Initialize the receiver's widgets"

	| root |

	root := self rootWidget.

	root addWidget: (SWTHeader level: 2 contents: self class applicationName).

	root addWidget: (SWTButton caption: 'server ping' onClick: [:event | self serverSide ping]).
! !

!SWTPingPongClientApplication methodsFor: 'ping/pong' stamp: 'dgd 7/1/2007 19:44'!
pong
	self inform: 'pong!!'! !

SWTClientApplication subclass: #SWTSocialShoppingClientApplication
	instanceVariableNames: 'usersListWidget chatMessagesWidget lastUserName inventoryPanel cartPanel cartTotalPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-View'!

!SWTSocialShoppingClientApplication class methodsFor: 'configuration' stamp: 'dgd 9/5/2006 22:35'!
applicationName
	^ 'Social Shopping (Demo)'! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 10/12/2006 12:02'!
baseColor

	^ Color green! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - inventory' stamp: 'dgd 9/6/2006 19:58'!
buyProductId: anInteger
	self serverSide buyProductId: anInteger! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 21:06'!
cartPanel

	| panel totalPanel |

	panel := SWTColumnPanel new.

	panel
"		border: 1;"
		width: 100 percent;
		height: 100 percent.

	panel addWidget: (SWTText contents: 'carrito de compras:').
	panel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.

	panel addWidget: (cartPanel := SWTPanel new).
	panel lastWidget
		overflow: 'auto';
		border: 1;
		width: 100 percent;
		height: 100 percent;
		borderColor: self baseColor muchDarker;
		backgroundColor: self baseColor muchLighter muchLighter muchLighter.

	totalPanel := SWTRowPanel new.
	totalPanel
		backgroundColor: self baseColor muchLighter;
		"border: 1;"
		cellPadding: 5;
		width: 100 percent;
		cellsWidth: { 60 percent. 40 percent }.
	totalPanel addWidget: (SWTText contents: 'total compra:').
	totalPanel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.

	totalPanel addWidget: (cartTotalPanel := SWTPanel new).
	totalPanel lastWidget
		border: 1;
		width: 100 percent;
		height: 100 percent;
		borderColor: self baseColor muchDarker;
		backgroundColor: self baseColor muchLighter muchLighter muchLighter.

	panel addWidget: totalPanel.
	panel cellsHeight: {1 percent. 98 percent. 1 percent.}.

	^ panel.
! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/7/2006 11:23'!
chatPanel

	| panel userListPanel |

	panel := SWTColumnPanel new.
	panel
"		border: 1;"
		cellPadding: 0;
		height: 100 percent;
		width: 100 percent.

"	panel addWidget: (SWTText contents: 'online users:')."
	panel addWidget: (SWTText contents: 'compradores conectados:').
	panel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.
	panel addWidget: (userListPanel := SWTPanel new).
	panel lastWidget
		overflow: 'auto';
		fontSize: 'small';
		border: 1;
		borderColor: self baseColor muchDarker;
		width: 100 percent;
		height: 100 percent;
		backgroundColor: self baseColor muchLighter muchLighter muchLighter.
	userListPanel addWidget: (usersListWidget := SWTText contents: '').

	panel addWidget: (SWTText contents: 'chat:').
	panel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.
	panel addWidget: (chatMessagesWidget := SWTPanel new).
	panel lastWidget
		overflow: 'scroll';
		fontSize: 'small';
		border: 1;
		borderColor: self baseColor muchDarker;
		width: 100 percent;
		height: 100 percent;
		backgroundColor: self baseColor muchLighter muchLighter muchLighter.

"	panel addWidget: (SWTText contents: 'your chat message:')."
	panel addWidget: (SWTText contents: 'mi mensaje:').
	panel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.
	panel addWidget: (SWTInputText contents: '').
	panel lastWidget
		border: 1;
		borderColor: self baseColor muchDarker;
		width: 100 percent.

	panel lastWidget
		onChange: [:event | self sendChatMessage: event source ];
		onKeyPress: [:event |
			(event keyCode = 13) ifTrue:[
"					(event ctrlKey or:[event shiftKey]) ifFalse:[]."
					self sendChatMessage: event source.
				]
		].

	panel cellsHeight: {1 percent. 30 percent. 1 percent. 66 percent. 1 percent. 1 percent}.

	^ panel.
! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 21:09'!
helpPanel

	| text panel |

"
	text := SWTText contents: 'This is a proof-of-concept for a new type of online store: Social-Shopping.  Shopping is a social activity and most of the online stores ignore this fact.  Social-Shopping allows more than one shooper to interact into a single buying process.  The cart can be handled simultaneously by every authorized shooper.  Social-Shopping also considers the role of the seller, that can offer help to the shoppers.'.
"
	text := SWTText contents: 'Esto es una demostracin de <b>Social Shopping</b> (Compra Social). Comprar es una actividad social, y la mayora de las tiendas online ignoran ese hecho.  <b>Social Shopping</b> permite interactuar, a ms de un comprador, en el mismo proceso de compra.  El carrito de la compra puede ser manipulado, simultneamente, por cada uno de los compradores autorizados y los cambios son visibles, en tiempo real, por los otros compradores. <b>Social Shopping</b> tambin considera el rol del vendedor, que puede ofrecer ayuda (en tiempo real) en la compra.  Todos los actores, del proceso de la compra, pueden comunicarse entre si usando el chat provisto.'.

	text fontSize: 'x-small'.

	panel := SWTRowPanel withAllWidgets: { SWTImage src: 'help.png'. text }.
	panel
		cellPadding: 5.

	^ panel! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/5/2006 19:28'!
initializeWidgets
	"Initialize the receiver's widgets"

	| column |

	column := SWTColumnPanel withAllWidgets: { self titlePanel. self mainPanel. self helpPanel. }.

	column
		cellsHeight: {1 percent. 98 percent. 1 percent};
		cellsVAlign: {'bottom'. 'top'. 'top'};
		width: 100 percent;
		height: 100 percent.

	self rootWidget addWidget: column.
! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 19:27'!
inventoryPanel

	| panel |

	panel := SWTColumnPanel new.

	panel
"		border: 1;"
		width: 100 percent;
		height: 100 percent.

	panel addWidget: (SWTText contents: 'inventario de productos:').
	panel lastWidget
		color: self baseColor muchDarker muchDarker;
		italic;
		bold.

	panel addWidget: (inventoryPanel := SWTPanel new).
	panel lastWidget
		overflow: 'auto';
		border: 1;
		width: 100 percent;
		height: 100 percent;
		borderColor: self baseColor muchDarker;
		backgroundColor: self baseColor muchLighter muchLighter muchLighter.

	panel cellsHeight: {1 percent. 99 percent}.

	^ panel! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 20:19'!
mainPanel

	| panel |

	panel := SWTRowPanel withAllWidgets: { self chatPanel. self inventoryPanel. self cartPanel }.

	panel
		cellPadding: 10;
		width: 100 percent;
		height: 100 percent;
		cellsWidth: {25 percent. 50 percent. 25 percent};
		cellsBackgroundColor: {self baseColor muchLighter. self baseColor muchLighter muchLighter. self baseColor muchLighter muchLighter }.

	^ panel.
! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - inventory' stamp: 'dgd 9/6/2006 20:28'!
notBuyProductId: anInteger
	self serverSide notBuyProductId: anInteger! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - inventory' stamp: 'dgd 9/12/2006 18:42'!
receiveCart: aCollection

	| total |

	cartPanel clearWidgets..

	total := 0.

	aCollection inlineDo:[:dict |
		| t p c id panel  |

		t := dict first.
		p := dict second.
		c := dict third.
		id := dict fourth.

		panel := SWTRowPanel new.
		panel
			cellPadding: 1;
			width: 100 percent.

		panel addWidget: (SWTButton caption: '-' onClick:[:event | self notBuyProductId: event source model ]).
		panel lastWidget model: id.
		panel addWidget: (SWTText contents: c asString).
		panel addWidget: (SWTText contents: t asString).
		panel addWidget: (SWTText contents: '&euro;' , (p * c) asString).

		panel cellsWidth: {10 percent. 10 percent. 70 percent. 10 percent}.

		cartPanel addWidget: panel.

		total := total + (p * c).
	].

	cartTotalPanel clearWidgets.
	cartTotalPanel addWidget: (SWTText contents: '&euro; ' , total asString).
! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - chat' stamp: 'dgd 9/23/2006 20:07'!
receiveChatMessage: chatString from: userNameString

	| userName chatMsg |

	userName := userNameString.

	chatMsg := chatString.

	(userName = self userName) ifTrue:[
		userName := 'me'.
		chatMsg := '<i>' , chatMsg , '</i>'.
	].

	(lastUserName = userName)
		ifTrue:[userName := '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' first: lastUserName size * 6]
		ifFalse:[lastUserName := userName].

	chatMessagesWidget 
		addWidget: (SWTText contents: '<tt><b>' , userName , ':</b></tt> ' , chatMsg);
		addBreak;
		goBottom.
! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - inventory' stamp: 'dgd 9/6/2006 21:15'!
receiveInventory: aCollection

	| first |

	inventoryPanel clearWidgets.

	first := true.
	aCollection inlineDo:[:dict |
		| t d p c i id panel detailsPanel |

		t := dict first.
		d := dict second.
		p := dict third.
		c := dict fourth.
		i := dict fifth.
		id := dict sixth.

		panel := SWTRowPanel new.
		panel
			cellPadding: 5.

		panel addWidget: (SWTImage src: i).

		detailsPanel := SWTColumnPanel new.
		detailsPanel addWidget: (SWTText contents: t asString).
		detailsPanel lastWidget
			fontSize: 'large';
			bold.
		detailsPanel addWidget: (SWTText contents: d asString).
		detailsPanel lastWidget
			fontSize: 'small';
			italic.
		detailsPanel addWidget: (SWTText contents: '<b>precio:</b> &euro;' , p asString , '.  <b>disponibles:</b> ' , c asString , ' unidades.').
		detailsPanel addWidget: (SWTButton caption: 'Agregar al Carrito' onClick:[:event | self buyProductId: event source model ]).
		detailsPanel lastWidget model: id.

		panel addWidget: detailsPanel.

		first
			ifTrue:[ first := false ]
			ifFalse:[ inventoryPanel addHorizontalRule ].

		inventoryPanel addWidget: panel.
	].
! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - inventory' stamp: 'dgd 9/6/2006 21:14'!
receiveInventory: inventoryCollection cart: cartCollection

	self receiveInventory: inventoryCollection.
	self receiveCart: cartCollection.
! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - chat' stamp: 'dgd 10/9/2007 11:25'!
receiveUsersList: aCollection

	| userList |

	userList := String new writeStream.

"	userList nextPutAll: '<ul>'."
"
	(S2SArrayExtension withAll: aCollection)
		reject:[:each | each = self userName]
		thenDo:[:each |
			userList nextPutAll: '<li>'.
			userList nextPutAll: each asString.
		].
"
	aCollection inlineDo:[:each |
			| userName |

			userName := each asString.

			(each = self userName) ifTrue:[
				userName := '<i>' , userName , ' (me)</i>'
			].

			userList nextPutAll: '<li>'.
			userList nextPutAll: userName.
		].


"	userList nextPutAll: '</ul>'."

	usersListWidget contents: userList contents.! !

!SWTSocialShoppingClientApplication methodsFor: 'processing - chat' stamp: 'dgd 9/5/2006 20:48'!
sendChatMessage: aInputTextWidget
	| msg |

	msg := aInputTextWidget contents.
	aInputTextWidget contents: ''.

	msg isEmpty
		ifTrue:[^ self].

	self serverSide
				receiveChatMessage: msg
				from: self userName.

	aInputTextWidget focus.
! !

!SWTSocialShoppingClientApplication methodsFor: 'configuration' stamp: 'dgd 9/6/2006 21:10'!
titlePanel

	| titlePanel legendsPanel |

	titlePanel := SWTRowPanel new.
	titlePanel cellPadding: 2.
	titlePanel addWidget: (SWTImage src: 'minicart.png').

	legendsPanel := SWTColumnPanel new.

	legendsPanel addWidget: (SWTText contents: self class applicationName).
	legendsPanel lastWidget
		fontSize: 'x-large';
		bold.

"	legendsPanel addWidget: (SWTText contents: 'e-commerce for the web 2.0 age')."
	legendsPanel addWidget: (SWTText contents: 'comercio electrnico para la era web 2.0').
	legendsPanel lastWidget
		fontSize: 'large';
		italic.
	titlePanel addWidget: legendsPanel.

	^ titlePanel
! !

!SWTSocialShoppingClientApplication methodsFor: 'accessing' stamp: 'dgd 11/5/2007 13:15'!
userName
	^ '#' , self listenerId asString.
! !

SWTClientApplication subclass: #SWTWhiteboardClientApplication
	instanceVariableNames: 'canvas captureCanvas penCanvas drawing points currentColor currentWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SharedWhiteboard'!

!SWTWhiteboardClientApplication class methodsFor: 'configuration' stamp: 'dgd 10/15/2006 12:44'!
applicationName
	^ 'Realtime Collaborative Whiteboard'! !

!SWTWhiteboardClientApplication methodsFor: 'drawing' stamp: 'dgd 10/14/2006 14:09'!
clear
	canvas clear.! !

!SWTWhiteboardClientApplication methodsFor: 'configuration' stamp: 'dgd 10/14/2006 18:54'!
createColorSelector
	"Initialize the receiver's widgets"

	| colorSelector |

	colorSelector := SWTColumnPanel new.

	(Color red wheel: 16) do:[:each |
		colorSelector addWidget: (self wheelRowFor: each handler: [:event | self currentColor: event source backgroundColor]).
	].

	^ colorSelector.
! !

!SWTWhiteboardClientApplication methodsFor: 'configuration' stamp: 'dgd 10/14/2006 18:57'!
createToolbar
	"Initialize the receiver's widgets"

	| toolbarPanel |

	toolbarPanel := SWTColumnPanel new.
	toolbarPanel addWidget: (SWTButton caption: 'clear' onClick: [:event | self serverSide clear]).

	toolbarPanel addWidget: (SWTText contents: 'Width:').
	toolbarPanel addWidget: (SWTButton caption: 'thin' onClick: [:event | self currentWidth: 1]).
	toolbarPanel addWidget: (SWTButton caption: 'medium' onClick: [:event | self currentWidth: 2]).
	toolbarPanel addWidget: (SWTButton caption: 'thick' onClick: [:event | self currentWidth: 5]).
	toolbarPanel addWidget: (SWTButton caption: 'marker' onClick: [:event | self currentWidth: 20]).

	toolbarPanel addWidget: (SWTText contents: 'Color:').
	toolbarPanel addWidget: self createColorSelector.

	toolbarPanel addWidget: (SWTText contents: 'Pen:').
	toolbarPanel addWidget: (penCanvas := SWTCanvas new).
	toolbarPanel lastWidget
		backgroundColor: Color white;
		extent: 64@24;
		border: 0.

	^ toolbarPanel! !

!SWTWhiteboardClientApplication methodsFor: 'accessing' stamp: 'dgd 10/14/2006 16:30'!
currentColor: aColor
	currentColor := aColor "alpha: 0.9".
	self updatePen.
! !

!SWTWhiteboardClientApplication methodsFor: 'accessing' stamp: 'dgd 10/14/2006 15:34'!
currentWidth: aNumber
	currentWidth := aNumber.
	self updatePen.
! !

!SWTWhiteboardClientApplication methodsFor: 'drawing' stamp: 'dgd 10/14/2006 16:07'!
draw: anEvent

	| currentPoint |

	drawing ifFalse: [^ self].

	captureCanvas roundLineCap.
	currentPoint := anEvent relativePosition.

	captureCanvas
		line: points last
		to: currentPoint
		width: currentWidth + 1
		color: currentColor.

	points add: currentPoint.
! !

!SWTWhiteboardClientApplication methodsFor: 'initialization' stamp: 'dgd 6/14/2007 16:26'!
initializeApplication
	super initializeApplication.

	drawing := false.

	self currentColor: Color black.
	self currentWidth: 2.
! !

!SWTWhiteboardClientApplication methodsFor: 'configuration' stamp: 'dgd 10/30/2006 09:39'!
initializeWidgets
	"Initialize the receiver's widgets"

	| root canvasToolbarPanel  |

	root := self rootWidget.

"	self halt."

	root addWidget: (SWTHeader level: 2 contents: self class applicationName).

	canvasToolbarPanel := SWTRowPanel new.
	canvasToolbarPanel
		backgroundColor: Color lightGreen twiceDarker;
		padding: 6;
		cellPadding: 1.
	root addWidget: canvasToolbarPanel.

	canvas := SWTCanvas new.
	canvas backgroundColor: Color white.
	canvasToolbarPanel addWidget: canvas.

	canvasToolbarPanel addWidget: self createToolbar.

	captureCanvas := SWTCanvas new.
	captureCanvas
		beAbsolute;
		topLeft: canvas topLeft.
	root addWidget: captureCanvas.

	captureCanvas onMouseDown:[:event | self startDrawing: event].
	captureCanvas onMouseMove:[:event | self draw: event].
	captureCanvas onMouseUp:[:event | self stopDrawing: event].
! !

!SWTWhiteboardClientApplication methodsFor: 'drawing' stamp: 'dgd 11/21/2006 11:15'!
newStroke: aPenStroke

	aPenStroke drawOn: canvas.
! !

!SWTWhiteboardClientApplication methodsFor: 'configuration' stamp: 'dgd 10/14/2006 13:34'!
panelFor: aColor handler: handler
	"Initialize the receiver's widgets"

	| panel |

	panel := SWTPanel new.

	panel
			extent: 8@8;
			backgroundColor: aColor;
			onClick: handler.

	^ panel
! !

!SWTWhiteboardClientApplication methodsFor: 'drawing' stamp: 'dgd 10/14/2006 16:13'!
startDrawing: anEvent

	drawing ifTrue:[^ self].

	drawing := true.

	captureCanvas
		fillRect: (0@0 extent: captureCanvas extent)
		color: (Color gray muchLighter muchLighter alpha: 0.7).

	points isNil ifTrue:[
		points := OrderedCollection new.
	].
	points add: anEvent relativePosition.
! !

!SWTWhiteboardClientApplication methodsFor: 'drawing' stamp: 'dgd 10/14/2006 14:21'!
stopDrawing: anEvent

	drawing ifFalse:[^ self].

	drawing := false.

	self serverSide newStroke: (SWTStroke points: points color: currentColor width: currentWidth).

	points := nil.
	captureCanvas clear.
! !

!SWTWhiteboardClientApplication methodsFor: 'private' stamp: 'dgd 10/18/2006 16:27'!
updatePen

	currentWidth isNil inlineIfTrue:[^ self].
	currentColor isNil inlineIfTrue:[^ self].

	penCanvas clear.
	penCanvas roundLineCap.

	penCanvas
		line: currentWidth @ (penCanvas height / 2)
		to: (penCanvas width - currentWidth) @ (penCanvas height / 2)
		width: currentWidth
		color: currentColor.
! !

!SWTWhiteboardClientApplication methodsFor: 'configuration' stamp: 'dgd 10/14/2006 13:44'!
wheelRowFor: aColor handler: handler
	"Initialize the receiver's widgets"

	| row |

	row :=  SWTRowPanel new.

	(aColor lightShades: 10) allButFirst do:[:each |
		row addWidget: (self panelFor: each handler: handler).
	].

	(aColor darkShades: 10) allButFirst allButLast reverseDo:[:each |
		row addWidget: (self panelFor: each handler: handler).
	].

	^ row.
! !

SWTClientApplication subclass: #SWTWindowsClientApplication
	instanceVariableNames: 'toolbarPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

!SWTWindowsClientApplication class methodsFor: 'configuration' stamp: 'dgd 9/30/2006 12:59'!
applicationName
	^ 'Windows Example'! !

!SWTWindowsClientApplication methodsFor: 'private' stamp: 'dgd 11/7/2006 10:30'!
createWindowsIn: aPanel

	| button |
	aPanel addWidget: (SWTWindow title: 'Window A').
	aPanel lastWidget
		addContentsWidget: (SWTText contents: 'Sample contents');
		backgroundColor: Color lightGreen;
		topLeft: 20@60.

	aPanel addWidget: (SWTWindow title: 'Window B').
	aPanel lastWidget
		showTitleBar: false;
		addContentsWidget: (SWTText contents: 'Sample contents');
		dragOpacity: 0.8;
		backgroundColor: Color lightRed;
		topLeft: 60@210.

	aPanel addWidget: (SWTWindow title: 'Window C').
	aPanel lastWidget
		opacity: 0.4;
		dragOpacity: 0.8;
		topLeft: 230@240;
		extent: 200@180.

	aPanel addWidget: (SWTWindow title: 'Window D').
	aPanel lastWidget
		showCloseButton: false;
		backgroundColor: Color yellow lighter;
		opacity: 0.8;
		topLeft: 260@260";
		extent: 400@150".

	button := SWTButton caption: 'add contents'.
	button
		model: aPanel lastWidget;
		onClick:[:event | button model addContentsWidget: (SWTText contents: 'Bla, bla, bla, bla.!!. Foo, foo, foo.') ].

	aPanel lastWidget
		addContentsWidget: button.
! !

!SWTWindowsClientApplication methodsFor: 'configuration' stamp: 'dgd 11/6/2006 16:39'!
initializeWidgets
	"Initialize the receiver's widgets"

	| root |

	root := self rootWidget.

	root addWidget: (toolbarPanel := SWTPanel new).
	root lastWidget
		padding: 0.5 percent;
		backgroundColor: Color green muchLighter;
		width: 99 percent.

	toolbarPanel addWidget:(SWTButton caption: 'cascade windows' onClick:[:event | self rootWidget cascadeWindows ]).
	toolbarPanel addWidget:(SWTButton caption: 'arrange windows' onClick:[:event | self rootWidget arrangeWindows ]).
	toolbarPanel addWidget:(SWTButton caption: 'randomize windows' onClick:[:event | self randomizeWindows ]).

	root viewPort: [self viewPort].

	self createWindowsIn: root.
! !

!SWTWindowsClientApplication methodsFor: 'configuration' stamp: 'dgd 10/2/2006 10:49'!
randomizeWindows

	| vp root  |

	root := self rootWidget.

	vp := root viewPort.

	root windows do:[:each |
		| maxX maxY newPos |

		maxX := vp width - each width.
		maxY := vp height - each height.

		newPos := maxX atRandom @ maxY atRandom.

		each animatePositionTo: newPos + vp topLeft.
	].
! !

!SWTWindowsClientApplication methodsFor: 'configuration' stamp: 'dgd 10/2/2006 10:46'!
viewPort
	"Answer the viewport area"

	^ self rootWidget bounds top: toolbarPanel bottom + 1! !

S2SObject subclass: #SWTDomDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTDomDecorator methodsFor: 'decoration' stamp: 'dgd 11/6/2006 18:11'!
decorate: aDom
	self subclassResponsibility! !

!SWTDomDecorator methodsFor: 'as yet unclassified' stamp: 'dgd 11/6/2006 18:28'!
domCreateElement: type
	^ self jsLiteral: 'document.createElement(type)'.! !

SWTDomDecorator subclass: #SWTShadowDomDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTShadowDomDecorator methodsFor: 'decoration' stamp: 'dgd 11/6/2006 18:24'!
createDivOfClass: classString

	| div |

	div := self domCreateElement: 'div'.
	div jsSet: #className to: classString.
	div jsPerform: #setAttribute with: 'class' with: classString.

	^ div! !

!SWTShadowDomDecorator methodsFor: 'decoration' stamp: 'dgd 11/7/2006 10:06'!
decorate: aDom

	| o1 o2 sb ib |

	o1 := self createDivOfClass: 'outerpair1'.
	o2 := self createDivOfClass: 'outerpair2'.
	sb := self createDivOfClass: 'shadowbox'.
	ib := self createDivOfClass: 'innerbox'.

	o1 jsPerform: #appendChild with: o2.
	o2 jsPerform: #appendChild with: sb.
	sb jsPerform: #appendChild with: ib.
	ib jsPerform: #appendChild with: aDom.

	^  o1! !

!SWTShadowDomDecorator methodsFor: 'decoration' stamp: 'dgd 11/6/2006 19:46'!
oldDecorate: aDom

	| w1 w2 w3 |

	w1 := self createDivOfClass: 'w1'.
	w2 := self createDivOfClass: 'w2'.
	w3 := self createDivOfClass: 'w3'.

	w1 jsPerform: #appendChild with: w2.
	w2 jsPerform: #appendChild with: w3.
	w3 jsPerform: #appendChild with: aDom.

	^  w1! !

S2SObject subclass: #SWTEvent
	instanceVariableNames: 'source domEvent type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTEvent class methodsFor: 'instance creation' stamp: 'dgd 11/3/2007 18:13'!
type: typeSymbol source: aWidget domEvent: aDomEvent
	^ self new initializeType: typeSymbol source: aWidget domEvent: aDomEvent! !

!SWTEvent methodsFor: 'accessing - keyboard' stamp: 'dgd 9/5/2006 10:33'!
altKey
	^ domEvent jsGet: #altKey! !

!SWTEvent methodsFor: 'accessing - keyboard' stamp: 'dgd 9/5/2006 10:33'!
ctrlKey
	^ domEvent jsGet: #ctrlKey! !

!SWTEvent methodsFor: 'accessing' stamp: 'dgd 9/4/2006 21:05'!
domEvent
	"Answer the receiver's domEvent."
	^ domEvent! !

!SWTEvent methodsFor: 'private' stamp: 'dgd 8/9/2006 12:30'!
getEvent: anEvent
	"PRIVATE - get the dom event considering the browser differences"

	^ self jsLiteral: 'anEvent ? anEvent : window.event'.
! !

!SWTEvent methodsFor: 'initialization' stamp: 'dgd 11/3/2007 18:13'!
initializeType: typeSymbol source: aWidget domEvent: aDomEventOrNil
	"Initialize the receiver's source"
	type := typeSymbol.
	source := aWidget.
	domEvent := self getEvent: aDomEventOrNil.
! !

!SWTEvent methodsFor: 'accessing - keyboard' stamp: 'dgd 10/9/2006 11:12'!
keyCode
	^ domEvent jsGet: #keyCode! !

!SWTEvent methodsFor: 'accessing - mouse' stamp: 'dgd 12/13/2006 11:32'!
pointerX
	| de |
	de := self domEvent.
	^ self jsLiteral: 'de.pageX || (de.clientX + (document.documentElement.scrollLeft || document.body.scrollLeft))'! !

!SWTEvent methodsFor: 'accessing - mouse' stamp: 'dgd 12/13/2006 11:32'!
pointerY
	| de |
	de := self domEvent.
	^ self jsLiteral: 'de.pageY || (de.clientY + (document.documentElement.scrollTop || document.body.scrollTop))'! !

!SWTEvent methodsFor: 'accessing - mouse' stamp: 'dgd 12/13/2006 11:32'!
position
	^ self pointerX @ self pointerY! !

!SWTEvent methodsFor: 'accessing' stamp: 'dgd 12/13/2006 11:27'!
preventDefault

	| de |

	de := self domEvent.

	(self jsLiteral:'de.preventDefault')
		inlineIfTrue:[ de jsPerform: #preventDefault ]
		ifFalse:[ de jsSet: #returnValue to: true ].
! !

!SWTEvent methodsFor: 'printing' stamp: 'dgd 12/13/2006 11:33'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPutAll: ' type=(';
		print: type;
		nextPutAll: '), source=(';
		print: source;
		nextPutAll: ')'.
"
	aStream nextPutAll: ', domEvent:'.
	aStream print: domEvent.
"! !

!SWTEvent methodsFor: 'accessing - mouse' stamp: 'dgd 12/13/2006 11:31'!
relativePosition
	"Answer the position relative to the source widget"

	^ self position - source position! !

!SWTEvent methodsFor: 'accessing - keyboard' stamp: 'dgd 9/5/2006 10:33'!
shiftKey
	^ domEvent jsGet: #shiftKey! !

!SWTEvent methodsFor: 'accessing' stamp: 'dgd 8/9/2006 12:08'!
source
	"Answer the receiver's source. It means the widget thet generated the event."
	^ source! !

!SWTEvent methodsFor: 'accessing' stamp: 'dgd 12/13/2006 11:27'!
stopPropagation

	| de |

	de := self domEvent.

	(self jsLiteral:'de.stopPropagation')
		inlineIfTrue:[ de jsPerform: #stopPropagation ]
		ifFalse:[ de jsSet: #cancelBubble to: true ].
! !

!SWTEvent methodsFor: 'accessing' stamp: 'dgd 10/9/2006 11:05'!
type
	"Answer the receiver's type."
	^ type! !

S2SObject subclass: #SWTMessageSend
	instanceVariableNames: 'receiver selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC'!

!SWTMessageSend class methodsFor: 'instance creation' stamp: 'dgd 6/12/2007 10:45'!
receiver: anObject selector: aSymbol
	^ self new initializeReceiver: anObject selector: aSymbol! !

!SWTMessageSend methodsFor: 'initialization' stamp: 'dgd 10/15/2006 18:37'!
initializeReceiver: receiverObject selector: aSymbol
	receiver := receiverObject.
	selector := aSymbol asSelector.
! !

!SWTMessageSend methodsFor: 'printing' stamp: 'dgd 6/13/2007 12:47'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPutAll: ', receiver:(';
		print: receiver;
		nextPutAll: '), selector:';
		print: selector.
! !

!SWTMessageSend methodsFor: 'accessing' stamp: 'dgd 10/15/2006 18:33'!
receiver
	^ receiver! !

!SWTMessageSend methodsFor: 'accessing' stamp: 'dgd 10/15/2006 18:33'!
selector
	^ selector! !

!SWTMessageSend methodsFor: 'evaluating' stamp: 'dgd 10/15/2006 18:20'!
value
	^ receiver perform: selector! !

!SWTMessageSend methodsFor: 'evaluating' stamp: 'dgd 10/15/2006 18:37'!
value: anObject
	^ receiver perform: selector with: anObject! !

!SWTMessageSend methodsFor: 'evaluating' stamp: 'dgd 11/5/2007 19:06'!
value: anObject value: anotherObject
	^ receiver perform: selector with: anObject with: anotherObject! !

S2SObject subclass: #SWTScheduler
	instanceVariableNames: 'deferredUIMessageList effectList stepList onStartingEffectHandlers onStoppingEffectHandlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTScheduler methodsFor: 'deferred ui messaging' stamp: 'dgd 10/19/2007 12:17'!
addDeferredUIMessage: valuableObject

	self addDeferredUIMessage: valuableObject at: Time timestamp.
! !

!SWTScheduler methodsFor: 'deferred ui messaging' stamp: 'dgd 10/19/2007 12:16'!
addDeferredUIMessage: valuableObject at: scheduledTimeNumber

	deferredUIMessageList add: { valuableObject. scheduledTimeNumber }.

! !

!SWTScheduler methodsFor: 'testing' stamp: 'dgd 10/9/2007 20:11'!
anyEffectAffectsWidget: aWidget

	effectList inlineDo:[:pair |
		(pair first affectsWidget: aWidget) inlineIfTrue:[
			^ true
		].
	]. 

	^ false! !

!SWTScheduler methodsFor: 'update cycle' stamp: 'dgd 11/1/2007 13:56'!
doOneCycle
	"Perform periodic activity inbetween event cycles"

	| now effectsToStop effect stress |

	now := Time timestamp.

	"deferred UI messages "
	deferredUIMessageList isEmpty inlineIfFalse: [
		| valuableObjects |
"
		valuableObjects := deferredUIMessageList
											select:[:pair | pair second <= now]
											thenCollect:[:pair | pair first].
"
		valuableObjects := OrderedCollection new.
		deferredUIMessageList inlineDo:[:pair |
			(pair second <= now) inlineIfTrue:[
				valuableObjects add: pair first.
			].
		].

		valuableObjects inlineDo:[:valuableObject |
			deferredUIMessageList removeAllSuchThat: [:pair | pair first == valuableObject].

			valuableObject value.
		].
	].

	"stress testing"
	stress := effectList size // 4.
	effectList inlineDo:[:triplet |
		effect := triplet first.
		effect updateStress: stress.
	].


	"run effect list"
	effectsToStop := OrderedCollection new.
	effectList inlineDo:[:triplet |
		(self jsLiteral: 'triplet[1] <= now') inlineIfTrue:[
			effect := triplet first.

			(self jsLiteral: 'triplet[2] == false') inlineIfTrue:[
				triplet at: 3 put: true.
				effect start.
			].

			effect doStep: now.
			triplet at: 2 put: "(effect stepTime) + now." (self jsLiteral: 'effect.stepTime() + now').

			(effect isDone: now) inlineIfTrue:[
					effectsToStop add: effect.
			].
		].
	].
	effectsToStop inlineDo:[:each | self stopEffect: each].


	"run step list"
	stepList inlineDo:[:pair |
		(self jsLiteral: 'pair[1] <= now') inlineIfTrue:[
			pair first step.
			pair at: 2 put: "(pair first stepTime) + now." (self jsLiteral: 'pair[0].stepTime() + now').
		].
	].
! !

!SWTScheduler methodsFor: 'stepping' stamp: 'dgd 6/14/2007 15:02'!
forceStepFor: aWidget

	self startStepping: aWidget at: Time timestamp.! !

!SWTScheduler methodsFor: 'testing' stamp: 'dgd 10/20/2007 17:19'!
hasEffectsRunning

	^ effectList notEmpty! !

!SWTScheduler methodsFor: 'initialization' stamp: 'dgd 10/20/2007 17:53'!
initialize
	"Initialize the receiver"

	super initialize.

	deferredUIMessageList := OrderedCollection new. "Holds a collection of 'pairs' {valuableObject. scheduledTime}"
	effectList := OrderedCollection new. "Holds a collection of 'tripplets' {effect. scheduledTime. startedBoolean}"
	stepList := OrderedCollection new. "Holds a collection of 'pairs' {morph. scheduledTime}"

	"lastStepTime := 0."

	onStartingEffectHandlers := OrderedCollection new.
	onStoppingEffectHandlers := OrderedCollection new.
! !

!SWTScheduler methodsFor: 'events' stamp: 'dgd 10/20/2007 17:52'!
onStartingEffects: aBlock 
	"registers a block, to evaluate, when starting effects event occurs"

	onStartingEffectHandlers add: aBlock.
! !

!SWTScheduler methodsFor: 'events' stamp: 'dgd 10/20/2007 17:52'!
onStoppingEffects: aBlock 
	"registers a block, to evaluate, when stopping effects event occurs"

	onStoppingEffectHandlers add: aBlock.
! !

!SWTScheduler methodsFor: 'effects' stamp: 'dgd 10/20/2007 17:44'!
startEffect: anEffect at: scheduledTimeNumber

"
	effectList inlineDo:[:each |
		(each first == anEffect) inlineIfTrue:[
			each at: 2 put: scheduledTimeNumber.

			^ self
		].
	].
"
	effectList add: {anEffect. scheduledTimeNumber. false}.
	effectList size = 1 inlineIfTrue:[
		self startingEffects.
	].
! !

!SWTScheduler methodsFor: 'effects' stamp: 'dgd 10/20/2007 17:16'!
startEffect: anEffect in: delayTimeNumber

	self startEffect: anEffect at: (Time timestamp + delayTimeNumber).
! !

!SWTScheduler methodsFor: 'events' stamp: 'dgd 10/20/2007 17:58'!
startingEffects

	onStartingEffectHandlers inlineDo:[:handler |
		handler value.
	].
! !

!SWTScheduler methodsFor: 'stepping' stamp: 'dgd 10/20/2007 17:17'!
startStepping: aWidget at: scheduledTimeNumber
	"Add the given widget to the step list. Do nothing if it is already being stepped."

	stepList inlineDo:[:each |
		(each first == aWidget) inlineIfTrue:[
			each at: 2 put: scheduledTimeNumber.

			^ self
		].
	].

	stepList add: {aWidget. scheduledTimeNumber}.
! !

!SWTScheduler methodsFor: 'effects' stamp: 'dgd 10/20/2007 17:44'!
stopAllEffectsForWidget: aWidget

	effectList
		select:[:each | each first widget == aWidget ]
		thenDo: [:each | each first stop].

	effectList := effectList reject:[:each | each first widget == aWidget ].
	effectList isEmpty inlineIfTrue:[
		self stoppingEffects.
	].
! !

!SWTScheduler methodsFor: 'effects' stamp: 'dgd 10/20/2007 17:44'!
stopEffect: anEffect

	effectList removeAllSuchThat: [:each | each first == anEffect ].
	effectList isEmpty inlineIfTrue:[
		self stoppingEffects.
	].

	anEffect stop.
! !

!SWTScheduler methodsFor: 'events' stamp: 'dgd 10/20/2007 17:58'!
stoppingEffects

	onStoppingEffectHandlers inlineDo:[:handler |
		handler value.
	].
! !

!SWTScheduler methodsFor: 'stepping' stamp: 'dgd 6/14/2007 10:40'!
stopStepping: aWidget

	stepList := stepList reject:[:each | each first == aWidget ].
! !

S2SObject subclass: #SWTServerApplicationProxy
	instanceVariableNames: 'clientApplication invokeId asyncMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTServerApplicationProxy class methodsFor: 'instance creation' stamp: 'dgd 9/3/2006 13:00'!
clientApplication: aClientApplication
	^ self new initializeClientApplication: aClientApplication! !

!SWTServerApplicationProxy methodsFor: 'accessing' stamp: 'dgd 10/25/2006 15:13'!
application
	^ clientApplication! !

!SWTServerApplicationProxy methodsFor: 'accessing' stamp: 'dgd 10/22/2007 12:49'!
asyncMode: aBlock
	"evaluates the given block in async mode"

	asyncMode := true.
	aBlock value.
	asyncMode := false.
! !

!SWTServerApplicationProxy methodsFor: 'initialization' stamp: 'dgd 10/22/2007 12:42'!
initialize
	super initialize.

	invokeId := 0.
	asyncMode := false.
! !

!SWTServerApplicationProxy methodsFor: 'initialization' stamp: 'dgd 9/3/2006 13:00'!
initializeClientApplication: aClientApplication
	"Initialize the receiver's client application"

	clientApplication := aClientApplication! !

!SWTServerApplicationProxy methodsFor: 'private' stamp: 'dgd 10/22/2007 13:53'!
invokeJsonRPCMethod: selector arguments: args

	"
	For senders see:
		SWTServerApplication class>>serverApplicationProxySource
	"

	invokeId := invokeId + 1.

	^ self application
				invokeJsonRPCMethod: selector
				arguments: args
				asynchronous: asyncMode
				invokeId: invokeId.
! !

S2SObject subclass: #SWTStackCommand
	instanceVariableNames: 'counter do unDo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTStackCommand class methodsFor: 'instance creation' stamp: 'dgd 10/20/2007 19:11'!
do: doBlock unDo: unDoBlock
	^ self new initializeDo: doBlock unDo: unDoBlock! !

!SWTStackCommand methodsFor: 'doing' stamp: 'dgd 10/21/2007 12:32'!
doIt
	counter := counter + 1.

	(counter = 1) inlineIfTrue:[	
"		self log: self asString , ' -> first #do, real #do'."
		do value.
	]
"	ifFalse:[
		self log: self asString , ' -> not first #do'.
	].
"! !

!SWTStackCommand methodsFor: 'initialization' stamp: 'dgd 10/20/2007 19:09'!
initialize
	"initialize the receiver"

	super initialize.

	counter := 0.
! !

!SWTStackCommand methodsFor: 'initialization' stamp: 'dgd 10/20/2007 19:11'!
initializeDo: doBlock unDo: unDoBlock
	do := doBlock.
	unDo := unDoBlock.
! !

!SWTStackCommand methodsFor: 'accessing' stamp: 'dgd 10/20/2007 19:16'!
isActive
	^ counter isZero not! !

!SWTStackCommand methodsFor: 'printing' stamp: 'dgd 10/20/2007 19:31'!
printOn: aStream

	super printOn: aStream.

	aStream
		nextPutAll: ' counter: ';
		nextPutAll: counter asString
! !

!SWTStackCommand methodsFor: 'doing' stamp: 'dgd 10/21/2007 12:33'!
unDoIt
	counter > 0 inlineIfFalse:[
"		self log: self asString, 'invalid #unDo'."
		^ self
	].

	counter := counter - 1.

	counter isZero inlineIfTrue:[
"		self log: self asString , ' -> last #unDo, real #unDo'."
		unDo value.
	]
"	ifFalse:[
		self log: self asString , ' -> not last #unDo'.
	]
"! !

S2SObject subclass: #SWTStroke
	instanceVariableNames: 'points color width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Misc'!

!SWTStroke class methodsFor: 'instance creation' stamp: 'dgd 10/14/2006 12:29'!
constructFromJson: aDictionary
	^ self
			points: ((aDictionary at: 'points') collect: [:each | Point constructFromJson: each] )
			color: (Color constructFromJson: (aDictionary at: 'color'))
			width: (aDictionary at: 'width').
! !

!SWTStroke class methodsFor: 'instance creation' stamp: 'dgd 10/14/2006 12:19'!
points: aCollection color: aColor width: anInteger
	^ self new initializePoints: aCollection color: aColor width: anInteger! !

!SWTStroke methodsFor: 'accessing' stamp: 'dgd 10/19/2006 13:54'!
color
	^ color! !

!SWTStroke methodsFor: 'drawing' stamp: 'dgd 10/18/2006 16:58'!
drawOn: aSWTCanvas

	| priorPoint |

	priorPoint := nil.

	aSWTCanvas roundLineCap.

	points inlineDo:[:currentPoint |
		priorPoint isNil inlineIfFalse:[
			aSWTCanvas
					line: priorPoint
					to: currentPoint
					width: width
					color: color.
		].

		priorPoint := currentPoint.
	].
! !

!SWTStroke methodsFor: 'initialization' stamp: 'dgd 10/14/2006 12:18'!
initialize
	"Initialize the receiver"

	super initialize.

	points := OrderedCollection new.
	color := Color blue alpha: 0.75.
	width := 2.
! !

!SWTStroke methodsFor: 'initialization' stamp: 'dgd 10/14/2006 12:19'!
initializePoints: aCollection color: aColor width: anInteger
	"Initialize the receiver"

	points := aCollection.
	color := aColor.
	width := anInteger.
! !

!SWTStroke methodsFor: 'accessing' stamp: 'dgd 10/19/2006 13:54'!
points
	^ points! !

!SWTStroke methodsFor: 'printing' stamp: 'dgd 10/17/2006 20:43'!
printOn: aStream
	super printOn: aStream.

	aStream nextPutAll: ' color: ' , color asString , ', width: ' , width asString , ', points: ' , points asString! !

!SWTStroke methodsFor: 'simplifying' stamp: 'dgd 10/14/2006 12:33'!
simplify

	| simplifier |

	simplifier := StrokeSimplifier new.
	points do:[:eachPoint | simplifier add: eachPoint].
	simplifier finalizeStroke.

	points := simplifier finalStroke.
! !

!SWTStroke methodsFor: 'simplifying' stamp: 'dgd 10/14/2006 12:52'!
simplify2

	points := StrokeSimplifier smoothen: points length: 10.
! !

!SWTStroke methodsFor: 'accessing' stamp: 'dgd 10/19/2006 13:54'!
width
	^ width! !

!S2SStringExtension methodsFor: '*SWT-converting' stamp: 'dgd 10/15/2006 18:38'!
asSelector
	^ self copyReplaceAll: ':' with: '_'! !

!S2SStringExtension methodsFor: '*SWT-views' stamp: 'dgd 10/15/2006 17:20'!
defaultViewClass
	^ SWTEditInPlaceText! !

AComet subclass: #SWTApplicationRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTApplicationRunner class methodsFor: 'running' stamp: 'dgd 12/27/2006 10:45'!
assembleService: assembly

	assembly alias: '/JavascriptSource' to: [
		assembly addPlug: (MessageSend
									receiver: self instance
									selector: #processJavascriptSourceRequest:
									argument: nil).
	].

	assembly alias: '/resources' to: [
		assembly documentRoot: (FileDirectory default fullNameFor: 'resources').
		assembly directoryIndex: 'index.html'.
		assembly serveFiles.
	].

	assembly alias: '/hook' to: [
		assembly addPlug: (MessageSend
									receiver: self instance
									selector: #processHookRequest:
									argument: nil).
	].


	assembly alias: '/xul' to: [
		assembly addPlug: (MessageSend
									receiver: self instance
									selector: #processXULRequest:
									argument: nil).
	].

	assembly addPlug: (MessageSend
								receiver: self instance
								selector: #process:
								argument: nil).
! !

!SWTApplicationRunner class methodsFor: 'class initialization' stamp: 'dgd 9/8/2006 11:58'!
initialize
	self openWorkspace.
! !

!SWTApplicationRunner class methodsFor: 'utilities' stamp: 'dgd 9/8/2006 12:06'!
openWorkspace
	"
	SWTApplicationRunner openWorkspace.
	"
	'"
SWT - Squeak Web Toolkit

How to run:
- Check the port in SWTApplicationRunner class>>servicePort, the default is 2222
- Start the service
- open your internet browser pointing to http://localhost:2222
- Select one of the application to run
	- Ping Pong: is the simplest example that shows the complete arquitecture. It''s a good entry point.
	- Example Applitation: An assorted set of widgets showing different features of the framework.
	- Social Shopping: The internet-browsers can be used in better ways than today, just take a look at this proof of concept.  It''s a type of colaborative-shopping-cart.
"

SWTApplicationRunner start.
SWTApplicationRunner stop.
SWTApplicationRunner reset.


"Social Shopping"
SWTSocialShoppingSystem clearInstance.
SWTSocialShoppingSystem instance.
'  openInWorkspaceWithTitle: 'SWT - Squeak Web Toolkit'! !

!SWTApplicationRunner class methodsFor: 'running' stamp: 'dgd 8/31/2006 20:50'!
serviceName
	"Answer the receiver's intented service name"

	^ 'SWT - Squeak Widget Toolkit'! !

!SWTApplicationRunner class methodsFor: 'running' stamp: 'dgd 8/31/2006 20:50'!
servicePort
	"Answer the receiver's intented service port"

	^ 2222! !

!SWTApplicationRunner methodsFor: 'private - processing' stamp: 'dgd 11/2/2007 08:23'!
applicationsListHtml

	| response |

	response := String new writeStream.

	response nextPutAll: '<html>'.
	response nextPutAll: '<head>'.
	response nextPutAll: '<title>'.
	response nextPutAll: 'SWT Application Runner'.
	response nextPutAll: '</title>'.

	response nextPutAll: '<script>
	function openWindow(windowUrl) {
		var params, newwin;

		if (navigator.appName == "Microsoft Internet Explorer"){
			params = "fullscreen=yes";
		}
		else {
			params = "width=" + screen.availWidth + ", height=" + screen.availHeight + ", top=0, left=0";
		}
		params += ",directories=no,location=no,menubar=no,scrollbars=no,status=no,toolbar=no,resizable=yes,titlebar=no,dialog=no,close=no";

		newwin = window.open(windowUrl, windowUrl, params);
		if (window.focus) {
			newwin.focus();
		}

		return false;
}
</script>'.

	response nextPutAll: '</head>'.
	response nextPutAll: '<body>'.

	response nextPutAll: '<h3>Select the application to run</h3>'.
	response nextPutAll: '<ul>'.
	(SWTServerApplication allSubclasses asSortedCollection: [:x :y | x clientSideApplicationClass applicationName <= y clientSideApplicationClass applicationName])
		do:[:each |
			| appName |
			appName := each clientSideApplicationClass applicationName.
			response nextPutAll: '<li>'.
			response nextPutAll: '<a href="' , each name , '">'.
			response nextPutAll: appName.
			response nextPutAll: '</a>'.

			response nextPutAll: ' (<a href="#" onClick=''return openWindow("' , each name , '");''>open in a new window</a>&nbsp;<a href="/xul/' , each name , '">XUL</a>)'.

			response cr.

		].
	response nextPutAll: '</ul>'.

	response nextPutAll: '</body>'.
	response nextPutAll: '</html>'.

	^ response contents.
! !

!SWTApplicationRunner methodsFor: 'private' stamp: 'dgd 9/3/2006 18:01'!
cometSocketClass

	^ SWTCometSocket! !

!SWTApplicationRunner methodsFor: 'private' stamp: 'dgd 11/9/2007 12:16'!
initCometSocket: aCometSocket 

	| script |

	script := '
app = top.app;
app.justConnectedListenerId_({1});
' format: {
		aCometSocket listenerId
	}.

	^ self script: script.
! !

!SWTApplicationRunner methodsFor: 'rpc' stamp: 'dgd 10/15/2007 11:28'!
jsonReceiverFor: aDictionary request: aRequest ifAbsent: aBlock

	| listId socket |

	listId := aDictionary
						at: 'listener_id'
						ifAbsent: [
							self log: 'parameter ''listener_id'' is missing'.
							^ aBlock value.
						].

	socket := self
					listenerId: listId asNumber
					ifAbsent: [
							self log: 'invalid listener_id: #' , listId asString.
							^ aBlock value.
					].

	^ socket serverApplication.
! !

!SWTApplicationRunner methodsFor: 'rpc' stamp: 'dgd 10/31/2007 12:34'!
jsonResponseID: id result: result error: error receiver: receiverObject

	| dict string |

	dict := Dictionary new.
	dict at: 'id' put: id.
	dict at: 'error' put: error.
	dict at: 'result' put: result.

	string := (dict jsSerializedContext: receiverObject) convertToUTF8.

	self flag: #todo. "removes hack"
	(result class == CGSolitarioEscaleraCardGame) ifTrue:[
		"HACK para probar que el cliente tiene un freshvalue incorrecto"
		"generar un evento posterior a la serializacion para forzar un caso donde un aspect tiene un freshvalue viejo"
"
		result mainDeck turnTopmostCard.
"
	].

	^ HttpResponse
			fromString: string
			contentType: MIMEDocument contentTypePlainText.
! !

!SWTApplicationRunner methodsFor: 'events - connection' stamp: 'dgd 9/20/2006 17:42'!
justConnected: aCometSocket request: aRequest

	super justConnected: aCometSocket request: aRequest.

	self swtSockets
		do: [:each | each justConnected: aCometSocket request: aRequest ].
! !

!SWTApplicationRunner methodsFor: 'events - connection' stamp: 'dgd 10/15/2007 11:40'!
justDisconnected: aCometSocket

	super justDisconnected: aCometSocket.

	self swtSockets
		do: [:each | each justDisconnected: aCometSocket ].
! !

!SWTApplicationRunner methodsFor: 'processing - xul' stamp: 'dgd 12/27/2006 11:03'!
mainXUL
	^ self xulTitle: 'SWT Runner' url: ''! !

!SWTApplicationRunner methodsFor: 'private - processing' stamp: 'dgd 8/31/2006 21:04'!
notFoundResponse

	^ HttpResponse 
				status: #notFound 
				contents: 'The object you requested was not found on this server.'
! !

!SWTApplicationRunner methodsFor: 'pushing - pinging' stamp: 'dgd 11/9/2007 12:16'!
pingBlock
	^ [:socket | self script: 'if (app) { app.serverHasContacted() }' ] fixTemps
! !

!SWTApplicationRunner methodsFor: 'processing' stamp: 'dgd 10/15/2007 11:27'!
processHookRequest: aRequest

	| url hookSelector receiver |

	url := aRequest url.

	(url beginsWith: '/hook')
		ifTrue:[url := url allButFirst: 5].

	(url beginsWith: '/')
		ifTrue:[url := url allButFirst].

	hookSelector := ((url endsWith: ':')
								ifTrue:[url]
								ifFalse:[url , ':']) asSymbol.

	receiver := self
					jsonReceiverFor: aRequest fields
					request: aRequest
					ifAbsent: [^ nil].

	^ receiver perform: hookSelector with: aRequest.
! !

!SWTApplicationRunner methodsFor: 'processing' stamp: 'dgd 10/2/2006 12:55'!
processJavascriptSourceRequest: aRequest 

	| pair applicationClassName sourceName response klass |

	pair := self sourceNameFrom: aRequest.

	applicationClassName := pair first: (pair indexOf: $/) - 1.
	sourceName := pair allButFirst: (pair indexOf: $/).

	klass := Smalltalk
						at: applicationClassName asSymbol
						ifAbsent:[ ^ self notFoundResponse ].

	(klass isValidClassName: sourceName) ifFalse:[
		^ self notFoundResponse
	].

	response := (klass updateLoadProgressIndicator: sourceName) , (klass sourceForClass: sourceName).

	^ HttpResponse
				fromString: response
				contentType: 'text/javascript'
! !

!SWTApplicationRunner methodsFor: 'processing - xul' stamp: 'dgd 12/27/2006 11:04'!
processXULRequest: aRequest 

	| url klass |

	url := aRequest url.

	(url beginsWith: '/')
		ifTrue: [url := url allButFirst].
	(url beginsWith: 'xul')
		ifTrue: [url := url allButFirst: 3].
	(url beginsWith: '/')
		ifTrue: [url := url allButFirst].

	url isEmpty ifTrue: [
		^ HttpResponse fromString: self mainXUL contentType: 'text/xml'
	].

	klass := Smalltalk
						at: url asSymbol
						ifAbsent:[ ^ self notFoundResponse ].

	^ HttpResponse
			fromString: (self xulTitle: klass clientSideApplicationClass applicationName url: klass name)
			contentType: 'text/xml'
! !

!SWTApplicationRunner methodsFor: 'processing' stamp: 'dgd 10/24/2006 13:19'!
process: aRequest 

	| url className klass response |

	url := aRequest url.

	(url = '/')
		ifTrue:[ ^ self applicationsListHtml asHttpResponseTo: aRequest ].

	className := url allButFirst.
	
	klass := Smalltalk
						at: className asSymbol
						ifAbsent:[ ^ self notFoundResponse ].

	(klass inheritsFrom: SWTServerApplication)
		ifFalse:[ ^ self notFoundResponse ].

	response := HttpResponse fromString: klass htmlSource.
	response fieldAt: 'Expires' put: '-1'"DateAndTime now asHttpString".
	response fieldAt: 'Cache-Control' put: 'no-cache, must-revalidate, no-store'.
	response fieldAt: 'Pragma' put: 'no-cache'.

	^  response
! !

!SWTApplicationRunner methodsFor: 'private - processing' stamp: 'dgd 9/1/2006 19:47'!
sourceNameFrom: aRequest 

	| sourceName |

	sourceName := aRequest fields at: 'source' ifAbsent:[
		| path |
		path := ModCore path.
		(path beginsWith: '/')
			ifTrue:[path := path allButFirst].
		path
	].

	(sourceName endsWith:'.js')
		ifTrue:[sourceName := sourceName allButLast: 3].

	^ sourceName
! !

!SWTApplicationRunner methodsFor: 'accessing' stamp: 'dgd 9/20/2006 17:17'!
swtSockets
	^ self sockets select: [:each | each isKindOf: SWTCometSocket]
! !

!SWTApplicationRunner methodsFor: 'accessing' stamp: 'dgd 9/20/2006 17:18'!
swtSocketsOfApplication: aServerApplicationClass
	^ self swtSockets select: [:each | each serverApplication class == aServerApplicationClass]
! !

!SWTApplicationRunner methodsFor: 'processing - xul' stamp: 'dgd 12/27/2006 10:52'!
xulHeight
	^'768'! !

!SWTApplicationRunner methodsFor: 'processing - xul' stamp: 'dgd 4/18/2007 16:49'!
xulHideChrome
	^ 'false'! !

!SWTApplicationRunner methodsFor: 'processing - xul' stamp: 'dgd 4/18/2007 16:50'!
xulSizeMode
"	^'maximized'"
	^ 'normal'
! !

!SWTApplicationRunner methodsFor: 'processing - xul' stamp: 'dgd 12/27/2006 11:03'!
xulTitle: aString url: url
	^'<?xml version="1.0"?>
<?xml-stylesheet href="chrome://communicator/skin/" type="text/css"?>

<window
	id="rootWindow"
	sizemode="' , self xulSizeMode , '" hidechrome="' , self xulHideChrome , '"
	centerscreen="true"
	width="' , self xulWidth , '" height="' , self xulHeight , '"
	title="' , aString , '"
	xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
	xmlns:html="http://www.w3.org/1999/xhtml">

		<browser type="content" src="http://localhost:2222/' , url , '" flex="1"/>

</window>
'! !

!SWTApplicationRunner methodsFor: 'processing - xul' stamp: 'dgd 12/27/2006 10:52'!
xulWidth
	^'1024'! !

!Symbol methodsFor: '*SWT-converting' stamp: 'dgd 10/15/2006 18:38'!
asSelector
	^ self! !

!S2SBooleanExtension methodsFor: '*SWT-views' stamp: 'dgd 10/25/2006 16:58'!
defaultViewClass
	^ SWTInputCheckbox! !

S2SObjectWithProperties subclass: #SWTWidget
	instanceVariableNames: 'parent dom domDecorator decoratedDom dropShadow deltaPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

SWTWidget subclass: #SWTBreak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTBreak methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 18:40'!
createDom

	^ self domCreateElement: 'br'
! !

SWTWidget subclass: #SWTCanvas
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Misc'!

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/13/2006 18:35'!
beginPath
	^ self context jsPerform: #beginPath! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/14/2006 12:14'!
buttLineCap
	^ self lineCap: 'butt'! !

!SWTCanvas methodsFor: 'drawing' stamp: 'dgd 10/13/2006 19:06'!
clear
	self clearRect: (0@0 extent: self extent).! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/13/2006 19:07'!
clearRect: aRectangle
	^ self context
				jsPerform: #clearRect
				with: aRectangle left with: aRectangle top with: aRectangle right with: aRectangle bottom! !

!SWTCanvas methodsFor: 'accessing' stamp: 'dgd 10/18/2006 16:33'!
context

	context isNil ifTrue:[
		| myDom |
		myDom := self dom.

		self jsLiteral: '
			// IE Canvas emulation
			if (!!myDom.getContext) {
				myDom = G_vmlCanvasManager.initElement(myDom);
				self._dom = myDom
			}'.

		context := myDom jsPerform: #getContext with: '2d'.
	].

	^ context! !

!SWTCanvas methodsFor: 'dom counterpart' stamp: 'dgd 10/18/2006 16:33'!
createDom

	| can |

	can := self domCreateElement: 'canvas'.
"
	self jsLiteral: '
		// IE Canvas emulation
		if (!!can.getContext) {
			can = G_vmlCanvasManager.initElement(can);
		}'.
"
	^ can
! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/14/2006 15:51'!
fillRect: aRectangle
	^ self context
				jsPerform: #fillRect
				with: aRectangle left with: aRectangle top with: aRectangle right with: aRectangle bottom! !

!SWTCanvas methodsFor: 'drawing' stamp: 'dgd 10/14/2006 15:57'!
fillRect: aRectangle color: aColor 

	aColor isTransparent ifTrue:[^ self].

	self isolated: [
		self setColor: aColor.
		self fillRect: aRectangle.
	].
! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/14/2006 16:01'!
fillStyle: aColorOrString
	^ self context jsSet: #fillStyle to: aColorOrString asColorString! !

!SWTCanvas methodsFor: 'drawing' stamp: 'dgd 10/14/2006 15:53'!
frameAndFillRectangle: aRectangle fillColor: fillColor borderWidth: borderWidth borderColor: borderColor 

	self fillRect: (aRectangle insetBy: borderWidth) color: fillColor.
	self strokeRect: aRectangle color: borderColor width: borderWidth.
! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/13/2006 18:55'!
globalAlpha: aNumber
	^ self context jsSet: #globalAlpha to: aNumber! !

!SWTCanvas methodsFor: 'accessing - geometry' stamp: 'dgd 10/13/2006 18:15'!
height: aNumber

	super height: aNumber.

	self dom
		jsSet: #height
		to: aNumber. 
! !

!SWTCanvas methodsFor: 'initialization' stamp: 'dgd 10/13/2006 18:14'!
initialize
	super initialize.

	self extent: 640@480.
! !

!SWTCanvas methodsFor: 'private' stamp: 'dgd 10/14/2006 15:56'!
isolated: aBlock

	self save.

	aBlock value.

	self restore.
! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/14/2006 12:14'!
lineCap: aString
	^ self context jsSet: #lineCap to: aString! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/13/2006 18:44'!
lineTo: aPoint
	^ self context jsPerform: #lineTo with: aPoint x with: aPoint y! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/13/2006 18:56'!
lineWidth: aNumber
	^ self context jsSet: #lineWidth to: aNumber! !

!SWTCanvas methodsFor: 'drawing' stamp: 'dgd 10/14/2006 15:57'!
line: fromPoint to: toPoint width: anInteger color: aColor

	self isolated: [
		self globalAlpha: aColor alpha.
		self strokeStyle: aColor.
		self lineWidth: anInteger.

		self beginPath.
		self moveTo: fromPoint.
		self lineTo: toPoint.
		self stroke.
	].
! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/13/2006 18:44'!
moveTo: aPoint
	^ self context jsPerform: #moveTo with: aPoint x with: aPoint y! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/13/2006 18:35'!
restore
	^ self context jsPerform: #restore! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/14/2006 12:14'!
roundLineCap
	^ self lineCap: 'round'! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/13/2006 18:35'!
save
	^ self context jsPerform: #save! !

!SWTCanvas methodsFor: 'drawing' stamp: 'dgd 10/14/2006 15:54'!
setColor: fillColor
	self globalAlpha: fillColor alpha.
	self fillStyle: fillColor.! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/14/2006 12:14'!
squareLineCap
	^ self lineCap: 'square'! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/13/2006 18:35'!
stroke
	^ self context jsPerform: #stroke! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/14/2006 15:51'!
strokeRect: aRectangle
	^ self context
				jsPerform: #strokeRect
				with: aRectangle left with: aRectangle top with: aRectangle right with: aRectangle bottom! !

!SWTCanvas methodsFor: 'drawing - canvas api' stamp: 'dgd 10/13/2006 18:55'!
strokeStyle: aColorOrString
	^ self context jsSet: #strokeStyle to: aColorOrString asColorString! !

!SWTCanvas methodsFor: 'accessing - geometry' stamp: 'dgd 10/13/2006 18:15'!
width: aNumber

	super width: aNumber.

	self dom
		jsSet: #width
		to: aNumber. 
! !

SWTWidget subclass: #SWTFocusWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

SWTFocusWidget subclass: #SWTButton
	instanceVariableNames: 'caption'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTButton class methodsFor: 'instance creation' stamp: 'dgd 8/9/2006 11:16'!
caption: aString
	"Answer a new instance of the receiver with the given caption"
	^ self new initializeCaption: aString! !

!SWTButton class methodsFor: 'instance creation' stamp: 'dgd 8/9/2006 11:39'!
caption: aString onClick: aBlock
	"Answer a new instance of the receiver with the given caption"
	^ (self caption: aString)
			onClick: aBlock;
			yourself! !

!SWTButton methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 18:40'!
createDom

	| button |

	button := self domCreateElement: 'button'.
	button jsSet: #innerHTML to: caption.

	^ button
! !

!SWTButton methodsFor: 'initialization' stamp: 'dgd 8/9/2006 11:17'!
initializeCaption: aString
	"Initialize the receiver's caption"

	caption := aString.
! !

!SWTFocusWidget methodsFor: 'events' stamp: 'dgd 6/13/2007 18:07'!
cleanUp

	| myDom |

	myDom := self dom.
	myDom jsSet: #onfocus to: nil.
	myDom jsSet: #onblur to: nil.

	super cleanUp.
! !

!SWTFocusWidget methodsFor: 'actions' stamp: 'dgd 9/5/2006 11:46'!
focus
	self dom focus! !

!SWTFocusWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:13'!
onBlur: aBlock
	"registers a block, to evaluate, when onBlur event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onBlurHandlers
						ifAbsentPut: [
							"is very first handler?"
							| handler |

							handler :=  [:domEvent | 
										| event |

										event := SWTEvent type: #Blur source: self domEvent: domEvent.

										(self valueOfProperty: #onBlurHandlers)
											do: [:each | each value: event].
									].

							self dom jsSet: #onblur to: handler.

							OrderedCollection new.
						].

	handlers add: aBlock.
! !

!SWTFocusWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:13'!
onFocus: aBlock
	"registers a block, to evaluate, when onFocus event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onFocusHandlers
						ifAbsentPut: [
							"is very first handler?"
							| handler |

							handler :=  [:domEvent | 
										| event |

										event := SWTEvent type: #Focus source: self domEvent: domEvent.

										(self valueOfProperty: #onFocusHandlers)
											do: [:each | each value: event].
									].

							self dom jsSet: #onfocus to: handler.

							OrderedCollection new.
						].

	handlers add: aBlock.
! !

SWTFocusWidget subclass: #SWTInput
	instanceVariableNames: 'onChange onKeyPress autoSetContents newContents contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

SWTInput subclass: #SWTInputCheckbox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTInputCheckbox class methodsFor: 'instance creation' stamp: 'dgd 10/22/2007 18:52'!
forAspect: anAspect

	| instance |

	instance := self
					contents: [ anAspect value ] "this block is to produce a delay on the aspect evaluation to make it happens after #onChangeSend:to: sending"
					onChange: [:event | anAspect value: event source newContents ].

	instance aspect: anAspect.

	anAspect onChangeSend: #contents: to: instance.
	anAspect onChangeSend: #highlight to: instance.

	instance
		autoSetContents: false.

	^ instance! !

!SWTInputCheckbox methodsFor: 'private' stamp: 'dgd 10/25/2006 18:12'!
contentsForDom
	^ super contentsForDom = true! !

!SWTInputCheckbox methodsFor: 'dom counterpart' stamp: 'dgd 10/25/2006 18:05'!
domContentsSelector

	^ #checked! !

!SWTInputCheckbox methodsFor: 'dom counterpart' stamp: 'dgd 10/25/2006 16:59'!
inputType
	^ 'checkbox'! !

SWTInput subclass: #SWTInputPassword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTInputPassword methodsFor: 'dom counterpart' stamp: 'dgd 11/14/2006 13:20'!
domContentsSelector

	^ #value! !

!SWTInputPassword methodsFor: 'dom counterpart' stamp: 'dgd 11/14/2006 13:20'!
inputType
	^ 'password'! !

SWTInput subclass: #SWTInputText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTInputText methodsFor: 'dom counterpart' stamp: 'dgd 10/25/2006 17:42'!
domContentsSelector

	^ #value! !

!SWTInputText methodsFor: 'dom counterpart' stamp: 'dgd 10/25/2006 16:46'!
inputType
	^ 'text'! !

!SWTInput class methodsFor: 'instance creation' stamp: 'dgd 10/25/2006 17:32'!
contents: aString
	^ self new initializeContents: aString! !

!SWTInput class methodsFor: 'instance creation' stamp: 'dgd 10/25/2006 17:32'!
contents: aString onChange: aBlock
	^ (self contents: aString)
			onChange: aBlock;
			yourself! !

!SWTInput methodsFor: 'accessing' stamp: 'dgd 10/25/2006 17:08'!
autoSetContents: aBoolean

	autoSetContents := aBoolean.
! !

!SWTInput methodsFor: 'events' stamp: 'dgd 6/13/2007 18:07'!
cleanUp

	| myDom |

	myDom := self dom.
	myDom jsSet: #onchange to: nil.
	myDom jsSet: #onkeypress to: nil.

	super cleanUp.
! !

!SWTInput methodsFor: 'accessing' stamp: 'dgd 10/25/2006 17:31'!
contents
	"Answer the receiver's contents"
	^ contents value! !

!SWTInput methodsFor: 'private' stamp: 'dgd 10/25/2006 18:12'!
contentsForDom
	^ self contents! !

!SWTInput methodsFor: 'accessing' stamp: 'dgd 10/25/2006 18:17'!
contents: anObject.
	self setContents: anObject.

	self updateDomValue.! !

!SWTInput methodsFor: 'dom counterpart' stamp: 'dgd 10/25/2006 18:10'!
createDom

	| input |

	input := self domCreateElement: 'input'.
	input jsSet: #type to: self inputType.

	^ input
! !

!SWTInput methodsFor: 'dom counterpart' stamp: 'dgd 12/27/2006 15:47'!
domContentsSelector

	^ self subclassResponsibility! !

!SWTInput methodsFor: 'private' stamp: 'dgd 10/25/2006 17:41'!
getDomValue
"
	^ self dom jsGet: #value
"

	| domSelector myDom |

	domSelector := self domContentsSelector.
	myDom := self dom.

	^ self jsLiteral: 'myDom[domSelector]'.
! !

!SWTInput methodsFor: 'initialization' stamp: 'dgd 10/25/2006 17:08'!
initialize
	super initialize.

	autoSetContents := true.! !

!SWTInput methodsFor: 'initialization' stamp: 'dgd 10/25/2006 17:32'!
initializeContents: aString
	contents := aString.! !

!SWTInput methodsFor: 'dom counterpart' stamp: 'dgd 11/14/2006 14:00'!
initializeDom
	super initializeDom.

	self updateDomValue.

	self onChange: [:event |
		autoSetContents ifTrue:[
			self setContents: newContents.
		].
	].
! !

!SWTInput methodsFor: 'dom counterpart' stamp: 'dgd 10/25/2006 16:45'!
inputType
	^ self subclassResponsibility! !

!SWTInput methodsFor: 'accessing' stamp: 'dgd 10/25/2006 17:14'!
newContents
	^ newContents! !

!SWTInput methodsFor: 'events' stamp: 'dgd 11/3/2007 18:17'!
onChange: aBlock 
	"registers a block, to evaluate, when onChange event occurs"

	"is very first handler?"
	onChange isNil ifTrue: [
		| handler |

		onChange := OrderedCollection new.

		handler :=  [:domEvent | 
					| event |

					event := SWTEvent type: #Change source: self domEvent: domEvent.

					newContents := self getDomValue.
					autoSetContents ifTrue:[
						self setContents: newContents.
					].

					onChange do: [:each | each value: event].

					true
				].

		self dom jsSet: #onchange to: handler.
	].

	onChange add: aBlock.
! !

!SWTInput methodsFor: 'events' stamp: 'dgd 11/3/2007 18:17'!
onKeyPress: aBlock 
	"registers a block, to evaluate, when onKeyPress event occurs"

	"is very first handler?"
	onKeyPress isNil ifTrue: [
		| handler |

		onKeyPress := OrderedCollection new.

		handler :=  [:domEvent | 
					| event returnValue |

					event := SWTEvent type: #KeyPress source: self domEvent: domEvent.

					newContents := self getDomValue.
					autoSetContents ifTrue:[
						self setContents: newContents.
					].

					returnValue := true.
					onKeyPress do: [:each |
						(each value: event) == false
							ifTrue:[returnValue := false].
					].

					returnValue
				].

		self dom jsSet: #onkeypress to: handler.
	].

	onKeyPress add: aBlock.
! !

!SWTInput methodsFor: 'private' stamp: 'dgd 10/25/2006 17:50'!
setContents: anObject
	contents := anObject.
! !

!SWTInput methodsFor: 'private' stamp: 'dgd 10/25/2006 18:12'!
updateDomValue

	| domSelector myDom con |
"
	self dom jsSet: #value to: self contents.
"
	domSelector := self domContentsSelector.
	myDom := self dom.
	con := self contentsForDom.

	self jsLiteral: 'myDom[domSelector] = con'.
! !

SWTFocusWidget subclass: #SWTPanel
	instanceVariableNames: 'children viewPortHandler windowZOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

SWTPanel subclass: #SWTCellPanel
	instanceVariableNames: 'innerDom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

!SWTCellPanel class methodsFor: 'instance creation' stamp: 'dgd 11/28/2006 19:54'!
forAspect: anAspect

	| instance allWidgets |

	allWidgets := anAspect value collect:[:each | each defaultView].
	instance := self withAllWidgets: allWidgets.

	instance aspect: anAspect.

"	anAspect onChangeSend: #contents: to: instance."

	^ instance
! !

!SWTCellPanel class methodsFor: 'instance creation' stamp: 'dgd 9/4/2006 18:11'!
withAllWidgets: widgetsCollection heights: heightsCollection
	^ (self withAllWidgets: widgetsCollection) cellsHeight: heightsCollection! !

!SWTCellPanel class methodsFor: 'instance creation' stamp: 'dgd 9/4/2006 18:12'!
withAllWidgets: widgetsCollection widths: widthsCollection
	^ (self withAllWidgets: widgetsCollection) cellsWidth: widthsCollection! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:07'!
border: aNumberOrString

	self dom
		jsSet: #border
		to: aNumberOrString.
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:07'!
cellPadding: aNumberOrString

	self dom
		jsSet: #cellPadding
		to: aNumberOrString.
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:07'!
cellSpacing: aNumberOrString

	self dom
		jsSet: #cellSpacing
		to: aNumberOrString.
! !

!SWTCellPanel methodsFor: 'private' stamp: 'dgd 9/4/2006 18:30'!
cells
	^ self subclassResponsibility! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/13/2006 11:31'!
cellsAlign: aCollection

	self with: aCollection cellsDo: [:cell :each |
		cell jsSet: #align to: each.
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:59'!
cellsBackgroundColor: aCollection

	self with: aCollection cellsDo: [:cell :each |
		each isNil ifFalse:[
			cell jsStyleSet: #backgroundColor to: each asColorString.
		].
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/13/2006 11:26'!
cellsBorderBottom: aCollection

	self with: aCollection cellsDo: [:cell :each |
		each isNil ifFalse:[
			cell jsStyleSet: #borderBottom to: each asString , 'px solid'

		].
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/13/2006 11:23'!
cellsBorderColor: aCollection

	self with: aCollection cellsDo: [:cell :each |
		each isNil ifFalse:[
			cell jsStyleSet: #borderColor to: each asColorString.
		].
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/13/2006 15:35'!
cellsBorderLeft: aCollection

	self with: aCollection cellsDo: [:cell :each |
		each isNil ifFalse:[
			cell jsStyleSet: #borderLeft to: each asString , 'px solid'

		].
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/13/2006 11:57'!
cellsBorderRight: aCollection

	self with: aCollection cellsDo: [:cell :each |
		each isNil ifFalse:[
			cell jsStyleSet: #borderRight to: each asString , 'px solid'

		].
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/13/2006 11:26'!
cellsBorderTop: aCollection

	self with: aCollection cellsDo: [:cell :each |
		each isNil ifFalse:[
			cell jsStyleSet: #borderTop to: each asString , 'px solid'

		].
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/13/2006 11:24'!
cellsBorder: aCollection

	self with: aCollection cellsDo: [:cell :each |
		each isNil ifFalse:[
			cell jsStyleSet: #border to: each asString , 'px solid'

		].
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:07'!
cellsHeight: aCollection

	self with: aCollection cellsDo: [:cell :each |
		cell jsSet: #height to: each.
	].
! !

!SWTCellPanel methodsFor: 'private' stamp: 'dgd 10/4/2006 13:49'!
cellsOrRows
	^ self subclassResponsibility! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:48'!
cellsVAlign: aCollection

	self with: aCollection cellsDo: [:cell :each |
		cell jsSet: #vAlign to: each.
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 18:12'!
cellsWidth: aCollection

	self with: aCollection cellsDo: [:cell :each |
		cell jsSet: #width to: each.
	].
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 10/4/2006 13:48'!
firstCellHeight: aNumberOrString

	self cellsOrRows first jsStyleSet: #height  to: aNumberOrString.
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 10/4/2006 13:52'!
firstCellVisible: aBoolean

	| visibility |

	visibility := aBoolean
						ifTrue:['visible']
						ifFalse:['hidden'].

	self cellsOrRows first jsStyleSet: #visibility  to: visibility.! !

!SWTCellPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 18:08'!
initializeDom
	"the receiver's dom counterpart was just created, initialize it"

	super initializeDom.

	self cellPadding: 0.
	self cellSpacing: 0.
! !

!SWTCellPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 18:25'!
innerDom

	"force dom creation"
	self dom.

	^ innerDom! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 11/14/2006 12:42'!
lastCellAlign: aString

	self cells last jsSet: #align to: aString.
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 10/15/2006 17:45'!
lastCellBackgroundColor: aColorOrString

	self cells last jsStyleSet: #backgroundColor to: aColorOrString asColorString.
! !

!SWTCellPanel methodsFor: 'accessing' stamp: 'dgd 10/3/2006 17:11'!
lastCellVAlign: aString

	self cells last jsSet: #vAlign to: aString.
! !

!SWTCellPanel methodsFor: 'private' stamp: 'dgd 9/4/2006 18:33'!
with: aCollection cellsDo: aBlock
	"Evaluate the given block with a pair of objects. The pair is composed of a cell and the corresponding element in the given collection."

	| cells |

	cells := self cells.

	1
		to: (cells size min: aCollection size)
		do:[:index |
			aBlock value: (cells at: index) value: (aCollection at: index)
		].
! !

SWTCellPanel subclass: #SWTColumnPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

!SWTColumnPanel methodsFor: 'private' stamp: 'dgd 11/6/2006 18:06'!
cells

	| rows result innerD |

	result := OrderedCollection new.

	innerD := self innerDom.
	rows := innerD jsPerform: #getElementsByTagName with: 'tr'.

	rows inlineDo:[:each |
		((each jsGet: #parentNode) == innerD) inlineIfTrue:[
			result add: (each jsGet: #firstChild)
		]
	].

	^ result.
! !

!SWTColumnPanel methodsFor: 'private' stamp: 'dgd 11/6/2006 18:06'!
cellsOrRows

	| rows result innerD |

	result := OrderedCollection new.

	innerD := self innerDom.
	rows := innerD jsPerform: #getElementsByTagName with: 'tr'.

	rows inlineDo:[:each |
		((each jsGet: #parentNode) == innerD) inlineIfTrue:[
			result add: each.
		]
	].

	^ result.
! !

!SWTColumnPanel methodsFor: 'dom counterpart' stamp: 'dgd 11/6/2006 17:26'!
createDom

	| table tbody |

	table := self domCreateElement: 'table'.

	tbody := self domCreateElement: 'tbody'.
	table jsPerform: #appendChild with: tbody.

	innerDom := tbody.

	^ table.! !

!SWTColumnPanel methodsFor: 'dom counterpart' stamp: 'dgd 11/8/2006 12:13'!
wrapDomWithTd: aDom

	| td |

	td := self domCreateElement: 'td'.
	td jsPerform: #appendChild with: aDom.

	^ td.
! !

!SWTColumnPanel methodsFor: 'dom counterpart' stamp: 'dgd 6/13/2007 19:05'!
wrapDom: aDom

	| wrapped td tr |

	wrapped := super wrapDom: aDom.

	td := self wrapDomWithTd: wrapped.
	td jsSet: #colSpan to: 2.

	tr := self domCreateElement: 'tr'.
	tr jsPerform: #appendChild with: td.

	^ tr.
! !

!SWTColumnPanel methodsFor: 'dom counterpart' stamp: 'dgd 11/14/2006 16:50'!
wrapDom: aDom label: labelString

	| tr th |

	th := self domCreateElement: 'td'.
	th jsSet: #align to: 'right'.
	th jsSet: #innerHTML to: '<i>' , labelString asString , ':</i>'.
"
	th jsStyleSet: #backgroundColor to: self backgroundColor slightlyDarker asColorString.
"
	tr := self domCreateElement: 'tr'.
	tr jsPerform: #appendChild with: th.
	tr jsPerform: #appendChild with: (self wrapDomWithTd: aDom).

	^ tr.
! !

SWTCellPanel subclass: #SWTRowPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

!SWTRowPanel methodsFor: 'private' stamp: 'dgd 11/6/2006 18:06'!
cells

	| cells result innerD |

	result := OrderedCollection new.

	innerD := self innerDom.
	cells := innerD jsPerform: #getElementsByTagName with: 'td'.

	cells inlineDo:[:each |
		((each jsGet: #parentNode) == innerD) inlineIfTrue:[
			result add: each.
		].
	].

	^ result.
! !

!SWTRowPanel methodsFor: 'private' stamp: 'dgd 10/4/2006 13:50'!
cellsOrRows
	^ self cells! !

!SWTRowPanel methodsFor: 'dom counterpart' stamp: 'dgd 11/6/2006 17:26'!
createDom

	| table tbody tr |

	table := self domCreateElement: 'table'.

	tbody := self domCreateElement: 'tbody'.
	table jsPerform: #appendChild with: tbody.

	tr := self domCreateElement: 'tr'.
	tbody jsPerform: #appendChild with: tr.

	innerDom := tr.

	^ table.! !

!SWTRowPanel methodsFor: 'dom counterpart' stamp: 'dgd 11/6/2006 17:09'!
wrapDom: aDom

	| wrapped td |

	wrapped := super wrapDom: aDom.

	td := self domCreateElement: 'td'.
	td jsPerform: #appendChild with:wrapped.

	^ td.
! !

SWTPanel subclass: #SWTFlasher
	instanceVariableNames: 'onOffFlag onColor offColor delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Misc'!

!SWTFlasher methodsFor: 'accessing' stamp: 'dgd 9/26/2006 11:40'!
delay: millisecondsInteger
	delay := millisecondsInteger! !

!SWTFlasher methodsFor: 'dom counterpart' stamp: 'dgd 10/12/2006 12:01'!
initialize

	super initialize.
	
	delay := 500.

	onOffFlag := true.
	onColor := Color green.
	offColor := Color red.
! !

!SWTFlasher methodsFor: 'dom counterpart' stamp: 'dgd 10/9/2006 11:44'!
initializeDom

	super initializeDom.

	self float: 'left'.
	self extent: 100@100.
	self border: 2.
! !

!SWTFlasher methodsFor: 'accessing' stamp: 'dgd 9/26/2006 11:45'!
offColor: aColor
	offColor := aColor! !

!SWTFlasher methodsFor: 'accessing' stamp: 'dgd 9/26/2006 11:45'!
onColor: aColor
	onColor := aColor! !

!SWTFlasher methodsFor: 'stepping' stamp: 'dgd 10/9/2006 14:04'!
step

	| newColor |

	super step.

	newColor := onOffFlag
						ifTrue:[ onColor ]
						ifFalse:[ offColor ].

	self backgroundColor: newColor.
	self borderColor: newColor muchDarker.

	onOffFlag := onOffFlag not.
! !

!SWTFlasher methodsFor: 'stepping' stamp: 'dgd 10/9/2006 14:04'!
stepTime
	"Answer the desired time between steps, in milliseconds."

	^ delay! !

SWTPanel subclass: #SWTIFramePanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

!SWTIFramePanel methodsFor: 'dom counterpart' stamp: 'dgd 10/8/2006 13:21'!
createDom

	| iframe |

	iframe := self domCreateElement: 'iframe'.

	iframe jsSet: #src to: 'about:blank'.

	^ iframe.! !

!SWTIFramePanel methodsFor: 'events' stamp: 'dgd 11/3/2007 18:14'!
onLoad: aBlock 
	"registers a block, to evaluate, when onLoad event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onLoadHandlers
						ifAbsentPut: [
							"is very first handler?"
							| handler myDom |

							handler :=  [:domEvent | 
										| event |

										event := SWTEvent type: #Load source: self domEvent: domEvent.

										(self valueOfProperty: #onLoadHandlers)
											do: [:each | each value: event].
									].

							"self dom jsSet: #onload to: handler."
							myDom := self dom.
							self jsLiteral: '
									if (myDom.addEventListener) {
										myDom.addEventListener("load", handler, false);
									}
									else if (myDom.attachEvent) {
										myDom.attachEvent("onload", handler);
									}
									else {
										myDom.onload = handler;
									}
							'.

							OrderedCollection new.
						].

	handlers add: aBlock.
! !

!SWTIFramePanel methodsFor: 'accessing' stamp: 'dgd 10/8/2006 13:18'!
src: urlString
	self dom jsSet: #src to: urlString! !

SWTPanel subclass: #SWTMap
	instanceVariableNames: 'cells relativePosition zoom dragging lastDraggingPosition formExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Misc'!

!SWTMap methodsFor: 'events' stamp: 'dgd 12/13/2006 13:43'!
applicationJustConnected
	cells do:[:each | each applicationJustConnected].
! !

!SWTMap methodsFor: 'layouting' stamp: 'dgd 12/12/2006 14:10'!
cellsExtent
	^ self cellsWidth @ self cellsHeight! !

!SWTMap methodsFor: 'layouting' stamp: 'dgd 12/12/2006 14:10'!
cellsHeight
	| cellsHeight heightForCells |

	heightForCells := self extentForCells y.

	cellsHeight := (self height / heightForCells) truncated.

	(cellsHeight * heightForCells) < self height
		ifTrue:[cellsHeight := cellsHeight + 1].
	
	^ cellsHeight! !

!SWTMap methodsFor: 'layouting' stamp: 'dgd 12/12/2006 14:09'!
cellsWidth
	| cellsWidth widthForCells |

	widthForCells := self extentForCells x.

	cellsWidth := (self width / widthForCells) truncated.

	(cellsWidth * widthForCells) < self width
		ifTrue:[cellsWidth := cellsWidth + 1].
	
	^ cellsWidth! !

!SWTMap methodsFor: 'layouting' stamp: 'dgd 12/15/2006 16:02'!
createCells

	| home |

self logWarning: 'relativePosition=' , relativePosition asString.

	home := (relativePosition / self extentForCells) truncated negated.

self logWarning: ' -- =' , home asString.

	1 to: "1"self cellsExtent x do: [:x | 
		1 to: "1"self cellsExtent y do: [:y | 
			| cell |

			cell := SWTCellMap map: self position: home + (x@y).

			cells add: cell.
			self addWidget: cell widget.
		]
	].

	self updateGrid.! !

!SWTMap methodsFor: 'private' stamp: 'dgd 12/15/2006 12:18'!
createNewColumn

	| newColumn rowFrom rowTo |

	newColumn := self positionTo x + 1.

	rowFrom := self positionFrom y.
	rowTo := self positionTo y.

	rowFrom to: rowTo do: [:y | 
		| cell |
		cell := SWTCellMap map: self position: newColumn @ y.

		cells add: cell.
		self addWidget: cell widget.
	].
! !

!SWTMap methodsFor: 'private' stamp: 'dgd 12/15/2006 12:22'!
createNewRow

	| newRow colFrom colTo |

	newRow := self positionTo y + 1.

	colFrom := self positionFrom x.
	colTo := self positionTo x.

	colFrom to: colTo do: [:x | 
		| cell |
		cell := SWTCellMap map: self position: x @ newRow.

		cells add: cell.
		self addWidget: cell widget.
	].
! !

!SWTMap methodsFor: 'layouting' stamp: 'dgd 12/12/2006 19:16'!
extentForCells
	"Answer a point with the extent for the receiver's cells"
	^ 256@256! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/15/2006 10:11'!
formExtent
	^ formExtent! !

!SWTMap methodsFor: 'initialization' stamp: 'dgd 12/13/2006 16:28'!
initialize
	super initialize.

	self
		beRelative;
		width: 100 percent;
		height: 100 percent;
		overflow: 'hidden'";
		backgroundColor: Color black".

	cells := {}.
	relativePosition := 0@0.
	zoom := 1.

	self initializeDrag.
! !

!SWTMap methodsFor: 'initialization' stamp: 'dgd 12/13/2006 11:22'!
initializeDrag
	"Initialize the receiver to process mouse dragging"

	dragging := false.
	lastDraggingPosition := nil.

	self onMouseDown: [:event |
		event preventDefault.
		dragging := true.
		lastDraggingPosition := event position.
	].

	self onMouseMove: [:event |
		dragging ifTrue: [
			| newPosition |

			newPosition := event position.

			self relativePosition: self relativePosition + newPosition - lastDraggingPosition.

			lastDraggingPosition := newPosition.
		]
	].

	self onMouseUp: [:event | dragging := false ].
	self onMouseOut: [:event | dragging := false ].
! !

!SWTMap methodsFor: 'initialization' stamp: 'dgd 12/15/2006 10:15'!
initializeFormExtent: aPoint

	formExtent := aPoint.

	self zoom: self initialZoom.
	self applicationJustConnected.
! !

!SWTMap methodsFor: 'initialization' stamp: 'dgd 12/15/2006 10:12'!
initialZoom

	| result |

	result := (self extent / formExtent) roundTo: 0.1.
	result := result x min: result y.

	^ result.
! !

!SWTMap methodsFor: 'layouting' stamp: 'dgd 6/13/2007 17:21'!
layout

	self removeCells.
	self createCells.
! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/15/2006 12:47'!
moveDown
	self relativePosition: self relativePosition + (0 @ (self extentForCells y / 2))! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/15/2006 12:46'!
moveLeft
	self relativePosition: self relativePosition - ((self extentForCells x / 2) @ 0)! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/15/2006 12:47'!
moveRight
	self relativePosition: self relativePosition + ((self extentForCells x / 2) @ 0)! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/15/2006 12:47'!
moveUp
	self relativePosition: self relativePosition - (0 @ (self extentForCells y / 2))! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/15/2006 11:29'!
positionFrom
	^ cells
			inject: cells anyOne position
			into:[:acum :each | acum min: each position].! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/15/2006 11:29'!
positionTo
	^ cells
			inject: cells anyOne position
			into:[:acum :each | acum max: each position].! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/12/2006 15:11'!
relativePosition
	^ relativePosition! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/15/2006 11:36'!
relativePosition: aPoint

	| newPoint |

	newPoint := aPoint min: 0@0.

	((newPoint x + self zoomedFormExtent x) <= self width) ifTrue:[
		newPoint := relativePosition x @ newPoint y.
	].

	((newPoint y + self zoomedFormExtent y) <= self height) ifTrue:[
		newPoint := newPoint x @ relativePosition y.
	].

	(relativePosition = newPoint) ifFalse:[
		relativePosition := newPoint.

		cells do:[:each | each layout].

		self updateGrid.
	].
! !

!SWTMap methodsFor: 'layouting' stamp: 'dgd 6/13/2007 17:21'!
removeCells

	cells do: [:each | each widget remove].
	cells := OrderedCollection new.
! !

!SWTMap methodsFor: 'private' stamp: 'dgd 6/13/2007 17:21'!
removeNotVisibleColumn

	| anyRemoved condition |

	anyRemoved := false.
	condition := [:each | each widget right < self left].
	cells
		select: condition
		thenDo: [:each |
			anyRemoved := true.
			each widget remove
		].

	anyRemoved ifFalse:[^ self].

	cells := cells reject: condition.

	relativePosition := relativePosition + (self extentForCells x @ 0).
	cells do:[:each | each layout].
! !

!SWTMap methodsFor: 'private' stamp: 'dgd 6/13/2007 17:21'!
removeNotVisibleRow

	| anyRemoved condition |

	anyRemoved := false.
	condition := [:each | each widget bottom < self top].
	cells
		select: condition
		thenDo: [:each |
			anyRemoved := true.
			each widget remove
		].

	anyRemoved ifFalse:[^ self].

	cells := cells reject: condition.

	relativePosition := relativePosition + (0 @ self extentForCells y).
	cells do:[:each | each layout].
! !

!SWTMap methodsFor: 'events' stamp: 'dgd 12/12/2006 14:04'!
resized
	super resized.

	self layout.! !

!SWTMap methodsFor: 'private' stamp: 'dgd 12/15/2006 17:33'!
updateGrid

	| cell |

	self removeNotVisibleColumn.

	cell := cells detectMax: [:each | each widget right].
	(cell widget right < self right) ifTrue:[
		self createNewColumn.
	].

	self removeNotVisibleRow.

	cell := cells detectMax: [:each | each widget bottom].
	(cell widget bottom < self bottom) ifTrue:[
		self createNewRow.
	].
! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/13/2006 16:28'!
zoom
	^ zoom! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/15/2006 10:16'!
zoomedFormExtent
	^ (self formExtent * self zoom)! !

!SWTMap methodsFor: 'accessing' stamp: 'dgd 12/13/2006 16:30'!
zoom: aNumber
	| newZoom |

	newZoom := aNumber min: 10 max: 0.01.

	zoom = newZoom inlineIfTrue:[^ self].

	zoom := newZoom.
	self layout.
! !

!SWTPanel class methodsFor: 'instance creation' stamp: 'dgd 11/5/2007 18:47'!
forArrayAspect: anArrayAspect

	| instance allWidgets |

	allWidgets := anArrayAspect value collect:[:each | each defaultView].
	instance := self withAllWidgets: allWidgets.

	instance aspect: anArrayAspect.

	anArrayAspect
		onChangeSend: #newContents: to: instance;
		onAddedElementSend: #addedElement:at: to: instance;
		onRemovedElementSend: #removedElementAt: to: instance.

	^ instance
! !

!SWTPanel class methodsFor: 'instance creation' stamp: 'dgd 11/5/2007 17:43'!
forAspect: anAspect

	| instance allWidgets |

	allWidgets := anAspect value collect:[:each | each defaultView].
	instance := self withAllWidgets: allWidgets.

	instance aspect: anAspect.

"	anAspect onChangeSend: #contents: to: instance."

	^ instance
! !

!SWTPanel class methodsFor: 'instance creation' stamp: 'dgd 11/7/2007 13:10'!
withAllWidgets: aCollection

	| instance |

	instance := self new.
	instance addAllWidgets: aCollection.

	^ instance.
! !

!SWTPanel class methodsFor: 'instance creation' stamp: 'dgd 4/17/2007 13:12'!
withWidget: aWidget
	^ self withAllWidgets: { aWidget }! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 15:45'!
addAllWidgets: aCollection
	aCollection do:[:each | self addWidget: each].! !

!SWTPanel methodsFor: 'utilities' stamp: 'dgd 8/11/2006 13:54'!
addBreak
	self addWidget: SWTBreak new.! !

!SWTPanel methodsFor: 'aspect - events' stamp: 'dgd 11/10/2007 13:34'!
addedElement: newElement at: newPosition

	self log: self asString , ': new element (' , newElement asString , ') at ' , newPosition asString.

	newPosition isNil inlineIfTrue:[
			"just create the view for newElement"
			self addWidget: newElement defaultView.
		]
		ifFalse:[
			"refresh the whole contents"
			self newContents: self aspect value.
		].

	self resized.
! !

!SWTPanel methodsFor: 'utilities' stamp: 'dgd 8/11/2006 13:53'!
addHorizontalRule
	self addWidget: SWTHorizontalRule new.! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 6/13/2007 14:22'!
addWidget: childWidget 

	^ self addWidget: childWidget label: nil.
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 11/9/2007 12:19'!
addWidget: childWidget label: labelString

	| childWidgetDom |

	labelString isNil inlineIfTrue:[
		childWidgetDom := self wrapDom: childWidget decoratedDom.
	]
	ifFalse:[
		childWidgetDom := self wrapDom: childWidget decoratedDom label: labelString.
	].

	children isNil inlineIfTrue: [ children := OrderedCollection new ].
	children add: { childWidget. childWidgetDom }.

	self innerDom
			jsPerform: #appendChild
			with: childWidgetDom.

	childWidget setParent: self.

	^ childWidget.
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 5/5/2007 12:32'!
allWidgets
	"Answer the receiver's children collection"

	| allWidgets |

	allWidgets := OrderedCollection new.

	self widgetsDo:[:each | allWidgets addAll: each withAllWidgets].

	^ allWidgets.
! !

!SWTPanel methodsFor: 'enumerating' stamp: 'dgd 6/19/2007 13:53'!
allWidgetsDo: aBlock
	"Evaluate the given block for each receiver's widgets, and the widgets of each of its childs, and so on."

	children isNil inlineIfTrue:[^ self].

	children inlineDo:[:each |
		aBlock value: each first.
		each first isPanel inlineIfTrue:[
			each first allWidgetsDo: aBlock.
		].
	].
! !

!SWTPanel methodsFor: 'windows' stamp: 'dgd 9/30/2006 18:30'!
arrangeWindows
	"Arrange all the windows"

	| cursorX cursorY maxY vp |

	vp := self viewPort.
	cursorX := vp left.
	cursorY := vp top.

	maxY := cursorY.

	self windows do:[:each |
		| newPos |

		((cursorX + each width + 20) > vp right) ifTrue:[
			cursorX := vp left.
			cursorY := maxY
		].

		newPos := (cursorX @ cursorY) + 10.

		each animatePositionTo: newPos.

		cursorX := cursorX + each width + 10.
		maxY := maxY max: (newPos y + each height).
	].
! !

!SWTPanel methodsFor: 'windows' stamp: 'dgd 10/26/2007 12:45'!
cascadeWindows
	"Arrange all the windows in cascade"

	| cursor delta |

	cursor := self viewPort topLeft + (10@10).
	delta := 40@40.

	self windows do:[:each |
		each animatePositionTo: cursor.

		cursor := cursor + delta.
	].
! !

!SWTPanel methodsFor: 'events' stamp: 'dgd 6/13/2007 18:07'!
cleanUp

	self clearWidgets.

	super cleanUp.
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 6/19/2007 13:53'!
clearWidgets

	children isNil inlineIfTrue:[^ self].

	[self hasWidgets] inlineWhileTrue: [
		"self widgets last unload."
		children last first remove.
	].
! !

!SWTPanel methodsFor: 'connection/disconnection' stamp: 'dgd 5/5/2007 12:43'!
connectUI
	super connectUI.

	self widgetsDo: [:each | each connectUI]
! !

!SWTPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/5/2006 15:04'!
createDom

	| div |

	div := self domCreateElement: 'div'.

	^ div.! !

!SWTPanel methodsFor: 'connection/disconnection' stamp: 'dgd 5/5/2007 12:43'!
disconnectUI
	super disconnectUI.

	self widgetsDo: [:each | each disconnectUI]
! !

!SWTPanel methodsFor: 'enumerating' stamp: 'dgd 6/13/2007 13:06'!
do: aBlock
	super do: self.

	self widgetsDo:[:each | each do: aBlock].! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 5/5/2007 12:43'!
enable: aBoolean
	"change the receiver's enable status"

	super enable: aBoolean.
"
	self jsLiteral: 'self.dom().disabled = !!(aBoolean)'.
"
	self widgetsDo: [:each | each enable: aBoolean]
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/5/2006 15:11'!
goBottom

	| myDom |
	myDom := self dom.
	myDom jsSet: #scrollTop to: (myDom jsGet: #scrollHeight).
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 6/19/2007 13:53'!
hasWidgets
	"Answer if the receiver has widgets inside"

	children isNil inlineIfTrue:[^ false].

	^ children notEmpty.
! !

!SWTPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 17:46'!
innerDom
	^ self dom! !

!SWTPanel methodsFor: 'testing' stamp: 'dgd 6/13/2007 18:56'!
isPanel
	^ true! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/4/2006 16:47'!
lastWidget

	^ children last first! !

!SWTPanel methodsFor: 'aspect - events' stamp: 'dgd 11/5/2007 18:21'!
newContents: aCollection

	| allWidgets |

	self clearWidgets.

	allWidgets := aCollection collect:[:each | each defaultView].

	self addAllWidgets: allWidgets.
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/5/2006 15:09'!
overflow: aString
	self dom jsStyleSet: #overflow to: aString! !

!SWTPanel methodsFor: 'windows' stamp: 'dgd 6/19/2007 13:57'!
popWindow: aWindow

	windowZOrder isNil inlineIfTrue:[windowZOrder := 0].

	windowZOrder := windowZOrder + 1.
	aWindow zIndex: windowZOrder.
! !

!SWTPanel methodsFor: 'aspect - events' stamp: 'dgd 11/10/2007 13:45'!
removedElementAt: oldPosition

	| isRemovedLast |

	self log: self asString , ': removed element at at ' , oldPosition asString.

	isRemovedLast := (oldPosition = self widgetsCount).

	isRemovedLast inlineIfTrue:[
			"just remove it"
			self removeWidgetAt: oldPosition
		]
		ifFalse:[
"
			| oldWidgets |
			oldWidgets := self widgets.
			oldWidgets removeIndex: oldPosition.

			self clearWidgets.
			self addAllWidgets: oldWidgets.
"
			"refresh the whole contents"
			self newContents: self aspect value.
		].

	self resized.
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 11/5/2007 19:30'!
removeWidgetAt: index

	self removeWidget: (self widgetAt: index)! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 11/9/2007 13:07'!
removeWidget: aWidget

	| pair widget widgetDom |

	pair := children detect:[:each | each first == aWidget].
	children remove: pair.

	widget := pair first.
	widgetDom := pair second.

	widget removedFromParent: self.

	self innerDom
			jsPerform: #removeChild
			with: widgetDom.
"
	self resized.
"! !

!SWTPanel methodsFor: 'events' stamp: 'dgd 5/5/2007 12:32'!
resized
	super resized.

	self widgetsDo:[:each | each resized].
! !

!SWTPanel methodsFor: 'events' stamp: 'dgd 10/22/2007 15:46'!
scrolled
	super scrolled.

	self widgetsDo:[:each | each scrolled].
! !

!SWTPanel methodsFor: 'private' stamp: 'dgd 6/13/2007 18:54'!
setParent: aPanel
	"PRIVATE- change the receiver's parent"

	super setParent: aPanel.

	self allWidgetsDo:[:each | each tryToStartStepping].
! !

!SWTPanel methodsFor: 'stepping' stamp: 'dgd 6/14/2007 15:02'!
startStepping: aWidget
	"Add the given morph to the step list. Do nothing if it is already being stepped."
	self
			startStepping: aWidget
			at: Time timestamp
! !

!SWTPanel methodsFor: 'stepping' stamp: 'dgd 6/14/2007 10:27'!
startStepping: aWidget at: scheduledTimeNumber

	self scheduler
				startStepping: aWidget
				at: scheduledTimeNumber
! !

!SWTPanel methodsFor: 'stepping' stamp: 'dgd 6/13/2007 14:29'!
stopStepping: aWidget

	self scheduler stopStepping: aWidget
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 9/6/2006 20:35'!
textAlign: aString
	self dom jsStyleSet: #textAlign to: aString! !

!SWTPanel methodsFor: 'windows' stamp: 'dgd 9/30/2006 18:07'!
viewPort
	^ viewPortHandler isNil
			ifTrue: [self bounds]
			ifFalse: [viewPortHandler value]! !

!SWTPanel methodsFor: 'windows' stamp: 'dgd 9/30/2006 18:06'!
viewPort: aBlock

	viewPortHandler := aBlock! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 11/5/2007 19:32'!
widgetAt: index
	"Answer the receiver's children collection"

	^ (children at: index) first
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 6/19/2007 13:52'!
widgets
	"Answer the receiver's children collection"

	children isNil inlineIfTrue:[^ {}].

	^ children collect:[:each | each first] "asReadOnlyCollection."
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 11/5/2007 19:26'!
widgetsCount
	"Answer the receiver's children collection"

	children isNil inlineIfTrue:[^ 0].

	^ children size
! !

!SWTPanel methodsFor: 'enumerating' stamp: 'dgd 6/19/2007 13:52'!
widgetsDo: aBlock
	"Evaluate the given block for each receiver's widgets"

	children isNil inlineIfTrue:[^ self].

	children inlineDo:[:each |
		aBlock value: each first
	].
! !

!SWTPanel methodsFor: 'windows' stamp: 'dgd 9/30/2006 19:22'!
windows
	"Answer the windows in the receiver's children collection"

	| result |

	result := self widgets select:[:each | each isWindow].

	self jsLiteral: '
		function __temp__(x, y) {
			if ( x.zIndex() < y.zIndex() ) return -1;
			if ( x.zIndex() > y.zIndex() ) return 1;
			return 0;
		}

		result = result.sort(__temp__);
	'.

	^ result
! !

!SWTPanel methodsFor: 'accessing' stamp: 'dgd 10/19/2006 10:24'!
withAllWidgets
	"Answer the receiver's children collection"

	| result |

	result := OrderedCollection new.
	result add: self.
	result addAll: self allWidgets.

	^ result
! !

!SWTPanel methodsFor: 'dom counterpart' stamp: 'dgd 9/4/2006 16:44'!
wrapDom: aDom
	^ aDom! !

!SWTPanel methodsFor: 'dom counterpart' stamp: 'dgd 11/8/2006 12:33'!
wrapDom: aDom label: labelString

	| b span |

	span := self domCreateElement: 'span'.

	b := self domCreateElement: 'b'.

	b jsSet: #innerHTML to: labelString asString.

	span jsPerform: #appendChild with: b.
	span jsPerform: #appendChild with: aDom.

	^ span! !

SWTPanel subclass: #SWTRootPanel
	instanceVariableNames: 'overlay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

!SWTRootPanel class methodsFor: 'instance creation' stamp: 'dgd 8/7/2006 13:13'!
default
	"Singleton accessing"
	
	^ self jsLiteral: 'SWT.RootPanel'.
! !

!SWTRootPanel class methodsFor: 'class initialization' stamp: 'dgd 9/3/2006 10:22'!
initialize
	
	| singleton |

	self jsInSmalltalk:[^ self].

	(self = SWTRootPanel) ifFalse:[ ^ self ].

	singleton := self new.

	self jsLiteral: 'SWT.RootPanel = singleton'.
! !

!SWTRootPanel class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 8/8/2006 16:29'!
jsPreSource
	^ '/* singleton holder */
SWT.RootPanel = null;
'! !

!SWTRootPanel methodsFor: 'connection/disconnection' stamp: 'dgd 5/5/2007 12:44'!
connectUI
"	self enable: true."

	self widgetsDo: [:each | each connectUI]
! !

!SWTRootPanel methodsFor: 'utilities' stamp: 'dgd 4/24/2007 16:52'!
createOverlay

	overlay isNil ifFalse:[^ self].

	overlay := SWTPanel new.
	overlay
		beAbsolute;
		topLeft: 0@0;
		zIndex: 99;
		width: 100 percent;
		height: 100 percent;
		backgroundColor: Color white;
		opacity: 0.0.

	self addWidget: overlay.

	overlay animateOpacityBy: 0.9.
! !

!SWTRootPanel methodsFor: 'utilities' stamp: 'dgd 10/14/2006 17:27'!
destroyOverlay

	overlay isNil ifTrue:[ ^ self].

	self removeWidget: overlay.
	overlay := nil.
! !

!SWTRootPanel methodsFor: 'connection/disconnection' stamp: 'dgd 5/5/2007 12:44'!
disconnectUI
"	self enable: false."

	self widgetsDo: [:each | each disconnectUI]
! !

!SWTRootPanel methodsFor: 'dom counterpart' stamp: 'dgd 8/7/2006 21:32'!
dom
	^ self jsLiteral: 'document.body'! !

!SWTRootPanel methodsFor: 'stepping' stamp: 'dgd 6/13/2007 18:46'!
isValidForStepping
	^ true! !

!SWTRootPanel methodsFor: 'accessing' stamp: 'dgd 10/22/2007 17:47'!
scrollLeft
	^ self jsLiteral: '(document.documentElement.scrollLeft || document.body.scrollLeft)'.! !

!SWTRootPanel methodsFor: 'accessing' stamp: 'dgd 10/22/2007 17:45'!
scrollTop
	^ self jsLiteral: '(document.documentElement.scrollTop || document.body.scrollTop)'.! !

!SWTRootPanel methodsFor: 'accessing' stamp: 'dgd 10/26/2007 13:06'!
scrollTopLeft
	^ self scrollLeft @ self scrollTop
! !

!SWTRootPanel methodsFor: 'accessing' stamp: 'dgd 8/7/2006 20:53'!
title: aString
	self jsLiteral: 'document.title = aString'.
! !

SWTPanel subclass: #SWTWhiteboard
	instanceVariableNames: 'board captureCanvas drawing points currentColor currentWidth strokes newStrokes toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Misc'!

!SWTWhiteboard class methodsFor: 'instance creation' stamp: 'dgd 10/22/2007 18:53'!
forAspect: anAspect

	| instance |

	instance := self strokes: [ anAspect value ]. "this block is to produce a delay on the aspect evaluation to make it happens after #onChangeSend:to: sending"
	instance onChange: [:event | anAspect value: instance allStrokes ].

	instance aspect: anAspect.

	anAspect onChangeSend: #strokes: to: instance.
	anAspect onChangeSend: #highlight to: instance.

	^ instance.
! !

!SWTWhiteboard class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 10/17/2006 20:39'!
jsClassesToInclude
	^ { SWTStroke }! !

!SWTWhiteboard class methodsFor: 'instance creation' stamp: 'dgd 10/17/2006 21:09'!
strokes: aCollection

	^ self new initializeStrokes: aCollection! !

!SWTWhiteboard methodsFor: 'accessing' stamp: 'dgd 10/18/2006 13:47'!
allStrokes

	"Answer the receiver's strokes"

	| allStrokes |

	allStrokes := OrderedCollection new.

	allStrokes addAll: self strokes.

	newStrokes isNil inlineIfFalse:[
		allStrokes addAll: newStrokes.
	].

	^ allStrokes
! !

!SWTWhiteboard methodsFor: 'events' stamp: 'dgd 6/13/2007 18:07'!
cleanUp
	super cleanUp.

	toolbar isNil ifFalse:[
		toolbar cleanUp.
	].! !

!SWTWhiteboard methodsFor: 'dom counterpart' stamp: 'dgd 10/18/2006 21:29'!
createToolbar

	| buttons baseColor acceptColor cancelColor |

	baseColor := Color yellow.

	buttons := SWTRowPanel new.

	acceptColor := baseColor darker alphaMixed: 0.25 with: Color green twiceLighter.
	buttons addWidget: (SWTButton caption: 'accept (<u>s</u>)' onClick:[:event | toolbar sticks last accept]).
	buttons lastWidget
		accessKey: 'S';
		border: 1;
		backgroundColor: acceptColor;
		borderColor: acceptColor muchDarker.

	cancelColor := baseColor darker alphaMixed: 0.25 with: Color red twiceLighter.
	buttons addWidget: (SWTButton caption: 'cancel (<u>l</u>)' onClick:[:event | toolbar sticks last cancel]).
	buttons lastWidget
		accessKey: 'L';
		border: 1;
		backgroundColor: cancelColor;
		borderColor: cancelColor muchDarker.

	toolbar := LWFloatingToolbar new.
	self root addWidget: toolbar.

	toolbar
		addContentsWidget: buttons;
		backgroundColor: baseColor muchLighter;
		hide.
! !

!SWTWhiteboard methodsFor: 'accessing' stamp: 'dgd 10/17/2006 20:31'!
currentColor: aColor
	currentColor := aColor "alpha: 0.9".
	self updatePen.
! !

!SWTWhiteboard methodsFor: 'accessing' stamp: 'dgd 10/17/2006 20:31'!
currentWidth: aNumber
	currentWidth := aNumber.
	self updatePen.
! !

!SWTWhiteboard methodsFor: 'private' stamp: 'dgd 10/17/2006 21:41'!
drawStrokes

	| stro |

	board isNil inlineIfTrue:[^ self].
	board clear.

	stro := self strokes.
	stro isNil inlineIfTrue:[^ self].
	stro inlineDo:[:each | each drawOn: board].
! !

!SWTWhiteboard methodsFor: 'private' stamp: 'dgd 10/17/2006 20:32'!
draw: anEvent

	| currentPoint |

	drawing ifFalse: [^ self].

	captureCanvas roundLineCap.
	currentPoint := anEvent relativePosition.

	captureCanvas
		line: points last
		to: currentPoint
		width: currentWidth + 1
		color: currentColor.

	points add: currentPoint.
! !

!SWTWhiteboard methodsFor: 'visual effects' stamp: 'dgd 10/18/2006 10:50'!
highlight
	board isNil
		ifTrue: [super highlight]
		ifFalse:[board highlight].
! !

!SWTWhiteboard methodsFor: 'initialization' stamp: 'dgd 10/17/2006 21:45'!
initialize
	super initialize.

	strokes := OrderedCollection new.

	drawing := false.

	self currentColor: Color black.
	self currentWidth: 2.
! !

!SWTWhiteboard methodsFor: 'dom counterpart' stamp: 'dgd 10/18/2006 21:31'!
initializeDom
	"the receiver's dom counterpart was just created, initialize it"

	super initializeDom.

	board := SWTCanvas new.
	self addWidget: board.
	self lastWidget
		onDblClick:[:event | self switchToEditMode ];
		"onMouseOut:[:event | self switchToNormalMode: false ];"
		backgroundColor: Color white;
		borderColor: Color gray muchDarker;
		border: 1.

	self drawStrokes.
"
	self createToolbar.
"! !

!SWTWhiteboard methodsFor: 'initialization' stamp: 'dgd 10/17/2006 21:33'!
initializeStrokes: aCollectionOrAspect
	strokes := aCollectionOrAspect.

	self drawStrokes.! !

!SWTWhiteboard methodsFor: 'accessing' stamp: 'dgd 10/17/2006 20:24'!
isEditing
	^ captureCanvas notNil! !

!SWTWhiteboard methodsFor: 'events' stamp: 'dgd 11/3/2007 18:11'!
onChange: aBlock 
	"registers a block, to evaluate, when onChange event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onChange
						ifAbsentPut: [OrderedCollection new].

	handlers add: aBlock.
! !

!SWTWhiteboard methodsFor: 'private' stamp: 'dgd 10/18/2006 11:53'!
startDrawing: anEvent

	drawing ifTrue:[^ self].

	drawing := true.

	points := OrderedCollection new.
	points add: anEvent relativePosition.
! !

!SWTWhiteboard methodsFor: 'private' stamp: 'dgd 10/17/2006 21:33'!
stopDrawing: anEvent

	drawing ifFalse:[^ self].

	drawing := false.

	newStrokes add: (SWTStroke points: points color: currentColor width: currentWidth).

	points := nil.
"
	self switchToNormalMode: false.
"! !

!SWTWhiteboard methodsFor: 'accessing' stamp: 'dgd 10/18/2006 11:45'!
strokes

	"Answer the receiver's strokes"

	^ strokes value ifNil:[#()]! !

!SWTWhiteboard methodsFor: 'accessing' stamp: 'dgd 10/17/2006 21:28'!
strokes: aCollection

	"Answer the receiver's strokes"

	strokes := OrderedCollection new.

	aCollection inlineDo:[:each |
		strokes add: each.
	].

	self drawStrokes.! !

!SWTWhiteboard methodsFor: 'private' stamp: 'dgd 10/18/2006 16:38'!
switchToEditMode

	self isEditing ifTrue:[
		^ self.
	].

	board
		border: 2;
		borderColor: Color red muchDarker.

	captureCanvas := SWTCanvas new.
	self addWidget: captureCanvas.
	captureCanvas
		beAbsolute;
		topLeft: board topLeft + 2.

	captureCanvas onMouseDown:[:event | self startDrawing: event].
	captureCanvas onMouseMove:[:event | self draw: event].
	captureCanvas onMouseUp:[:event | self stopDrawing: event].

	captureCanvas onMouseOut:[:event | self switchToNormalMode: false ].

	newStrokes := OrderedCollection new.

	captureCanvas
		fillRect: (0@0 extent: captureCanvas extent)
		color: (Color gray muchLighter muchLighter alpha: 0.7).
! !

!SWTWhiteboard methodsFor: 'private' stamp: 'dgd 11/3/2007 18:10'!
switchToNormalMode: cancelBoolean

	self isEditing ifFalse:[
		^ self.
	].

"	captureCanvas clear."
	captureCanvas remove.
"	self removeWidget: captureCanvas."
	captureCanvas := nil.

	board
		borderColor: Color gray muchDarker;
		border: 1.

	cancelBoolean ifFalse: [
		newStrokes isEmpty ifFalse:[
			self valueOfProperty: #onChange ifPresentDo:[:onChange |
				| event |
				event := SWTEvent type: #Change source: self domEvent: nil.
				onChange do:[:each | each value: event].
			]
		]
	].
! !

!SWTWhiteboard methodsFor: 'private' stamp: 'dgd 10/17/2006 20:31'!
updatePen

	currentWidth isNil ifTrue:[^ self].
	currentColor isNil ifTrue:[^ self].
"
	penCanvas clear.
	penCanvas roundLineCap.

	penCanvas
		line: currentWidth @ (penCanvas height / 2)
		to: (penCanvas width - currentWidth) @ (penCanvas height / 2)
		width: currentWidth
		color: currentColor.
"! !

SWTPanel subclass: #SWTWindow
	instanceVariableNames: 'title titlePanel contentsPanel dragging lastDraggingPosition mouseWidgetOffset oldOpacity resizing titleText closeButton dragOpacity column showTitleBar resizable isModal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets-Panels'!

!SWTWindow class methodsFor: 'instance creation' stamp: 'dgd 10/6/2006 11:05'!
title: aString
	"Answer a new instance of the receiver"

	^ self new initializeTitle: aString! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/3/2006 17:14'!
addContentsWidget: aWidget

	| result |

	result := contentsPanel addWidget: aWidget.

	contentsPanel lastCellVAlign: 'top'.

	^ result.
! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 11/3/2007 18:20'!
backgroundColor: aColor

	super backgroundColor: aColor twiceDarker twiceDarker.
	self setProperty: #backgroundColor toValue: aColor.

	self borderColor: aColor muchDarker twiceDarker.
	titlePanel backgroundColor: aColor twiceDarker.

	contentsPanel backgroundColor: aColor.

	closeButton backgroundColor: (aColor alphaMixed: 0.5 with: Color red) darker.
	closeButton borderColor: (aColor alphaMixed: 0.5 with: Color red) muchDarker.
! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/14/2006 17:59'!
beModal
	isModal := true.
	self position: self parent position + (50@50) "self parent center - (self extent // 2)".
	self beNotResizable.
	self root createOverlay.
	self zIndex: 100.
! !

!SWTWindow methodsFor: 'private' stamp: 'dgd 10/4/2006 13:19'!
beNotAutomaticSize

	contentsPanel
		overflow: 'auto';
		width: 100 percent;
		height: 100 percent.

	column
		width: 100 percent;
		height: 100 percent.
! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/6/2006 19:50'!
beNotResizable
	self resizable: false.! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/6/2006 19:50'!
beResizable
	self resizable: true.! !

!SWTWindow methodsFor: 'removing' stamp: 'dgd 6/13/2007 18:08'!
cleanUp
	isModal ifTrue:[
		self flag: #todo. "keep count of how many modal windows are open and only destroy the overlay when none"
		self root destroyOverlay
	].

	super cleanUp.
! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/3/2006 16:54'!
contentsPanel
	^ contentsPanel! !

!SWTWindow methodsFor: 'dom counterpart' stamp: 'dgd 10/4/2006 13:20'!
createContentsPanel

	contentsPanel := SWTColumnPanel new.
"
	contentsPanel
		border: 1.
"
	^ contentsPanel! !

!SWTWindow methodsFor: 'dom counterpart' stamp: 'dgd 6/13/2007 17:19'!
createTitlePanel

	| row |

	titleText := SWTText contents: self title.
	titleText
 		fontFamily: 'serif';
		bold.
	closeButton := SWTButton caption: 'x'.
	closeButton border: 1.
	closeButton onClick: [:event | self remove ].

	row := SWTRowPanel
				withAllWidgets: { titleText.  closeButton }
				widths: { 99 percent. 1 percent }.
	row
		"border: 1;"
		width: 100 percent.

	titlePanel := SWTPanel new.

	titlePanel
		width: 100 percent.
	titlePanel addWidget: row.

	^ titlePanel.
! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/3/2006 16:51'!
dragOpacity
	^ dragOpacity ifNil:[1]! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/3/2006 16:51'!
dragOpacity: aNumber

	dragOpacity := aNumber.
! !

!SWTWindow methodsFor: 'accessing - geometry' stamp: 'dgd 10/4/2006 13:16'!
height: aNumberOrString
	super height: aNumberOrString.
	self beNotAutomaticSize.
! !

!SWTWindow methodsFor: 'initialization' stamp: 'dgd 6/10/2007 15:04'!
initialize
	super initialize.

	self addDropShadowDomDecorator.
	isModal := false! !

!SWTWindow methodsFor: 'dom counterpart' stamp: 'dgd 11/7/2006 10:20'!
initializeChildren

	column := SWTColumnPanel
						withAllWidgets: { self createTitlePanel. self createContentsPanel }
						heights: { 1 percent. 99 percent }.

"	column
		cellPadding: 1."

	self addWidget: column.
! !

!SWTWindow methodsFor: 'dom counterpart' stamp: 'dgd 11/6/2006 19:33'!
initializeDom
	"the receiver's dom counterpart was just created, initialize it"

	super initializeDom.

	self initializeChildren.
	self initializeLayout.

	self initializeDragging.
! !

!SWTWindow methodsFor: 'private - dragging' stamp: 'dgd 12/27/2006 15:47'!
initializeDragging

	dragging := false.

	self onMouseDown:[:event | self startDragOrResizing: event].
	self onMouseMove: [:event | self mouseMoved: event].
"
	self dom jsSet: #onselectstart to: [:event | false ].
	self dom jsSet: #ondragstart to: [:event | false ].
"! !

!SWTWindow methodsFor: 'dom counterpart' stamp: 'dgd 11/7/2006 10:34'!
initializeLayout
	self
		beAbsolute;
		topLeft: 0 @ 0;
		cursorMove;
		border: 1;
		padding: 3;
		backgroundColor: Color gray muchLighter.
! !

!SWTWindow methodsFor: 'initialization' stamp: 'dgd 10/6/2006 11:05'!
initializeTitle: aStringOrNil
	"Initialize the receiver's title"

	title := aStringOrNil.
	showTitleBar := aStringOrNil notNil.
! !

!SWTWindow methodsFor: 'private - dragging' stamp: 'dgd 10/2/2006 16:26'!
isOnResizeArea: currentPosition
	"PRIVATE - Answer the the given position is in the resize-area"

	| areaExtent resizeArea |

	areaExtent := 20@20.

	resizeArea := (self bottomRight - areaExtent) extent: areaExtent.

	^ resizeArea containsPoint: currentPosition.
! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/6/2006 19:47'!
isResizable
	^ resizable ifNil:[true]! !

!SWTWindow methodsFor: 'testing' stamp: 'dgd 9/29/2006 13:44'!
isWindow
	"Answer if the receiver is a window"
	^ true! !

!SWTWindow methodsFor: 'events' stamp: 'dgd 6/13/2007 17:37'!
justAddedIn: aPanel
	super justAddedIn: aPanel.

	self beAbsolute.

	aPanel popWindow: self.
! !

!SWTWindow methodsFor: 'private - dragging' stamp: 'dgd 10/6/2006 19:53'!
mouseMoved: anEvent

	| currentPosition |

	currentPosition := anEvent position.

	dragging inlineIfTrue: [
		(lastDraggingPosition = currentPosition)
			inlineIfTrue:[^ self].

		resizing
			inlineIfTrue:[ self extent: self extent + (currentPosition - lastDraggingPosition) ]
			ifFalse:[ self topLeft: currentPosition - mouseWidgetOffset ].

		lastDraggingPosition := currentPosition.
	]
	ifFalse: [
		(self isResizable and:[ self isOnResizeArea: currentPosition ])
			inlineIfTrue: [ self cursorSEResize ]
			ifFalse: [ self cursorMove ].
	].
! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 9/30/2006 19:16'!
pop
	self parent popWindow: self.! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/6/2006 19:51'!
resizable: aBoolean
	"private - "

	(aBoolean = self isResizable)
		ifTrue:[^ self].

	resizable := aBoolean.
! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/4/2006 13:23'!
showCloseButton: aBoolean
	closeButton visible: aBoolean.
! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 10/6/2006 13:32'!
showTitleBar: aBoolean

	showTitleBar := aBoolean.

	titlePanel visible: aBoolean.
	column firstCellVisible: aBoolean.
! !

!SWTWindow methodsFor: 'private - dragging' stamp: 'dgd 12/12/2006 19:12'!
startDragOrResizing: anEvent

	| currentPosition |

	anEvent preventDefault.

	currentPosition := anEvent position.

	lastDraggingPosition := currentPosition.
	mouseWidgetOffset := currentPosition - self topLeft.

	dragging inlineIfTrue:[^ self].

	isModal ifFalse: [
		self pop.
	].

	oldOpacity := self opacity.
	"self animateOpacityTo: (oldOpacity - 0.5 max: 0.2)."
	self opacity: self dragOpacity.

	dragging := true.
	resizing := self isResizable and:[ self isOnResizeArea: currentPosition ].

	self onMouseUp: [:event | self stopDragOrResizing: event].
	self onMouseOut: [:event | self stopDragOrResizing: event].
"
	self onMouseMove: [:event | self mouseMoved: event].
"! !

!SWTWindow methodsFor: 'private - dragging' stamp: 'dgd 10/1/2006 12:52'!
stopDragOrResizing: anEvent

	dragging ifFalse:[^ self].

	dragging := false.

"	self animateOpacityTo: oldOpacity."
	self opacity: oldOpacity.

	self clearOnMouseUp.
	self clearOnMouseOut.
"
	self clearOnMouseMove.
"! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 9/28/2006 20:44'!
title
	"Answer the receiver's title"
	^ title ifNil: ['Untitled window']! !

!SWTWindow methodsFor: 'accessing' stamp: 'dgd 9/28/2006 20:44'!
title: aString
	"Change the receiver's title"
	title := aString! !

!SWTWindow methodsFor: 'accessing - geometry' stamp: 'dgd 10/4/2006 13:16'!
width: aNumberOrString 
	super width: aNumberOrString.
	self beNotAutomaticSize.
! !

SWTWidget subclass: #SWTHorizontalRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTHorizontalRule methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 18:41'!
createDom

	^ self domCreateElement: 'hr'! !

SWTWidget subclass: #SWTHtmlTagWidget
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTHtmlTagWidget class methodsFor: 'instance creation' stamp: 'dgd 10/17/2006 15:07'!
tag: aString
	^ self new initializeTag: aString! !

!SWTHtmlTagWidget methodsFor: 'dom counterpart' stamp: 'dgd 10/17/2006 15:08'!
createDom

	^ self domCreateElement: self tag! !

!SWTHtmlTagWidget methodsFor: 'initialization' stamp: 'dgd 10/17/2006 15:07'!
initializeTag: aString
	tag := aString! !

!SWTHtmlTagWidget methodsFor: 'accessing' stamp: 'dgd 10/17/2006 15:08'!
tag
	^ tag ifNil: ['span']! !

SWTWidget subclass: #SWTImage
	instanceVariableNames: 'src align'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTImage class methodsFor: 'instance creation' stamp: 'dgd 9/4/2006 13:45'!
src: aString
	"Answer a new instace of the receiver with the given src"
	^ self new initializeSrc: aString! !

!SWTImage methodsFor: 'accessing' stamp: 'dgd 9/4/2006 15:57'!
align: aString

	align := aString.

	self dom jsSet: #align to: align.
! !

!SWTImage methodsFor: 'dom counterpart' stamp: 'dgd 10/9/2007 15:30'!
createDom

	| img |

	img := self domCreateElement: 'img'.

	img jsSet: #src to: (self fullSrcFor: self src).

	align isNil inlineIfFalse:[
		img jsSet: #align to: align.
	].

	^ img! !

!SWTImage methodsFor: 'initialization' stamp: 'dgd 9/4/2006 13:45'!
initializeSrc: aString
	"Initialize the receiver's src"
	src := aString! !

!SWTImage methodsFor: 'accessing' stamp: 'dgd 10/9/2007 15:30'!
src

	^ src value! !

!SWTImage methodsFor: 'accessing' stamp: 'dgd 10/9/2007 15:30'!
src: aString

"	src = aString inlineIfTrue:[^ self]."

	src := aString.

	self dom jsSet: #src to: (self fullSrcFor: self src).
! !

SWTWidget subclass: #SWTText
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

SWTText subclass: #SWTEditInPlaceText
	instanceVariableNames: 'editing editingType multiLine editBackgroundColor fontSize fontFamily fontWeight contentsToEditHandler readOnly acceptOnBlur newContents autoSetContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTEditInPlaceText class methodsFor: 'instance creation' stamp: 'dgd 9/20/2006 18:40'!
contents: aString onChange: aBlock
	^ (self contents: aString)
			onChange: aBlock;
			yourself
! !

!SWTEditInPlaceText class methodsFor: 'instance creation' stamp: 'dgd 10/22/2007 18:52'!
forAspect: anAspect

	| instance |

	instance := self
					contents: [ anAspect value ] "this block is to produce a delay on the aspect evaluation to make it happens after #onChangeSend:to: sending"
					onChange: [:event | anAspect value: event source newContents ].

	instance aspect: anAspect.

	anAspect onChangeSend: #contents: to: instance.
	anAspect onChangeSend: #highlight to: instance.

	instance
		autoSetContents: false;
		contentsToEditHandler: [ anAspect valueForEdit ];
		editBackgroundColor: Color lightYellow.

	^ instance! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 10/7/2006 19:16'!
accept
	self switchToNormalMode: false.
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 10/7/2006 19:21'!
acceptOnBlur: aBoolean

	(acceptOnBlur = aBoolean)
		ifTrue:[^ self].

	self ensureNonEditing.

	acceptOnBlur := aBoolean.

	self resetHandlers.
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 10/18/2006 19:11'!
autoSetContents: aBoolean

	autoSetContents := aBoolean! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 9/21/2006 12:49'!
beMultiLine
	self ensureNonEditing.

	multiLine := true.
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 9/21/2006 12:49'!
beSingleLine
	self ensureNonEditing.

	multiLine := false.
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 10/6/2006 11:28'!
cancel
	self switchToNormalMode: true.
! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 6/13/2007 18:07'!
cleanUp
	self ensureNonEditing.

	super cleanUp.
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 10/7/2006 19:31'!
clearHandlers
	"private - removes all the events handlers."

	| myDom editors |

	myDom := self dom.

	myDom jsSet: #ondblclick to: nil.
	myDom jsSet: #onclick to: nil.
	myDom jsSet: #onmouseover to: nil.
	myDom  jsSet: #onmouseout to: nil. "Just in case of editBackgroundColor"

	editors := self jsLiteral: 'myDom.getElementsByTagName("input")'.
	editors inlineDo:[:editor |
		editor jsSet: #onchange to: nil.
		editor jsSet: #onblur to: nil.
		editor jsSet: #onfocus to: nil. "Just in case of onEditFocus:"
		editor jsSet: #onmouseout to: nil.
	].

	editors := self jsLiteral: 'myDom.getElementsByTagName("textarea")'.
	editors inlineDo:[:editor |
		editor jsSet: #onchange to: nil.
		editor jsSet: #onblur to: nil.
		editor jsSet: #onfocus to: nil. "Just in case of onEditFocus:"
		editor jsSet: #onmouseout to: nil.
	].! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 9/21/2006 20:24'!
contentsToEdit

	contentsToEditHandler isNil ifTrue:[^ self contents].

	^ contentsToEditHandler value! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 9/21/2006 20:22'!
contentsToEditHandler: aBlock

	contentsToEditHandler := aBlock! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 9/21/2006 12:49'!
contents: aString

	self ensureNonEditing.

	super contents: aString.

	self resetHandlers.
! !

!SWTEditInPlaceText methodsFor: 'dom counterpart' stamp: 'dgd 11/6/2006 17:33'!
createOuterDom

	| div |

	div := self domCreateElement: 'div'.
	div jsStyleSet: #cssFloat to: 'left'.
	div jsStyleSet: #styleFloat to: 'left'.

	^ div
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 9/21/2006 13:53'!
editBackgroundColor: aColorOrString
	"change the receiver's color"

	self ensureNonEditing.

	editBackgroundColor := aColorOrString.
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 8/11/2006 11:54'!
editingType: aString

	"private - change the receiver's editing type"

	editingType := aString.
	self resetHandlers.
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 8/11/2006 11:54'!
editOnClick
	self editingType: 'click'! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 8/11/2006 11:54'!
editOnDblClick
	self editingType: 'dblclick'! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 8/11/2006 11:54'!
editOnMouseOver
	self editingType: 'mouseover'! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 10/6/2006 11:28'!
ensureNonEditing

	self isEditing
		ifTrue:[ self cancel ].
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 9/21/2006 14:11'!
fontFamily: aString 
	"change the receiver's fontFamiliy"

	super fontFamily: aString.
	fontFamily := aString! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 9/21/2006 13:00'!
fontSize: aNumberOrString
	"change the receiver's fontSize"

	super fontSize: aNumberOrString.
	fontSize := aNumberOrString.
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 9/21/2006 17:19'!
fontWeight: aNumberOrString
	"change the receiver's fontWeight"

	super fontWeight: aNumberOrString.

	fontWeight := aNumberOrString.
! !

!SWTEditInPlaceText methodsFor: 'initialization' stamp: 'dgd 10/18/2006 19:11'!
initialize
	super initialize.

	editing := false.
	editingType := 'click'.
	multiLine := false.
	readOnly := false.
	acceptOnBlur := true.
	autoSetContents := true.! !

!SWTEditInPlaceText methodsFor: 'dom counterpart' stamp: 'dgd 8/11/2006 18:28'!
initializeDom
	"the receiver's dom counterpart was just created, initialize it"

	super initializeDom.

	self installHandlers.
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 11/3/2007 18:10'!
installEditEventsHandlers

	| editor |

	editor := self domFirstChild.

	self valueOfProperty: #onEditFocus ifPresentDo:[:onEditFocus |
		| focusHandler |

		focusHandler := [:domEvent |
				| event |
				event := SWTEvent type: #Focus source: self domEvent: domEvent.
				onEditFocus do:[:each | each value: event].
			].
				
		editor jsSet: #onfocus to: focusHandler.
	].
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 10/8/2006 15:20'!
installEditHandlers

	| handler editor |

	editor := self domFirstChild.

	handler := [:domEvent | self switchToNormalMode: false].

	self flag: #todo.	"register keypress, to capture the CR/TAB key to accept and Escape key to cancel"

	acceptOnBlur inlineIfTrue:[
		editor jsSet: #onblur to: handler.
	].
	"editor jsSet: #onchange to: handler."
	(editingType = 'mouseover') inlineIfTrue: [
		editor jsSet: #onmouseout to: handler.
	].

	self installEditEventsHandlers.
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 9/23/2006 19:46'!
installHandlers
	"private - install all the events handlers corresponding the the editing mode of the receiver"

	readOnly ifTrue:[^ self].

	editing
		inlineIfTrue: [ self installEditHandlers ]
		ifFalse: [ self installNoEditHandlers ].
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 9/21/2006 14:47'!
installNoEditHandlers

	| myDom handler |

	myDom := self dom.
	handler := [:domEvent |
						myDom jsStyleSet: #backgroundColor to: ''.
						self switchToEditMode.
				].

	(editingType = 'mouseover')
		inlineIfTrue: [ myDom jsSet: #onmouseover to: handler ]
		ifFalse: [
			editBackgroundColor isNil inlineIfFalse:[
				myDom jsSet: #onmouseover to: [ myDom jsStyleSet: #backgroundColor to: editBackgroundColor lighter asColorString ].
				myDom jsSet: #onmouseout to: [ myDom jsStyleSet: #backgroundColor to: '' ].
			].
		].

	(editingType = 'click')
		inlineIfTrue: [ myDom jsSet: #onclick to: handler ].

	(editingType = 'dblclick')
		inlineIfTrue: [ myDom jsSet: #ondblclick to: handler ].
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 9/20/2006 18:51'!
isEditing
	^ editing! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 10/18/2006 19:08'!
newContents
	^ newContents! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 11/3/2007 18:12'!
onAbort: aBlock 
	"registers a block, to evaluate, when onAbort event occurs"

	"is very first handler?"
	| handlers |
	handlers := self
						valueOfProperty: #onAbort
						ifAbsentPut: [OrderedCollection new].

	handlers add: aBlock! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 11/3/2007 18:10'!
onChange: aBlock 
	"registers a block, to evaluate, when onChange event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onChange
						ifAbsentPut: [OrderedCollection new].

	handlers add: aBlock.
! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 8/11/2006 11:33'!
onClick: aBlock 
	self error: 'click is hardcoded'.
! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 8/11/2006 11:43'!
onDblClick: aBlock 
	self error: 'dblclick is hardcoded'.
! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 11/3/2007 18:12'!
onEditEnd: aBlock 
	"registers a block, to evaluate, when onEdit event occurs"

	"is very first handler?"
	| handlers |

	handlers := self
						valueOfProperty: #onEditEnd
						ifAbsentPut: [OrderedCollection new].

	handlers add: aBlock! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 11/3/2007 18:12'!
onEditFocus: aBlock 
	"registers a block, to evaluate, when onEdit event occurs"

	"is very first handler?"
	| handlers |

	self ensureNonEditing.

	handlers := self
						valueOfProperty: #onEditFocus
						ifAbsentPut: [OrderedCollection new].

	handlers add: aBlock.

	self resetHandlers.
! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 11/3/2007 18:12'!
onEditStart: aBlock 
	"registers a block, to evaluate, when onEdit event occurs"

	"is very first handler?"
	| handlers |

	handlers := self
						valueOfProperty: #onEditStart
						ifAbsentPut: [OrderedCollection new].

	handlers add: aBlock! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 8/11/2006 11:43'!
onMouseOut: aBlock 
	self error: 'mouseout is hardcoded'.
! !

!SWTEditInPlaceText methodsFor: 'events' stamp: 'dgd 8/11/2006 11:43'!
onMouseOver: aBlock 
	self error: 'mouseover is hardcoded'.
! !

!SWTEditInPlaceText methodsFor: 'accessing' stamp: 'dgd 9/23/2006 19:47'!
readOnly: aBoolean

	(readOnly = aBoolean)
		ifTrue:[^ self].

	self ensureNonEditing.

	readOnly := aBoolean.

	self resetHandlers.
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 9/23/2006 19:46'!
resetHandlers
	"private - reinstall the events handlers."

	self clearHandlers.
	self installHandlers.
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 11/3/2007 18:09'!
switchToEditMode

	| editor h |

	editing ifTrue:[^ self].
	editing := true.

	h := self height + 4.

	multiLine
		inlineIfTrue:[
			editor := self domCreateElement: 'textarea'.
			h := h max: 200.
		]
		ifFalse:[
			editor := self domCreateElement: 'input'.
			editor jsSet: #type to: 'text'.
		].
	editor jsSet: #value to: self contentsToEdit.

	editor jsStyleSet: #width to: self width.
	editor jsStyleSet: #height to: h.
	editor jsStyleSet: #borderWidth to: 2.
	editor jsStyleSet: #borderStyle to: 'solid'.

	self backgroundColor isNil inlineIfFalse:[
		editor jsStyleSet: #backgroundColor to: self backgroundColor asColorString.
		editor jsStyleSet: #borderColor to: self backgroundColor muchDarker asColorString.
	].
	editBackgroundColor isNil inlineIfFalse:[
		editor jsStyleSet: #backgroundColor to: editBackgroundColor asColorString.
		editor jsStyleSet: #borderColor to: editBackgroundColor muchDarker asColorString.
	].

	fontSize isNil inlineIfFalse:[
		editor jsStyleSet: #fontSize to: fontSize.
	].
	fontFamily isNil inlineIfFalse:[
		editor jsStyleSet: #fontFamily to: fontFamily.
	].
	fontWeight isNil inlineIfFalse:[
		editor jsStyleSet: #fontWeight to: fontWeight.
	].

"
	self domReplaceChild: self domFirstChild with: editor.
"
	self domReplaceAllChildrenWith: editor.

	"workaround for the firefox bug: https://bugzilla.mozilla.org/show_bug.cgi?id=236791"
	self jsLiteral: 'editor.setAttribute(''autocomplete'', ''off'')'.

	self jsLiteral: 'editor.focus()'.

	self resetHandlers.

	self valueOfProperty: #onEditStart ifPresentDo:[:onEditStart |
		| event |
		event := SWTEvent type: #EditStart source: self domEvent: nil.
		onEditStart do:[:each | each value: event].
	].
! !

!SWTEditInPlaceText methodsFor: 'private' stamp: 'dgd 11/3/2007 18:10'!
switchToNormalMode: cancelBoolean

	| editor |

	editing ifFalse:[^ self].
	editing := false.

	editor := self domFirstChild.
	cancelBoolean inlineIfTrue:[
		self valueOfProperty: #onAbort ifPresentDo:[:onAbort |
			| event |
			event := SWTEvent type: #Abort source: self domEvent: nil.
			onAbort do:[:each | each value: event].
		]
	]
	ifFalse:[
		newContents := editor jsGet: #value.
		autoSetContents ifTrue:[
			contents := newContents.
		].

		self valueOfProperty: #onChange ifPresentDo:[:onChange |
			| event |
			event := SWTEvent type: #Change source: self domEvent: nil.
			onChange do:[:each | each value: event].
		]
	].

"
	text := self domCreateTextNode: self contents.
	self domReplaceChild: editor with: text.
"
	self dom jsSet: #innerHTML to: self contents.

	self resetHandlers.

	self valueOfProperty: #onEditEnd ifPresentDo:[:onEditEnd |
		| event |
		event := SWTEvent type: #EditEnd source: self domEvent: nil.
		onEditEnd do:[:each | each value: event].
	].
! !

SWTText subclass: #SWTHeader
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Widgets'!

!SWTHeader class methodsFor: 'instance creation' stamp: 'dgd 8/10/2006 19:09'!
level: anInteger contents: aString
	^ (self contents: aString) initializeLevel: anInteger! !

!SWTHeader methodsFor: 'dom counterpart' stamp: 'dgd 8/29/2006 18:41'!
createOuterDom

	| type |

	type := 'h' , level asString.

	^ self domCreateElement: type! !

!SWTHeader methodsFor: 'initialization' stamp: 'dgd 8/29/2006 16:47'!
initialize

	super initialize.

	level := 1.
! !

!SWTHeader methodsFor: 'initialization' stamp: 'dgd 8/10/2006 19:09'!
initializeLevel: anInteger
	level := anInteger.
! !

!SWTText class methodsFor: 'instance creation' stamp: 'dgd 8/10/2006 19:09'!
contents: aString
	^ self new initializeContents: aString! !

!SWTText class methodsFor: 'instance creation' stamp: 'dgd 10/22/2007 18:52'!
forAspect: anAspect

	| instance |

	instance := self contents: [ anAspect value ]. "this block is to produce a delay on the aspect evaluation to make it happens after #onChangeSend:to: sending"

	instance aspect: anAspect.

	anAspect onChangeSend: #contents: to: instance.

	^ instance
! !

!SWTText class methodsFor: 'instance creation' stamp: 'dgd 10/15/2006 17:16'!
model: anObject
	^ self contents: anObject! !

!SWTText methodsFor: 'accessing' stamp: 'dgd 10/15/2006 17:18'!
contents
	"Answer the receiver's contents"
	^ contents value! !

!SWTText methodsFor: 'accessing' stamp: 'dgd 9/21/2006 13:08'!
contents: aString
	"Answer the receiver's contents"
	contents := aString.

	self updateDomContents.
! !

!SWTText methodsFor: 'dom counterpart' stamp: 'dgd 9/21/2006 20:51'!
createDom

	| outer |

	outer := self createOuterDom.
"
	text := self domCreateTextNode: contents.
	self jsLiteral: 'outer.appendChild(text)'.

"
	outer jsSet: #innerHTML to: self contents "toHtml".

	^ outer.
! !

!SWTText methodsFor: 'dom counterpart' stamp: 'dgd 11/6/2006 17:34'!
createOuterDom

	^ self domCreateElement: 'span'! !

!SWTText methodsFor: 'initialization' stamp: 'dgd 8/10/2006 19:08'!
initializeContents: aString
	contents := aString.! !

!SWTText methodsFor: 'accessing' stamp: 'dgd 9/21/2006 20:51'!
updateDomContents

	self dom jsSet: #innerHTML to: self contents "toHtml".
! !

!SWTWidget class methodsFor: 'instance creation' stamp: 'dgd 10/18/2006 14:59'!
dom: aDomElement
	^ self new initializeDom: aDomElement! !

!SWTWidget class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 10/30/2007 19:27'!
jsClassesToInclude

	| result |
	
	result := Set new.

	result addAll: S2SPoint withAllSubclasses.
	result addAll: S2SColor withAllSubclasses.
	result addAll: S2STime jsWithAllClassesToInclude.

	result addAll: SWTEvent withAllSubclasses.
	result addAll: SWTAbstractEffect withAllSubclasses.
	result addAll: SWTDomDecorator withAllSubclasses.

	result addAll: SWTAbstractModel jsWithAllClassesToInclude.
	result addAll: SWTModel jsWithAllClassesToInclude.
	result addAll: SWTRemoteModel jsWithAllClassesToInclude.

	^ result
! !

!SWTWidget class methodsFor: '- only smalltalk - javascript-translation' stamp: 'dgd 8/8/2006 16:28'!
jsPreSource
	^ '/* SWT namespace */
var SWT = {};
'! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 10/8/2006 12:35'!
accessKey: aString
	"change the receiver's accesskey"

	self dom
			jsSet: #accessKey
			to: aString.
! !

!SWTWidget methodsFor: 'drop shadows' stamp: 'dgd 6/14/2007 13:39'!
addDropShadow

	dropShadow notNil inlineIfTrue:[^ self].

	dropShadow := self createDropShadow.

	parent addWidget: dropShadow.
	self forceStep.
! !

!SWTWidget methodsFor: 'drop shadows' stamp: 'dgd 6/10/2007 15:05'!
addDropShadowDomDecorator
	self domDecorator: SWTShadowDomDecorator new! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 10/14/2006 17:12'!
animateCenter

	self animatePositionTo: self parent center - (self extent // 2).
! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 9/30/2006 13:14'!
animateOpacityBy: deltaOpacityNumber

	self animateOpacityTo: (self opacity + deltaOpacityNumber)
! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 6/14/2007 15:25'!
animateOpacityTo: opacityNumber

	(SWTOpacityEffect from: self opacity to: opacityNumber) startFor: self.! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 6/14/2007 15:25'!
animatePositionTo: aPoint

	(SWTPositionEffect from: self position to: aPoint) startFor: self.! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 6/14/2007 15:25'!
animatePositionTo: aPoint time: aNumber 

	(SWTPositionEffect to: aPoint time: aNumber) startFor: self.! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 6/14/2007 15:25'!
appear

	(SWTOpacityEffect from: (self opacity ifNil:[0]) to: 1) startFor: self.! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 11/15/2006 11:20'!
asBoxColor: aColor

	^ self asBoxColor: aColor padding: 10! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 11/15/2006 11:20'!
asBoxColor: aColor padding: anInteger

	| box |

	box := SWTPanel new.
	box
		backgroundColor: aColor;
		padding: anInteger.

	box addWidget: self.

	^ SWTRowPanel withAllWidgets: {box}! !

!SWTWidget methodsFor: 'private' stamp: 'dgd 11/5/2007 19:10'!
aspect

	^ self valueOfProperty: #aspect
! !

!SWTWidget methodsFor: 'private' stamp: 'dgd 11/3/2007 18:19'!
aspect: anAspect

	self setProperty: #aspect toValue: anAspect.
! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 11/14/2006 12:30'!
asShadowedBoxColor: aColor

	^ self asShadowedBoxColor: aColor padding: 10! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 11/14/2006 12:30'!
asShadowedBoxColor: aColor padding: anInteger

	| shadowedBox |

	shadowedBox := SWTPanel new.
	shadowedBox
		addDropShadow;
		backgroundColor: aColor;
		padding: anInteger.

	shadowedBox addWidget: self.

	^ SWTRowPanel withAllWidgets: {shadowedBox}! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 11/3/2007 18:18'!
backgroundColor
	"answer the receiver's backgroundColor"

	^ self valueOfProperty: #backgroundColor! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 11/3/2007 18:19'!
backgroundColor: aColorOrString
	"change the receiver's color"

	| cssColor |

	self setProperty: #backgroundColor toValue: aColorOrString.

	cssColor := aColorOrString isNil
							ifTrue: ['']
							ifFalse: [aColorOrString asColorString].

	self dom
			jsStyleSet: #backgroundColor
			to: cssColor.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 7/1/2007 15:04'!
backgroundImage: aString

	| url |

	aString isNil
		inlineIfTrue:[ url := nil]
		ifFalse:[url := 'url(' , (self fullSrcFor: aString) , ')'].

	self dom
		jsStyleSet: #backgroundImage
		to: url.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 11/6/2007 15:26'!
backgroundRepeat: aString


	self dom
		jsStyleSet: #backgroundRepeat
		to: aString.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/6/2006 19:31'!
beAbsolute

"self isWindow inlineIfTrue:[self halt]."

	self decoratedDom
				jsStyleSet: #position
				to: 'absolute'.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/7/2007 17:20'!
beFixed

	self decoratedDom
				jsStyleSet: #position
				to: 'fixed'.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/6/2006 18:41'!
beRelative

	self decoratedDom
				jsStyleSet: #position
				to: 'relative'.
! !

!SWTWidget methodsFor: 'private' stamp: 'dgd 6/14/2007 16:28'!
beRootIn: anApplication 
	"PRIVATE - The receiver is, now, the root widget"

	self testBoxModel.
! !

!SWTWidget methodsFor: 'accessing - font' stamp: 'dgd 9/4/2006 20:01'!
bold
	"change the receiver's fontWeight to bold"

	self fontWeight: 'bold'! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/3/2007 18:11'!
border
	"answer the receiver's border"

	^ self valueOfProperty: #border ifAbsent: [0]! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/4/2006 21:21'!
borderColor: aColorOrString
	"change the receiver's borderColor"

	self dom
			jsStyleSet: #borderColor
			to: aColorOrString asColorString.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/3/2007 18:20'!
border: aNumberOrString
	"change the receiver's border"

	self setProperty: #border toValue: aNumberOrString.

	self dom
			jsStyleSet: #border
			to:aNumberOrString asString , 'px solid'
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 10/2/2006 13:12'!
bottom

	^ self bounds bottom! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 9/30/2006 13:30'!
bottomRight

	^ self bounds bottomRight! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/5/2007 15:06'!
bottom: aNumber
	" Move me so that my bottom is at the y-coordinate aNumber. My extent (width & height) are unchanged "

	self top: aNumber - self height
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/8/2006 16:49'!
bounds
	^ self topLeft extent: self extent! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 6/19/2007 14:02'!
bounds: newBounds

	| oldExtent newExtent |

	oldExtent := self extent.
	newExtent := newBounds extent.

	(oldExtent dotProduct: oldExtent) <= (newExtent dotProduct: newExtent) inlineIfTrue:[
		"We're growing. First move then resize."
		self position: newBounds topLeft.
		self extent: newExtent.
	] ifFalse:[
		"We're shrinking. First resize then move."
		self extent: newExtent.
		self position: newBounds topLeft.
	].
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 10/14/2006 17:09'!
center

	^ self bounds center! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 10/14/2006 17:08'!
center: aPoint
	self position: (aPoint - (self extent // 2)).! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/9/2007 12:12'!
cleanUp

	| myDom mod |

	self scheduler stopAllEffectsForWidget: self.

	mod := self model.
	mod isNil inlineIfFalse:[
		mod removeActionsWithReceiver: self.
	].

	self valueOfProperty: #aspect ifPresentDo:[:theAspect |
		theAspect removeActionsWithReceiver: self.
	].

	myDom := self dom.
	myDom jsSet: #onclick				to: nil.
	myDom jsSet: #ondblclick			to: nil.
	myDom jsSet: #onmousedown	to: nil.
	myDom jsSet: #onmousemove	to: nil.
	myDom jsSet: #onmouseout		to: nil.
	myDom jsSet: #onmouseover		to: nil.
	myDom jsSet: #onmouseup		to: nil.

	parent isNil inlineIfFalse:[
		| priorPanel |
		self logWarning: self asString , ': has parent in the cleanUp event!!'.
		priorPanel := parent.
		parent := nil.
		priorPanel removeWidget: self.
	].

	self valueOfProperty: #onCleanUpHandlers ifPresentDo:[:handlers |
		| event |
		event := SWTEvent type: #CleanUp source: self domEvent: nil.

		handlers do: [:each | each value: event].

		self removeProperty: #onCleanUpHandlers.
	].
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:19'!
clearOnClick

	self dom jsSet: #onclick to: nil.
	self removeProperty: #onClickHandlers.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:19'!
clearOnMouseMove

	self dom jsSet: #onmousemove to: nil.
	self removeProperty: #onMouseMoveHandlers.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:19'!
clearOnMouseOut

	self dom jsSet: #onmouseout to: nil.
	self removeProperty: #onMouseOutHandlers.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:19'!
clearOnMouseUp

	self dom jsSet: #onmouseup to: nil.
	self removeProperty: #onMouseUpHandlers.
! !

!SWTWidget methodsFor: 'enumerating' stamp: 'dgd 6/13/2007 13:05'!
collect: aBlock
	| result |
	result := OrderedCollection new.
	self do:[:each |
		result add: (aBlock value: each).
	].
	^ result.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 11/3/2007 18:18'!
color
	"answer the receiver's color"

	^ self valueOfProperty: #color! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 11/3/2007 18:20'!
color: aColorOrString
	"change the receiver's color"

	self setProperty: #color toValue: aColorOrString.

	self dom
			jsStyleSet: #color
			to: aColorOrString asColorString.
! !

!SWTWidget methodsFor: 'connection/disconnection' stamp: 'dgd 4/18/2007 22:49'!
connectUI
	self enable: true.
! !

!SWTWidget methodsFor: 'dom counterpart' stamp: 'dgd 8/8/2006 16:54'!
createDom
	"create the receiver's dom counterpart"

	^ self subclassResponsibility.
! !

!SWTWidget methodsFor: 'drop shadows' stamp: 'dgd 6/13/2007 12:20'!
createDropShadow

	| ds |

	ds := SWTPanel new.
	ds
		beAbsolute;
		position: self dropShadowPosition;
		extent: self extent;
		backgroundColor: self dropShadowColor;
		opacity: 0.7.

	^ ds.
! !

!SWTWidget methodsFor: 'dom counterpart' stamp: 'dgd 8/15/2006 13:24'!
cssClassName
	"answer the className to set on the receiver's dom counterpart"
	^ self className! !

!SWTWidget methodsFor: 'accessing - cursor' stamp: 'dgd 9/29/2006 14:16'!
cursorAuto
	"change the receiver's cursor"

	self cursor: 'auto'! !

!SWTWidget methodsFor: 'accessing - cursor' stamp: 'dgd 9/29/2006 14:16'!
cursorCrosshair
	"change the receiver's cursor"

	self cursor: 'crosshair'! !

!SWTWidget methodsFor: 'accessing - cursor' stamp: 'dgd 9/29/2006 14:17'!
cursorDefault
	"change the receiver's cursor"

	self cursor: 'default'! !

!SWTWidget methodsFor: 'accessing - cursor' stamp: 'dgd 9/30/2006 13:25'!
cursorEResize
	"change the receiver's cursor"

	self cursor: 'e-resize'.
! !

!SWTWidget methodsFor: 'accessing - cursor' stamp: 'dgd 9/29/2006 14:14'!
cursorMove
	"change the receiver's cursor"

	self cursor: 'move'! !

!SWTWidget methodsFor: 'accessing - cursor' stamp: 'dgd 10/19/2006 09:25'!
cursorPointer
	"change the receiver's cursor"

	self cursor: 'pointer'.
! !

!SWTWidget methodsFor: 'accessing - cursor' stamp: 'dgd 9/30/2006 13:32'!
cursorSEResize
	"change the receiver's cursor"

	self cursor: 'se-resize'.
! !

!SWTWidget methodsFor: 'accessing - cursor' stamp: 'dgd 9/30/2006 13:25'!
cursorWResize
	"change the receiver's cursor"

	self cursor: 'w-resize'.
! !

!SWTWidget methodsFor: 'accessing - cursor' stamp: 'dgd 9/29/2006 14:14'!
cursor: aString
	"change the receiver's cursor"

	self dom
			jsStyleSet: #cursor
			to: aString.
! !

!SWTWidget methodsFor: 'private' stamp: 'dgd 11/6/2006 18:40'!
decoratedDom

	decoratedDom isNil inlineIfTrue:[
		domDecorator isNil
			inlineIfTrue: [ decoratedDom := self dom ]
			ifFalse: [ decoratedDom := domDecorator decorate: self dom ].
	].

	^  decoratedDom! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 10/9/2007 09:14'!
defaultBackgroundColor: aColorOrString
	"change the receiver's color"

	self backgroundColor isNil ifTrue:[
		self backgroundColor: aColorOrString.
	].! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 6/15/2007 12:54'!
deltaPosition
	^ deltaPosition! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 6/9/2007 11:00'!
deltaPosition: newPoint
	| newPosition |
	newPosition := self topLeft - deltaPosition + newPoint.
	deltaPosition := newPoint.
	self plainTopLeft: newPosition.
! !

!SWTWidget methodsFor: 'connection/disconnection' stamp: 'dgd 4/18/2007 22:48'!
disconnectUI
	self enable: false.
! !

!SWTWidget methodsFor: 'dom counterpart' stamp: 'dgd 8/11/2006 19:18'!
dom
	"answer the receiver's dom counterpart"

	dom isNil inlineIfTrue: [
		dom := self createDom.
		self initializeDom.
	].

	^ dom
! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 9/21/2006 13:42'!
domAppendChild: aDom

	| myDom |

	myDom := self dom.

	self jsLiteral: 'myDom.appendChild(aDom)'.
! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 9/21/2006 13:41'!
domClear

	self dom jsSet: #innerHTML to: ''.
! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 8/29/2006 18:39'!
domCreateElement: type
	^ self jsLiteral: 'document.createElement(type)'.! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 8/29/2006 18:36'!
domCreateTextNode: aString
	^ self jsLiteral: 'document.createTextNode(aString)'! !

!SWTWidget methodsFor: 'decorations' stamp: 'dgd 11/6/2006 18:15'!
domDecorator: aDomDecorator
	domDecorator := aDomDecorator! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 8/29/2006 18:33'!
domFirstChild

	| myDom |

	myDom := self dom.
	
	^ self jsLiteral: 'myDom.firstChild'.
! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 9/21/2006 13:44'!
domReplaceAllChildrenWith: newDom

	self domClear.
	self domAppendChild: newDom.
! !

!SWTWidget methodsFor: 'private - dom utilities' stamp: 'dgd 8/29/2006 18:36'!
domReplaceChild: currentDom with: newDom

	| myDom |

	myDom := self dom.

	self jsLiteral: 'myDom.replaceChild(newDom, currentDom)'.
! !

!SWTWidget methodsFor: 'enumerating' stamp: 'dgd 6/13/2007 12:55'!
do: aBlock
	aBlock value: self.
! !

!SWTWidget methodsFor: 'drop shadows' stamp: 'dgd 6/19/2007 14:06'!
dropShadowBounds

	^ self dropShadowPosition extent: self extent
! !

!SWTWidget methodsFor: 'drop shadows' stamp: 'dgd 6/13/2007 12:20'!
dropShadowColor

	^ Color black! !

!SWTWidget methodsFor: 'drop shadows' stamp: 'dgd 6/19/2007 14:06'!
dropShadowPosition

	^ self position + (5@5)! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 9/7/2006 10:59'!
enable: aBoolean
	"change the receiver's enable status"

	self dom
			jsSet: #disabled
			to: aBoolean not.
! !

!SWTWidget methodsFor: 'removing' stamp: 'dgd 11/10/2007 12:26'!
ensureRemoval
	"remove the receiver if it has a parent"

	self hasParent inlineIfTrue:[
		self remove.
	].
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/8/2006 16:41'!
extent
	^ self width @ self height.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 9/29/2006 10:29'!
extent: aPoint
	"Change the receiver's extent"

	self width: aPoint x.
	self height: aPoint y.
! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 6/14/2007 15:25'!
fade

	(SWTOpacityEffect from: (self opacity ifNil:[1]) to: 0) startFor: self.! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 10/9/2006 11:42'!
float: aString

	| myDom |

	myDom := self dom.

	myDom
		jsStyleSet: #cssFloat to: aString;
		jsStyleSet: #styleFloat to: aString.
! !

!SWTWidget methodsFor: 'accessing - font' stamp: 'dgd 9/21/2006 14:11'!
fontFamily: aString 
	"change the receiver's fontFamiliy"

	self dom
		jsStyleSet: #fontFamily
		to: aString.
! !

!SWTWidget methodsFor: 'accessing - font' stamp: 'dgd 9/4/2006 19:58'!
fontSize: aNumberOrString
	"change the receiver's fontSize"

	self dom
			jsStyleSet: #fontSize
			to: aNumberOrString.
! !

!SWTWidget methodsFor: 'accessing - font' stamp: 'dgd 9/4/2006 19:58'!
fontStyle: aNumberOrString
	"change the receiver's fontStyle"

	self dom
			jsStyleSet: #fontStyle
			to: aNumberOrString.
! !

!SWTWidget methodsFor: 'accessing - font' stamp: 'dgd 9/4/2006 19:59'!
fontWeight: aNumberOrString
	"change the receiver's fontWeight"

	self dom
			jsStyleSet: #fontWeight
			to: aNumberOrString.
! !

!SWTWidget methodsFor: 'stepping' stamp: 'dgd 6/13/2007 20:08'!
forceStep
	"Force a step right now"

	self scheduler forceStepFor: self.
! !

!SWTWidget methodsFor: 'private' stamp: 'dgd 11/7/2007 16:57'!
fullSrcFor: srcString
	"PRIVATE - Answer the full src (considering the resources directory) for the given srcString"

	srcString isNil
		inlineIfTrue:[^ nil].

	(srcString beginsWith: '/')
		inlineIfTrue:[^ srcString].

	(srcString beginsWith: 'http://')
		inlineIfTrue:[^ srcString].

	^ self application resourcesUrl , srcString.
! !

!SWTWidget methodsFor: 'drop shadows' stamp: 'dgd 6/8/2007 11:04'!
hasDropShadow

	^ dropShadow notNil! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 10/9/2007 20:12'!
hasEffectsRunning

	^ self scheduler anyEffectAffectsWidget: self.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 6/13/2007 12:14'!
hasParent
	"answer if the receiver's has a parent"

	^ parent notNil! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/6/2006 19:14'!
height
	^ self decoratedDom jsGet: #offsetHeight! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 6/13/2007 11:07'!
height: aNumberOrString

	| newHeight |

	"IE includes padding and border in width/height, the other browsers don't"
	(aNumberOrString isNumber and: [self isStandardBoxModel])
			inlineIfTrue: [ newHeight  := aNumberOrString - ((self padding + self border) * 2) ]
			ifFalse: [ newHeight  := aNumberOrString ].

	self isDecorated inlineIfTrue:[
		newHeight := newHeight - (self height - (self dom jsGet: #offsetHeight)).
	].

	self dom
			jsStyleSet: #height
			to: newHeight.
! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 6/7/2007 09:16'!
highlight

	^ self highlight: Color red muchLighter! !

!SWTWidget methodsFor: 'visual effects' stamp: 'dgd 10/9/2007 09:04'!
highlight: toColor

	| bacColor |

	bacColor := self backgroundColor.
	bacColor isNil ifTrue:[bacColor := Color white].

	(SWTColorEffect highlight: toColor from: bacColor) startFor: self.
! !

!SWTWidget methodsFor: 'initialization' stamp: 'dgd 6/13/2007 20:08'!
initialize
	super initialize.
	deltaPosition := 0@0.
! !

!SWTWidget methodsFor: 'dom counterpart' stamp: 'dgd 9/29/2006 14:19'!
initializeDom
	"the receiver's dom counterpart was just created, initialize it"

	self dom jsSet: #className to: self cssClassName.
"
	self cursorDefault.
"! !

!SWTWidget methodsFor: 'initialization' stamp: 'dgd 10/18/2006 14:59'!
initializeDom: aDomElement
	dom := aDomElement.
	self initializeDom.
! !

!SWTWidget methodsFor: 'decorations' stamp: 'dgd 11/7/2006 09:38'!
isDecorated
"	^  self dom ~= self decoratedDom"
	^  domDecorator notNil! !

!SWTWidget methodsFor: 'testing' stamp: 'dgd 10/2/2006 10:12'!
isInIE

	| userAgent |

	userAgent := self userAgent asLowercase.

	^ (userAgent includesSubString: 'msie') and: [ (userAgent includesSubString: 'opera') not]
! !

!SWTWidget methodsFor: 'testing' stamp: 'dgd 6/13/2007 18:56'!
isPanel
	^ false! !

!SWTWidget methodsFor: 'testing' stamp: 'dgd 11/3/2007 18:18'!
isStandardBoxModel
	"answer the receiver's standardBoxModel"

	parent isNil
			inlineIfTrue: [ ^ (self valueOfProperty: #standardBoxModel) == true]
			ifFalse: [ ^ parent isStandardBoxModel ].
! !

!SWTWidget methodsFor: 'stepping' stamp: 'dgd 6/13/2007 18:47'!
isValidForStepping
	^ parent notNil and:[parent isValidForStepping]! !

!SWTWidget methodsFor: 'testing' stamp: 'dgd 9/29/2006 13:44'!
isWindow
	"Answer if the receiver is a window"
	^ false! !

!SWTWidget methodsFor: 'accessing - font' stamp: 'dgd 9/4/2006 20:01'!
italic
	"change the receiver's fontWeight to italic"

	self fontStyle: 'italic'! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 6/13/2007 17:44'!
justAddedIn: aPanel

! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/8/2006 16:23'!
left
	| result obj |

	result := 0.
	obj := self dom.

	self jsLiteral: '
	if (obj.offsetParent) {
		while (obj.offsetParent) {
			result += obj.offsetLeft;
			obj = obj.offsetParent;
		}
	}
	else if (obj.x) {
		result = obj.x;
	}'.

	^ result
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 10/26/2007 13:00'!
left: aNumberOrString

	| newNumber |

	aNumberOrString isNumber inlineIfTrue:[
		newNumber := aNumberOrString + deltaPosition x
	]
	ifFalse:[
		newNumber := aNumberOrString
	].

	self plainLeft: newNumber.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 11/3/2007 18:18'!
model
	"answer the receiver's model"

	^ self valueOfProperty: #model! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 11/3/2007 18:20'!
model: anObject
	"change the receiver's model"

	self
		setProperty: #model
		toValue: anObject.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:14'!
onCleanUp: aBlock 
	"registers a block, to evaluate, when onCleanup event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onCleanUpHandlers
						ifAbsentPut: [ OrderedCollection new ].

	handlers add: aBlock.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:17'!
onClick: aBlock 
	"registers a block, to evaluate, when onClick event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onClickHandlers
						ifAbsentPut: [
							"is very first handler?"
							| handler |

							handler :=  [:domEvent | 
										| event |

										event := SWTEvent type: #Click source: self domEvent: domEvent.

										(self valueOfProperty: #onClickHandlers)
											do: [:each | each value: event].
									].

							self dom jsSet: #onclick to: handler.

							OrderedCollection new.
						].

	handlers add: aBlock.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:14'!
onDblClick: aBlock 
	"registers a block, to evaluate, when onDblClick event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onDblClickHandlers
						ifAbsentPut: [
							"is very first handler?"
							| handler |

							handler :=  [:domEvent | 
										| event |

										event := SWTEvent type: #DblClick source: self domEvent: domEvent.

										(self valueOfProperty: #onDblClickHandlers)
											do: [:each | each value: event].
									].

							self dom jsSet: #ondblclick to: handler.

							OrderedCollection new.
						].

	handlers add: aBlock.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:15'!
onMouseDown: aBlock 
	"registers a block, to evaluate, when onMouseDown event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onMouseDownHandlers
						ifAbsentPut: [
							"is very first handler?"
							| handler |

							handler :=  [:domEvent | 
										| event |

										event := SWTEvent type: #MouseDown source: self domEvent: domEvent.

										(self valueOfProperty: #onMouseDownHandlers)
											do: [:each | each value: event].
									].

							self dom jsSet: #onmousedown to: handler.

							OrderedCollection new.
						].

	handlers add: aBlock.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:15'!
onMouseMove: aBlock 
	"registers a block, to evaluate, when onMouseMove event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onMouseMoveHandlers
						ifAbsentPut: [
							"is very first handler?"
							| handler |

							handler :=  [:domEvent | 
										| event |

										event := SWTEvent type: #MouseMove source: self domEvent: domEvent.

										(self valueOfProperty: #onMouseMoveHandlers)
											do: [:each | each value: event].
									].

							self dom jsSet: #onmousemove to: handler.

							OrderedCollection new.
						].

	handlers add: aBlock.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:15'!
onMouseOut: aBlock 
	"registers a block, to evaluate, when onMouseOut event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onMouseOutHandlers
						ifAbsentPut: [
							"is very first handler?"
							| handler |

							handler :=  [:domEvent | 
										| event |

										event := SWTEvent type: #MouseOut source: self domEvent: domEvent.

										(self valueOfProperty: #onMouseOutHandlers)
											do: [:each | each value: event].
									].

							self dom jsSet: #onmouseout to: handler.

							OrderedCollection new.
						].

	handlers add: aBlock.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:16'!
onMouseOver: aBlock 
	"registers a block, to evaluate, when onMouseOver event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onMouseOverHandlers
						ifAbsentPut: [
							"is very first handler?"
							| handler |

							handler :=  [:domEvent | 
										| event |

										event := SWTEvent type: #MouseOver source: self domEvent: domEvent.

										(self valueOfProperty: #onMouseOverHandlers)
											do: [:each | each value: event].
									].

							self dom jsSet: #onmouseover to: handler.

							OrderedCollection new.
						].

	handlers add: aBlock.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 11/3/2007 18:16'!
onMouseUp: aBlock 
	"registers a block, to evaluate, when onMouseUp event occurs"

	| handlers |

	handlers := self
						valueOfProperty: #onMouseUpHandlers
						ifAbsentPut: [
							"is very first handler?"
							| handler |

							handler :=  [:domEvent | 
										| event |

										event := SWTEvent type: #MouseUp source: self domEvent: domEvent.

										(self valueOfProperty: #onMouseUpHandlers)
											do: [:each | each value: event].
									].

							self dom jsSet: #onmouseup to: handler.

							OrderedCollection new.
						].

	handlers add: aBlock.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 11/3/2007 18:19'!
opacity
	"answer the receiver's opacity"

	^ self valueOfProperty: #opacity! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 11/3/2007 18:20'!
opacity: aFloat
	"change the receiver's opacity"

	| myDom newOpacity |

	newOpacity := aFloat isNil
							ifTrue:[ 1 ]
							ifFalse:[ aFloat min: 1 max: 0].

	self setProperty: #opacity toValue: newOpacity.

	myDom := self dom.

	myDom jsStyleSet: #opacity			to: newOpacity.
	myDom jsStyleSet: #MozOpacity		to: newOpacity.
	myDom jsStyleSet: #KhtmlOpacity	to: newOpacity.
	myDom jsStyleSet: #filter				to: 'alpha(opacity=' , (newOpacity * 100) rounded asString , ')'.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/3/2007 18:11'!
padding
	"Answer the receiver's padding"

	^ self valueOfProperty: #padding ifAbsent: [0]
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/3/2007 18:20'!
padding: anIntegerOrString
	"Change the receiver's padding"

	self setProperty: #padding toValue: anIntegerOrString.

	self dom
		jsStyleSet: #padding
		to: anIntegerOrString.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 8/9/2006 13:20'!
parent
	"answer the receiver's parent"

	^ parent! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 6/9/2007 10:56'!
plainLeft: aNumberOrString

	self decoratedDom
				jsStyleSet: #left
				to: aNumberOrString.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 10/26/2007 12:59'!
plainTopLeft: aPoint
	"Change the receiver's top and left"

	self plainLeft: aPoint x.
	self plainTop: aPoint y.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 6/9/2007 10:56'!
plainTop: aNumberOrString

	self decoratedDom
				jsStyleSet: #top
				to: aNumberOrString.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 9/30/2006 14:22'!
position
	"Answer the receiver's position"

	^ self topLeft! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 9/30/2006 14:22'!
position: aPoint
	"Change the receiver's position"

	self topLeft: aPoint.! !

!SWTWidget methodsFor: 'printing' stamp: 'dgd 8/10/2006 13:12'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: ' bounds=('.
	aStream nextPutAll: self bounds asString.
	aStream nextPutAll: ')'.
! !

!SWTWidget methodsFor: 'removing' stamp: 'dgd 11/9/2007 12:00'!
remove
	"remove the receiver from its parent"

	self hasParent inlineIfFalse:[
		self log: 'Can''t remove, the receiver has not parent (' , self asString , ')'.
		^ self
	].

	self parent removeWidget: self.
! !

!SWTWidget methodsFor: 'drop shadows' stamp: 'dgd 6/14/2007 13:39'!
removeDropShadow

	dropShadow notNil inlineIfFalse:[^ self].

	dropShadow remove.
	dropShadow := nil.
! !

!SWTWidget methodsFor: 'private' stamp: 'dgd 10/9/2007 09:22'!
removedFromParent: aPanel
	"The receiver is just removed from its parent"
"
	self
		assert: [parent notNil]
		errorMessage: 'The widget has not a parent.'.

	self
		assert: [parent == aPanel]
		errorMessage: 'The widget has a different parent!!'.
"
	parent stopStepping: self.
	parent := nil.

	self cleanUp.
! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 12/12/2006 14:01'!
resized
"	self logWarning: self asString, ' received resize notification'."
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 9/29/2006 14:27'!
right
	^ self left + self width
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/3/2007 11:01'!
right: aNumber
	" Move me so that my right side is at the x-coordinate aNumber. My extent (width & height) are unchanged "

	self left: aNumber - self width.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 10/3/2006 12:25'!
root
	"answer the receiver's parent"

	parent isNil
			inlineIfTrue: [ ^ self ]
			ifFalse: [ ^ parent root ].
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 6/12/2007 11:36'!
scheduler
	^ self application scheduler! !

!SWTWidget methodsFor: 'events' stamp: 'dgd 10/22/2007 15:48'!
scrolled
"	self logWarning: self asString, ' received scrolled notification'."
! !

!SWTWidget methodsFor: 'enumerating' stamp: 'dgd 6/13/2007 12:59'!
select: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |

	newCollection := OrderedCollection new.

	self do:[:each |
		(aBlock value: each)
			ifTrue: [newCollection add: each]
	].

	^ newCollection.
! !

!SWTWidget methodsFor: 'private' stamp: 'dgd 11/9/2007 12:05'!
setParent: aPanel
	"PRIVATE- change the receiver's parent"

	self
		assert: [aPanel notNil]
		errorMessage: '#parent: nil'.
	self
		assert: [parent isNil]
		errorMessage: 'The widget already has a parent!!'.

	parent := aPanel.

	self justAddedIn: aPanel.
	self tryToStartStepping.
! !

!SWTWidget methodsFor: 'stepping' stamp: 'dgd 6/14/2007 10:27'!
startStepping
	^ self startSteppingAt: nil! !

!SWTWidget methodsFor: 'stepping' stamp: 'dgd 6/14/2007 10:27'!
startSteppingAt: scheduledTime

	self scheduler
			startStepping: self
			at: scheduledTime.! !

!SWTWidget methodsFor: 'stepping' stamp: 'dgd 6/19/2007 14:08'!
step
	"Do some periodic activity."

	dropShadow notNil inlineIfTrue:[
		dropShadow bounds: self dropShadowBounds.
	].
! !

!SWTWidget methodsFor: 'stepping' stamp: 'dgd 6/18/2007 12:10'!
stepTime

	dropShadow notNil
		inlineIfTrue:[^ 10 ]
		ifFalse:[ ^ 1000 ]! !

!SWTWidget methodsFor: 'private' stamp: 'dgd 11/3/2007 18:20'!
testBoxModel

	| testPanel w p b expectedWidth |

	testPanel := SWTPanel new.
	testPanel beAbsolute.
	self addWidget: testPanel.

	w := 20.
	p := 9.
	b := 3.

	testPanel dom
		jsStyleSet: #width to: w;
		jsStyleSet: #height to: w;
		jsStyleSet: #padding to: p;
		jsStyleSet: #border to: b asString , 'px solid'.

	expectedWidth := w + (p * 2) + (b * 2).
	self setProperty: #standardBoxModel toValue: (testPanel width = expectedWidth).

	testPanel remove.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 8/8/2006 16:24'!
top
	| result obj |

	result := 0.
	obj := self dom.

	self jsLiteral: '
	if (obj.offsetParent) {
		while (obj.offsetParent) {
			result += obj.offsetTop;
			obj = obj.offsetParent;
		}
	}
	else if (obj.y) {
		result = obj.y;
	}'.

	^ result
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 10/26/2007 12:59'!
topLeft
	^ self left @ self top! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 10/26/2007 13:01'!
topLeft: aPoint
	"Change the receiver's top and left"

	self left: aPoint x.
	self top: aPoint y.
! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 10/26/2007 13:00'!
top: aNumberOrString

	| newNumber |

	aNumberOrString isNumber inlineIfTrue:[
		newNumber := aNumberOrString + deltaPosition y
	]
	ifFalse:[
		newNumber := aNumberOrString
	].

	self plainTop: newNumber.
! !

!SWTWidget methodsFor: 'private' stamp: 'dgd 6/13/2007 18:46'!
tryToStartStepping

	self wantsSteps
		inlineIfFalse:[^ self].

	self isValidForStepping inlineIfTrue:[
		parent startStepping: self.
	].
! !

!SWTWidget methodsFor: 'testing' stamp: 'dgd 10/2/2006 10:11'!
userAgent

	^ self jsLiteral: 'navigator.userAgent'.
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 10/31/2007 10:49'!
visible: aBoolean

	| visibility display |

	aBoolean inlineIfTrue:[
		visibility := 'visible'.
		display := 'block'.
	]
	ifFalse:[
		visibility := 'hidden'.
		display := 'none'.
	].

	self dom jsStyleSet: #visibility  to: visibility.
	self dom jsStyleSet: #display  to: display.
! !

!SWTWidget methodsFor: 'stepping' stamp: 'dgd 6/12/2007 11:23'!
wantsSteps
	^ true! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 11/6/2006 19:14'!
width
	^ self decoratedDom jsGet: #offsetWidth.! !

!SWTWidget methodsFor: 'accessing - geometry' stamp: 'dgd 10/21/2007 14:52'!
width: aNumberOrString

	| newWidth |
"
	aNumberOrString := arg.

	aNumberOrString isNumber inlineIfTrue: [
		aNumberOrString < 0 inlineIfTrue: [
			self trace.
			self log: 'negative width'.
			aNumberOrString := 0.
		].
	].
"
	(aNumberOrString isNumber and: [self isStandardBoxModel])
			inlineIfTrue: [ newWidth := aNumberOrString - ((self padding + self border) * 2) ]
			ifFalse: [ newWidth := aNumberOrString ].

	self isDecorated inlineIfTrue:[
		newWidth := newWidth - (self width - (self dom jsGet: #offsetWidth)).
	].

	self dom
		jsStyleSet: #width
		to: newWidth. 
! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 10/19/2006 10:23'!
withAllWidgets
	^ { self }! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 11/6/2006 19:08'!
zIndex
	"answer the receiver's zIndex"

	^  self decoratedDom jsStyleGet: #zIndex! !

!SWTWidget methodsFor: 'accessing' stamp: 'dgd 6/14/2007 13:40'!
zIndex: anInteger
	"change the receiver's zIndex"

	self decoratedDom
			jsStyleSet: #zIndex
			to: anInteger.

	dropShadow notNil inlineIfTrue:[
		dropShadow zIndex: anInteger-1.
	].! !

!S2SArrayExtension methodsFor: '*SWT-views' stamp: 'dgd 10/27/2007 19:04'!
defaultViewClass
	^ SWTColumnPanel
! !

!S2SArrayExtension methodsFor: '*SWT-views' stamp: 'dgd 11/7/2007 13:34'!
defaultViewClassForArray 
	^ SWTRowPanel
! !

Object subclass: #SWTClientApplicationProxy
	instanceVariableNames: 'for multicast'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTClientApplicationProxy class methodsFor: 'instance creation' stamp: 'dgd 9/5/2006 19:52'!
for: aClientApplicationClass multicast: aBoolean
	^ self new initializeFor: aClientApplicationClass multicast: aBoolean! !

!SWTClientApplicationProxy methodsFor: 'error handling' stamp: 'dgd 9/5/2006 19:56'!
doesNotUnderstand: aMessage

	for isNil ifFalse:[
		(for class clientSideApplicationClass canUnderstand: aMessage selector) ifTrue:[
			multicast
				ifTrue: [ for multicastClientSideMessageSend: aMessage ]
				ifFalse: [ for pushClientSideMessageSend: aMessage ].

			^ self
		].
	].

	^ super doesNotUnderstand: aMessage.
! !

!SWTClientApplicationProxy methodsFor: 'initialization' stamp: 'dgd 9/5/2006 19:51'!
initialize
	multicast := false.! !

!SWTClientApplicationProxy methodsFor: 'initialization' stamp: 'dgd 9/5/2006 19:51'!
initializeFor: aClientApplicationClass multicast: aBoolean
	for := aClientApplicationClass.
	multicast := aBoolean.
! !

Object subclass: #SWTIdManager
	instanceVariableNames: 'lastId dictionary mutex onNewId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC'!

!SWTIdManager methodsFor: 'accessing' stamp: 'dgd 10/16/2007 16:30'!
at: idObject
	"answer the object that the id was asigned before"

	^ self
			at:idObject
			ifAbsent: [ self error:'Object not found for id:' , idObject asString ].
! !

!SWTIdManager methodsFor: 'accessing' stamp: 'dgd 10/16/2007 16:30'!
at: idObject ifAbsent: absentBlock 

	"answer the object that the id was asigned before"

	| value |

	mutex critical: [
			self flag: #todo. "TODO: be carefull when WeakDictionary will be used"

			value := dictionary at: idObject ifAbsent: [nil].

			value ifNil: [value := absentBlock value].
	].

	^ value.
! !

!SWTIdManager methodsFor: 'accessing' stamp: 'dgd 10/16/2007 16:31'!
at: idObject put: anObject

	"asign id to anObject"

	^ dictionary at: idObject put: anObject! !

!SWTIdManager methodsFor: 'private' stamp: 'dgd 10/17/2007 17:23'!
calculateNewId

	"PRIVATE: This method is called from a critical section, be carefull to call  it without synchronization"

	lastId := lastId + 1.

	(lastId isDivisibleBy: 10)
		ifTrue: [self depurate].

"
	lastIdAsString := 'OID-'
							, (self printHexFrom: 65535 atRandom)
							, (self printHexFrom: lastId)
							, (self printHexFrom: 65535 atRandom).

	^ lastIdAsString
"
	^ lastId! !

!SWTIdManager methodsFor: 'private' stamp: 'dgd 10/16/2007 16:34'!
depurate
	"PRIVATE: This method is called from a critical section, be carefull to call 
	it without synchonization"
	! !

!SWTIdManager methodsFor: 'accessing' stamp: 'dgd 10/16/2007 16:32'!
hasId: anObject 
	"answer if anObject has a id"

	anObject isNil
		ifTrue: [^ self error: 'can store a nil'].

	mutex critical: [
		dictionary
				keyAtIdentityValue: anObject
				ifAbsent: [^ false].
	].

	^ true! !

!SWTIdManager methodsFor: 'accessing' stamp: 'dgd 10/16/2007 16:48'!
idFor: anObject 
	"gives an id for anObject, the id will be the same in future calls"

	| newId newIdFlag |

	anObject isNil
		ifTrue: [^ self error: 'can store a nil'].

	newIdFlag := false.
	mutex critical: [
		newId := dictionary
							keyAtIdentityValue: anObject
							ifAbsent: [ newIdFlag := true. self newIdFor: anObject ].
	].

	newIdFlag ifTrue:[
		onNewId isNil ifFalse:[
			onNewId value: anObject value: newId.
		].
	].

	^ newId.
! !

!SWTIdManager methodsFor: 'initialization' stamp: 'dgd 10/16/2007 16:55'!
initialize
	"initialize the receiver"

	super initialize.

	lastId := 0.
	onNewId := nil.
	mutex := Semaphore forMutualExclusion.

	self initializeDictionary.
! !

!SWTIdManager methodsFor: 'initialization' stamp: 'dgd 10/16/2007 16:57'!
initializeDictionary
	"hook method"
	dictionary := Dictionary new.
! !

!SWTIdManager methodsFor: 'private' stamp: 'dgd 10/16/2007 16:50'!
newIdFor: anObject 

	"PRIVATE: This method is called from a critical section, be carefull to call  it without synchronization"

	| newId |

	newId := self calculateNewId.

	dictionary at: newId put: anObject.

	^ newId.
! !

!SWTIdManager methodsFor: 'accessing' stamp: 'dgd 10/16/2007 16:33'!
onNewId: aBlock
	onNewId := aBlock! !

!SWTIdManager methodsFor: 'private' stamp: 'dgd 10/16/2007 16:36'!
printHexFrom: anInteger
	"Noury Bouraqadi 9/22/2006 02:41"
	
	^(anInteger printPaddedWith: $0 to: 4 base: 16) allButFirst: 3! !

!SWTIdManager methodsFor: 'printing' stamp: 'dgd 10/16/2007 16:34'!
printOn: aStream 

	super printOn: aStream.

	aStream
		nextPutAll: ' last id=';
		nextPutAll: lastId asString;
		nextPutAll: ', objects count=';
		nextPutAll: dictionary size asString.
! !

!SWTIdManager methodsFor: 'removing' stamp: 'dgd 10/16/2007 16:56'!
removeId: idObject 

	| r |

	mutex critical: [
		r := dictionary removeKey: idObject.
	].

	^ r! !

!SWTIdManager methodsFor: 'accessing' stamp: 'dgd 10/16/2007 16:55'!
size
	"answer an estimated size"
	
	| s |

	mutex critical: [
		s := dictionary size.
	].

	^ s! !

SWTIdManager subclass: #SWTWeakIdManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC'!

!SWTWeakIdManager methodsFor: 'private' stamp: 'dgd 10/16/2007 16:57'!
depurate
	"PRIVATE: This method is called from a critical section, be carefull to call it without synchonization"

	dictionary keys do: [:eachKey |
		(dictionary at: eachKey) isNil ifTrue: [
			"message #keys make a Set, so I can remove without problem"
			dictionary removeKey: eachKey.
		].
	].
! !

!SWTWeakIdManager methodsFor: 'initialization' stamp: 'dgd 10/16/2007 16:57'!
initializeDictionary
	"hook method"
	dictionary := WeakValueDictionary new.
! !

Object subclass: #SWTServerApplication
	instanceVariableNames: 'socket clientSide clientSideMulticast ids currentId forwardProcess forwardQueue garbage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

SWTServerApplication subclass: #SWTControlPanelServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTControlPanelServerApplication methodsFor: 'as yet unclassified' stamp: 'dgd 10/31/2006 12:36'!
resetRunner
	SWTApplicationRunner reset.
! !

!SWTControlPanelServerApplication methodsFor: 'as yet unclassified' stamp: 'dgd 10/31/2006 12:36'!
resetS2STranslator
	S2STranslator clearInstance.
! !

!SWTControlPanelServerApplication methodsFor: 'as yet unclassified' stamp: 'dgd 10/31/2006 12:37'!
saveImage
	 SmalltalkImage current saveSession.
! !

SWTServerApplication subclass: #SWTEffectsServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

SWTServerApplication subclass: #SWTExampleServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

!SWTExampleServerApplication methodsFor: 'tests' stamp: 'dgd 10/9/2007 12:17'!
bar: anObject
	Transcript show: 'bar: ' , anObject asString; cr.

	^ anObject asString! !

!SWTExampleServerApplication methodsFor: 'tests' stamp: 'dgd 9/3/2006 16:47'!
foo
	Transcript show: 'foo!!'; cr.! !

!SWTExampleServerApplication methodsFor: 'tests' stamp: 'dgd 9/4/2006 11:33'!
ping
	Transcript show: 'ping!!'; cr.
	self clientSide pong.! !

SWTServerApplication subclass: #SWTMapServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-Map'!

SWTMapServerApplication class
	instanceVariableNames: 'MainForm FormMutex FormCache FormCacheMutex'!

!SWTMapServerApplication class methodsFor: 'accessing' stamp: 'dgd 12/13/2006 14:21'!
extentForCells
	"Answer a point with the extent for the receiver's cells"
	^ 256@256! !

!SWTMapServerApplication class methodsFor: 'accessing' stamp: 'dgd 12/15/2006 20:03'!
form
	"
	SWTMapServerApplication form.
	"

	| result |

	FormMutex critical: [
		MainForm isNil ifTrue:[
"			MainForm := Form fromFileNamed: 'Spain.A2003170.1120.250m.jpg'."
			MainForm := Form fromFileNamed: 'world.200401.3x5400x2700.jpg'.
		].

		result := MainForm.
	].

	^ result! !

!SWTMapServerApplication class methodsFor: 'accessing' stamp: 'dgd 12/13/2006 17:49'!
formForZoom: aNumber

	| result |

	FormCacheMutex critical: [
		result := FormCache at: aNumber
	].

	^ result.
! !

!SWTMapServerApplication class methodsFor: 'class initialization' stamp: 'dgd 12/13/2006 17:59'!
initialize
	"
	SWTMapServerApplication initialize.
	"

	MainForm := nil.
	FormMutex := Semaphore forMutualExclusion.

	FormCache := LRUCache
									size: 2
									factory: [:zoom | self form magnifyBy: zoom ].
	FormCacheMutex := Semaphore forMutualExclusion.
! !

!SWTMapServerApplication methodsFor: 'request hooks' stamp: 'dgd 12/13/2006 18:30'!
formForPosition: aPoint zoom: zoom

	| formExtent to area form |

	formExtent := self class extentForCells.

	to := aPoint * formExtent.
	area := (to - formExtent) corner: to.

	form := Form extent: formExtent depth: self class form depth.
	(self class formForZoom: zoom) contentsOfArea: area into: form.

"	area asString displayOn: form."

	^ form.
! !

!SWTMapServerApplication methodsFor: 'events - connection' stamp: 'dgd 12/13/2006 18:15'!
justConnected

	super justConnected.
	
	self clientSide applicationJustConnected: self class form extent.
! !

!SWTMapServerApplication methodsFor: 'request hooks' stamp: 'dgd 12/13/2006 18:22'!
map: aRequest 

	| position form stream response zoom |

	position := (aRequest fields at: 'x') asNumber @ (aRequest fields at: 'y') asNumber.

	zoom := (aRequest fields at: 'z' ifAbsent:[1]) asNumber.
	zoom := zoom roundTo: 0.05.
	form := self formForPosition: position zoom: zoom.

	stream :=  form asPNGStream.

	response := HttpResponse fromMIMEDocument: (MIMEDocument contentType: 'image/png' content: stream).
	response
		fieldAt: 'Expires'			put: (DateAndTime year: 1970 month: 1 day: 1) asHttpString;
		fieldAt: 'Cache-Control'	put: 'no-cache, must-revalidate, no-store';
		fieldAt: 'Pragma'			put: 'no-cache, no-store'.

	^ response.
! !

SWTServerApplication subclass: #SWTMVCServerApplication
	instanceVariableNames: ''
	classVariableNames: 'TheModel'
	poolDictionaries: ''
	category: 'SWT-Examples-MVC'!

!SWTMVCServerApplication methodsFor: 'accessing' stamp: 'dgd 11/21/2006 13:22'!
model
	"
	TheModel := nil.
	"

	^ TheModel ifNil: [ TheModel := SWTSampleModel new ].
! !

SWTServerApplication subclass: #SWTPingPongServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

!SWTPingPongServerApplication methodsFor: 'ping/pong' stamp: 'dgd 6/1/2007 11:03'!
ping
	Transcript show: 'ping!!'; cr.
	self clientSide pong.
! !

!SWTServerApplication class methodsFor: 'configuration' stamp: 'dgd 9/1/2006 19:06'!
clientSideApplicationClass

	"Answer the receiver's pair class"

	| csClassName |

	csClassName := self name copyReplaceAll: 'Server' with: 'Client'.

	^ Smalltalk
			at: csClassName asSymbol
			ifAbsent:[self subclassResponsibility].
! !

!SWTServerApplication class methodsFor: 'private' stamp: 'dgd 10/13/2006 20:11'!
htmlSource

	| library result |

	library := self serverApplicationProxySource , self scriptLibrary ", self scriptLibraryJSON".

	result := self clientSideApplicationClass htmlSourceWith: library.

	^ result.
! !

!SWTServerApplication class methodsFor: 'private' stamp: 'dgd 9/20/2006 15:49'!
scriptLibrary
	^ '
<script type="text/javascript">
var ServerApplicationName = "' , self name , '";
</script>
'! !

!SWTServerApplication class methodsFor: 'private' stamp: 'dgd 9/3/2006 16:52'!
scriptLibraryJSON
	^'
<script type="text/javascript">
<!!--
/*
    json.js
    2006-04-28

    This file adds these methods to JavaScript:

        object.toJSONString()

            This method produces a JSON text from an object. The
            object must not contain any cyclical references.

        array.toJSONString()

            This method produces a JSON text from an array. The
            array must not contain any cyclical references.

        string.parseJSON()

            This method parses a JSON text to produce an object or
            array. It will return false if there is an error.
*/
(function () {
    var m = {
            "\b": "\\b",
            "\t": "\\t",
            "\n": "\\n",
            "\f": "\\f",
            "\r": "\\r",
            ''"'' : ''\\"'',
            "\\": "\\\\"
        },
        s = {
            array: function (x) {
                var a = ["["], b, f, i, l = x.length, v;
                for (i = 0; i < l; i += 1) {
                    v = x[i];
                    f = s[typeof v];
                    if (f) {
                        v = f(v);
                        if (typeof v == "string") {
                            if (b) {
                                a[a.length] = ",";
                            }
                            a[a.length] = v;
                            b = true;
                        }
                    }
                }
                a[a.length] = "]";
                return a.join("");
            },
            "boolean": function (x) {
                return String(x);
            },
            "null": function (x) {
                return "null";
            },
            number: function (x) {
                return isFinite(x) ? String(x) : "null";
            },
            object: function (x) {
                if (x) {
                    if (x instanceof Array) {
                        return s.array(x);
                    }
                    var a = ["{"], b, f, i, v;
                    for (i in x) {
                        v = x[i];
                        f = s[typeof v];
                        if (f) {
                            v = f(v);
                            if (typeof v == "string") {
                                if (b) {
                                    a[a.length] = ",";
                                }
                                a.push(s.string(i), ":", v);
                                b = true;
                            }
                        }
                    }
                    a[a.length] = "}";
                    return a.join("");
                }
                return "null";
            },
            string: function (x) {
                if (/["\\\x00-\x1f]/.test(x)) {
                    x = x.replace(/([\x00-\x1f\\"])/g, function(a, b) {
                        var c = m[b];
                        if (c) {
                            return c;
                        }
                        c = b.charCodeAt();
                        return "\\u00" +
                            Math.floor(c / 16).toString(16) +
                            (c % 16).toString(16);
                    });
                }
                return ''"'' + x + ''"'';
            }
        };

    Object.prototype.toJSONString = function () {
        return s.object(this);
    };

    Array.prototype.toJSONString = function () {
        return s.array(this);
    };
})();

String.prototype.parseJSON = function () {
    try {
        return !!(/[^,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]/.test(
                this.replace(/"(\\.|[^"\\])*"/g, ""))) &&
            eval("(" + this + ")");
    } catch (e) {
        return false;
    }
};
-->
</script>
'! !

!SWTServerApplication class methodsFor: 'private' stamp: 'dgd 11/11/2007 16:04'!
selectorsForProxy

	^
		(self selectors copyWithoutAll: #(initialize)) asArray ,
		#(
				#modelId:perform:
				#modelId:perform:with:
				#performAsynchronousRPCQueue:

				"#modelId:when:send:toJsObjectId:withResultsOfSelectors:eventCount:onConflictSend:"
				#mId:w:s:tOId:wRS:eC:oCS:

				"#modelId:removeActionsWithJsReceiverId:"
				#mId:rAWRId:

				#noteClientLag:
				#noteClientRpcTime:

				#kill
		)
! !

!SWTServerApplication class methodsFor: 'private' stamp: 'dgd 10/22/2007 13:54'!
serverApplicationProxySource

	| result translator |

	result := String new writeStream.

	result nextPutAll: '<script type="text/javascript">'; cr.
	result nextPutAll: '/* proxy methods generated from ' , self name , ' */'; cr.

	translator := S2STranslator instance.

	self selectorsForProxy do:[:selector |
		| jsMethodName args |

		jsMethodName := translator convertSelectorToJsMethodName: selector.

		args := String streamContents:[:stream |
			(1 to: selector numArgs)
				do:[:index | stream nextPutAll: ('arg{1}' format: { index })]
				separatedBy:[ stream nextPutAll: ', '].
		].

		result nextPutAll: ('ST.SWTServerApplicationProxy.prototype.{1} = function(' format: { jsMethodName }).
		result nextPutAll: args.
		result nextPutAll: ') {'; cr.
		result nextPutAll: ('	return this.invokeJsonRPCMethod_arguments_(''{1}'', [{2}]);' format: { selector. args }); cr.
		result nextPutAll: '};'; cr.
	].

	result nextPutAll: '</script>'; cr.

	^ result contents.
! !

!SWTServerApplication class methodsFor: 'instance creation' stamp: 'dgd 9/3/2006 20:46'!
socket: aSWTCometSocket 
	^ self new initializeSocket: aSWTCometSocket ! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 8/31/2006 20:16'!
clientSide
	"Answer the receiver's client side counterpart"

	^ clientSide
! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 9/5/2006 19:53'!
clientSideMulticast
	"Answer the receiver's client side counterpart"

	^ clientSideMulticast
! !

!SWTServerApplication methodsFor: 'events - connection' stamp: 'dgd 11/6/2007 10:42'!
close

	forwardProcess isNil ifFalse:[
		forwardProcess terminate.
		forwardProcess := nil.
	].

	"EXPLANATION:
	assure garbage collection removing the non-weak references from MessageSend.
	see users of instance var: garbage.   -- dgd"
	garbage do:[:eachModel |
		eachModel removeActionsWithReceiver: self.
	].! !

!SWTServerApplication methodsFor: 'events - connection' stamp: 'dgd 10/31/2007 10:37'!
createForwardProcess

	forwardQueue := SharedQueue2 new.

	forwardProcess := [
								[ self forwardEvents ] repeat.
						] newProcess.

	forwardProcess name: 'Forward Process for ListenerID #' , socket listenerId asString.
	forwardProcess priority: Processor highIOPriority.
	forwardProcess resume.
! !

!SWTServerApplication methodsFor: 'events - connection' stamp: 'dgd 10/31/2007 10:45'!
forwardEvents

	| eventArgs groupSize eventsGroup |

	"wait for the first event from the queue"
	eventArgs := forwardQueue next.

	groupSize := 25.
	eventsGroup := OrderedCollection new: groupSize.
	eventsGroup add: eventArgs.

	"wait some time for more events, to send them as a group"
	(Delay forMilliseconds: 15) wait.

	"get all the available events from the queue without blocking"
	[(eventArgs := forwardQueue nextOrNil) isNil] whileFalse:[
		eventsGroup add: eventArgs.

		"sent them in packets of groupSize, to speed up the browser reaction"
		(eventsGroup size >= groupSize) ifTrue:[
			self clientSide receiveEvents: eventsGroup.
			eventsGroup := OrderedCollection new: groupSize.
		].
	].

	eventsGroup isEmpty ifFalse:[
		self clientSide receiveEvents: eventsGroup.
	].
! !

!SWTServerApplication methodsFor: 'remote mvc' stamp: 'dgd 11/2/2007 16:21'!
forwardWith: arg1Object with: arg2Object with: arg3Object message: selector to: idJsObject producer: aModel eventName: eventName withResultsOfSelectors: selectorsForResults

	| args |

	args := selectorsForResults isNil
						ifTrue: [ { arg1Object. arg2Object. arg3Object } ]
						ifFalse: [ selectorsForResults collect:[:eachSelector | aModel perform: eachSelector] ].

	forwardQueue nextPut: {eventName. selector. idJsObject. args}.
! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 10/17/2007 15:42'!
idFor: aModel 

	^ ids
			at: aModel
			ifAbsentPut:[ self nextId ]
! !

!SWTServerApplication methodsFor: 'initialization' stamp: 'dgd 10/17/2007 15:12'!
initialize
	"Initialize the receiver"

	super initialize.

	clientSide := SWTClientApplicationProxy for: self multicast: false.
	clientSideMulticast := SWTClientApplicationProxy for: self multicast: true.

	currentId := 0.
	ids := Dictionary new.
	garbage := WeakSet new.
! !

!SWTServerApplication methodsFor: 'initialization' stamp: 'dgd 9/5/2006 22:52'!
initializeSocket: aSWTCometSocket 
	socket := aSWTCometSocket.
! !

!SWTServerApplication methodsFor: 'pushing' stamp: 'dgd 11/9/2007 12:17'!
jsMethodInvocationFrom: aMessage 

	|  params translator jsMethodName |

	params := String new writeStream.

	aMessage arguments
		do: [:each | params nextPutAll: (each jsSerializedContext: self) jsAsTopEval ]
		separatedBy: [params nextPutAll: ', '].

	translator := S2STranslator instance.
	jsMethodName := translator convertSelectorToJsMethodName: aMessage selector.

	^ 'if (!!(app.{1}({2}) === app)) alert (''#{1} not returns self, invalid for #clientSide messages.'')'
			format: { jsMethodName. params contents }.
"
	^ 'app.{1}({2})'
			format: { jsMethodName. params contents }.
"! !

!SWTServerApplication methodsFor: 'events - connection' stamp: 'dgd 10/25/2007 15:11'!
justConnected


	self createForwardProcess.! !

!SWTServerApplication methodsFor: 'events - connection' stamp: 'dgd 9/20/2006 17:50'!
justConnectedSocket: aSWTCometSocket 
! !

!SWTServerApplication methodsFor: 'events - connection' stamp: 'dgd 9/5/2006 22:58'!
justDisconnected: aSWTCometSocket ! !

!SWTServerApplication methodsFor: 'as yet unclassified' stamp: 'dgd 11/3/2007 17:22'!
kill
	"dispose the receiver as it will be not used anymore"

	socket kill.
! !

!SWTServerApplication methodsFor: 'user interface' stamp: 'dgd 10/15/2007 11:20'!
logError: aString
	self runner logError: aString.
! !

!SWTServerApplication methodsFor: 'user interface' stamp: 'dgd 10/15/2007 11:20'!
log: aString
	self runner log: aString.! !

!SWTServerApplication methodsFor: 'remote mvc' stamp: 'dgd 11/3/2007 12:32'!
mId: remoteId rAWRId: idJsObject

	"ugly short name to speed up events disconnection"

	^ self modelId: remoteId removeActionsWithJsReceiverId: idJsObject! !

!SWTServerApplication methodsFor: 'remote mvc' stamp: 'dgd 11/3/2007 12:43'!
mId: remoteId w: eventNameString s: selector tOId: idJsObject wRS: selectorsCollection eC: eventCount oCS: onConflictSelector

	"ugly short name to speed up events connection"

	^ self
			modelId: remoteId
			when: eventNameString
			send: selector
			toJsObjectId: idJsObject
			withResultsOfSelectors: selectorsCollection
			eventCount: eventCount
			onConflictSend: onConflictSelector! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 10/17/2007 14:04'!
modelForId: idInteger ifAbsent: aBlock

	^ ids keyAtValue: idInteger ifAbsent: aBlock.
! !

!SWTServerApplication methodsFor: 'remote mvc' stamp: 'dgd 10/22/2007 13:35'!
modelId: remoteId perform: selector

	| model result |

	model := self
					modelForId: remoteId
					ifAbsent: [
						self logError: self asString , 'invalid modelId #' , remoteId asString.
						^ nil
					].

	result := model perform: selector.

	result == model ifTrue:[^ nil].
	^ result! !

!SWTServerApplication methodsFor: 'remote mvc' stamp: 'dgd 10/22/2007 13:35'!
modelId: remoteId perform: selector with: anObject

	| model result |

	model := self
					modelForId: remoteId
					ifAbsent: [
						self logError: self asString , 'invalid modelId #' , remoteId asString.
						^ nil
					].

	result := model perform: (selector copyReplaceAll: '_' with: ':') asSymbol with: anObject.

	result == model ifTrue:[^ nil].
	^ result! !

!SWTServerApplication methodsFor: 'remote mvc' stamp: 'dgd 11/2/2007 16:19'!
modelId: remoteId removeActionsWithJsReceiverId: idJsObject

	| model |

	model := self
					modelForId: remoteId
					ifAbsent: [
						self logError: self asString , 'invalid modelId #' , remoteId asString.
						^ nil
					].

	model removeActionsSatisfying:[:action |
		(action receiver == self)
			and: [ action selector == #forwardWith:with:with:message:to:producer:eventName:withResultsOfSelectors: ]
			and: [ action arguments fifth = idJsObject ]
	].
! !

!SWTServerApplication methodsFor: 'remote mvc' stamp: 'dgd 11/6/2007 11:22'!
modelId: remoteId when: eventNameString send: selector toJsObjectId: idJsObject withResultsOfSelectors: selectorsCollection eventCount: eventCount onConflictSend: onConflictSelector

	| model event |

	model := self
					modelForId: remoteId
					ifAbsent: [
						self logError: self asString , 'invalid modelId #' , remoteId asString.
						^ nil
					].

	event := eventNameString asSymbol.

	"EXPLANATION:
	MessageSend stores 'strong' (normal) references to the involved objects.
	If the model don't receive #removeActions* events (such cases of client premature disconnection), memory leaks can occurrs.
	Adding the model to gargage (and using in #close) we asure the event-disconnection (and the memory leaks)   -- dgd"
	garbage add: model.

	model
		when: event
		evaluate: (MessageSend
							receiver: self
							selector: #forwardWith:with:with:message:to:producer:eventName:withResultsOfSelectors:
							arguments: {nil. nil. nil. selector. idJsObject. model. eventNameString. selectorsCollection}
		).

	"If the client doesn't send eventCount, it don't want events to update itself"
	eventCount isNil ifFalse:[
		| currentEventCount |
		currentEventCount := model countOfTriggeredEvent: event.
		(currentEventCount = eventCount) ifFalse:[
			| args |

			self log: '# need to callback to update the clientside (has=' , eventCount asString , ', current is=', currentEventCount asString , ')'.

			args := selectorsCollection isNil
								ifTrue: [ { } ]
								ifFalse: [ selectorsCollection collect:[:eachSelector | model perform: eachSelector] ].

			self clientSide
						onModelId: idJsObject
						perform: onConflictSelector
						arguments: args.
		].
	].
! !

!SWTServerApplication methodsFor: 'pushing' stamp: 'dgd 10/22/2007 13:38'!
multicastClientSideMessageSend: aMessage 

	| script |

	script := self jsMethodInvocationFrom: aMessage.

	self runner
		pushScript: [:soc | script]
		select:[:soc |
			(soc isKindOf: SWTCometSocket)
				and:[soc hasServerApplication]
				and:[soc serverApplication class == self class]
		].
! !

!SWTServerApplication methodsFor: 'private' stamp: 'dgd 10/15/2006 19:18'!
nextId
	currentId := currentId + 1.
	^ currentId! !

!SWTServerApplication methodsFor: 'events - connection' stamp: 'dgd 11/11/2007 16:02'!
noteClientLag: aNumber

	| remAdd remAddStr |

	remAdd := socket remoteAddress.
	remAddStr := remAdd isNil ifTrue: [ 'nil' ] ifFalse: [ remAdd asIpString ].

	self log: ( 'LAG: client #{1} ({2}) has an average lag of {3}ms'
						format: { socket listenerId. remAddStr. aNumber rounded } ).
! !

!SWTServerApplication methodsFor: 'events - connection' stamp: 'dgd 11/11/2007 16:03'!
noteClientRpcTime: aNumber

	| remAdd remAddStr |

	remAdd := socket remoteAddress.
	remAddStr := remAdd isNil ifTrue: [ 'nil' ] ifFalse: [ remAdd asIpString ].

	self log: ( 'RPC: client #{1} ({2}) has an average rpc time of {3}ms'
						format: { socket listenerId. remAddStr. aNumber rounded } ).
! !

!SWTServerApplication methodsFor: 'rpc queuing' stamp: 'dgd 10/22/2007 13:39'!
performAsynchronousRPCQueue: asynchronousRPCQueue

	asynchronousRPCQueue do:[:pair |
		| selector args |

		selector := pair first asSymbol.
		args := pair second.

		self perform: selector withArguments: args.
	].
! !

!SWTServerApplication methodsFor: 'pushing' stamp: 'dgd 10/22/2007 13:38'!
pushClientSideMessageSend: aMessage 

	| script |

	script := self jsMethodInvocationFrom: aMessage.

	self socket pushScript: [:soc | script].
! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 9/5/2006 22:18'!
runner
	"Answer the receiver's runner"
	^ socket runner! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 9/5/2006 22:19'!
socket
	"Answer the receiver's socket"
	^ socket! !

!SWTServerApplication methodsFor: 'accessing' stamp: 'dgd 9/20/2006 17:26'!
sockets
	
	^ self runner swtSocketsOfApplication: self class.
! !

SWTServerApplication subclass: #SWTSocialShoppingServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-View'!

!SWTSocialShoppingServerApplication methodsFor: 'processing - cart' stamp: 'dgd 9/6/2006 20:44'!
buyProductId: anInteger

	| product |

	product := self system productById: anInteger.

	self buyProduct: product! !

!SWTSocialShoppingServerApplication methodsFor: 'processing - cart' stamp: 'dgd 9/6/2006 21:13'!
buyProduct: aSWTSocialShoppingProduct 

	self system inventory removeProduct: aSWTSocialShoppingProduct.
	self system cart addProduct: aSWTSocialShoppingProduct.

	self sendInventoryAndCart: true.

! !

!SWTSocialShoppingServerApplication methodsFor: 'events - connection' stamp: 'dgd 10/15/2007 16:20'!
justConnected

	super justConnected.

	self sendInventoryAndCart: false.
! !

!SWTSocialShoppingServerApplication methodsFor: 'events - connection' stamp: 'dgd 9/20/2006 17:41'!
justConnectedSocket: aSWTCometSocket 
	super justConnectedSocket: aSWTCometSocket.
	self sendUsersList! !

!SWTSocialShoppingServerApplication methodsFor: 'events - connection' stamp: 'dgd 9/5/2006 22:56'!
justDisconnected: aSWTCometSocket 

	super justDisconnected: aSWTCometSocket.

	self sendUsersList.! !

!SWTSocialShoppingServerApplication methodsFor: 'processing - cart' stamp: 'dgd 9/6/2006 20:42'!
notBuyProductId: anInteger

	| product |

	product := self system productById: anInteger.

	self notBuyProduct: product! !

!SWTSocialShoppingServerApplication methodsFor: 'processing - cart' stamp: 'dgd 9/6/2006 21:13'!
notBuyProduct: aSWTSocialShoppingProduct 

	self system cart removeProduct: aSWTSocialShoppingProduct.
	self system inventory addProduct: aSWTSocialShoppingProduct.

	self sendInventoryAndCart: true.
! !

!SWTSocialShoppingServerApplication methodsFor: 'processing - chat' stamp: 'dgd 9/6/2006 13:08'!
receiveChatMessage: aString from: userNameString
	"Transcript show: userNameString , ': ' , aString asString; cr."

	self clientSideMulticast receiveChatMessage: aString from: userNameString.
! !

!SWTSocialShoppingServerApplication methodsFor: 'sending' stamp: 'dgd 9/6/2006 21:13'!
sendInventoryAndCart: multicastBoolean

	| receiver |

	receiver := multicastBoolean
							ifTrue: [self clientSideMulticast]
							ifFalse: [self clientSide].

	receiver
		receiveInventory: self system inventory asJsonSerializable
		cart: self system cart asJsonSerializable.
! !

!SWTSocialShoppingServerApplication methodsFor: 'sending' stamp: 'dgd 9/20/2006 17:25'!
sendUsersList

	| users |

	users := self sockets collect: [:each | each userName].

	self clientSide receiveUsersList: users asSortedCollection.
! !

!SWTSocialShoppingServerApplication methodsFor: 'accessing' stamp: 'dgd 9/6/2006 14:09'!
system
	^ SWTSocialShoppingSystem instance! !

SWTServerApplication subclass: #SWTWhiteboardServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SharedWhiteboard'!

!SWTWhiteboardServerApplication methodsFor: 'drawing' stamp: 'dgd 10/14/2006 14:09'!
clear

	self clientSideMulticast clear.
! !

!SWTWhiteboardServerApplication methodsFor: 'drawing' stamp: 'dgd 10/19/2006 15:32'!
newStroke: aPenStrokeDictionary

	| stroke |

	stroke := SWTStroke constructFromJson: aPenStrokeDictionary.
"	stroke simplify."

	self clientSideMulticast newStroke: stroke.
! !

SWTServerApplication subclass: #SWTWindowsServerApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples'!

Object subclass: #SWTSocialShoppingProduct
	instanceVariableNames: 'id title description price image'
	classVariableNames: 'ID'
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-Model'!

!SWTSocialShoppingProduct class methodsFor: 'instance creation' stamp: 'dgd 9/6/2006 19:10'!
title: titleString description: descriptionString price: aNumber image: imageSrcString
	^ self new initializeTitle: titleString description: descriptionString price: aNumber image: imageSrcString! !

!SWTSocialShoppingProduct methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:50'!
description
	^ description! !

!SWTSocialShoppingProduct methodsFor: 'accessing' stamp: 'dgd 9/6/2006 19:51'!
id
	^ id! !

!SWTSocialShoppingProduct methodsFor: 'accessing' stamp: 'dgd 9/6/2006 19:11'!
image
	^ image! !

!SWTSocialShoppingProduct methodsFor: 'initialization' stamp: 'dgd 9/6/2006 19:50'!
initialize

	ID isNil ifTrue:[ID := 0].

	ID := ID + 1.
	id := ID.! !

!SWTSocialShoppingProduct methodsFor: 'initialization' stamp: 'dgd 9/6/2006 19:10'!
initializeTitle: titleString description: descriptionString price: aNumber image: imageSrcString

	title := titleString.
	description := descriptionString.
	price := aNumber.
	image := imageSrcString.
! !

!SWTSocialShoppingProduct methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:50'!
price
	^ price! !

!SWTSocialShoppingProduct methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:50'!
title
	^ title! !

Object subclass: #SWTSocialShoppingProductHolder
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-Model'!

SWTSocialShoppingProductHolder subclass: #SWTSocialShoppingCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-Model'!

!SWTSocialShoppingCart methodsFor: 'serialization' stamp: 'dgd 9/6/2006 21:01'!
arrayForProduct: product count: count
	^ { product title. product price. count. product id}
! !

SWTSocialShoppingProductHolder subclass: #SWTSocialShoppingInventory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-Model'!

!SWTSocialShoppingInventory methodsFor: 'serialization' stamp: 'dgd 9/6/2006 21:00'!
arrayForProduct: product count: count
	^ { product title. product description. product price. count. product image. product id}
! !

!SWTSocialShoppingInventory methodsFor: 'initialization' stamp: 'dgd 9/6/2006 13:59'!
initialize
	super initialize.

	self initializeExampleProducts.! !

!SWTSocialShoppingInventory methodsFor: 'initialization' stamp: 'dgd 9/6/2006 20:56'!
initializeExampleProducts

	self
		addProduct: (SWTSocialShoppingProduct
										title: 'Jamn Ibrico'
										description: ' El jamn ibrico de bellota es un producto elaborado artesanalmente, dndosele a la pata un corte tpicamente serrano. Su exquisitez se debe a la alimentacin del cerdo, a base de hierbas y bellotas al aire libre en la sierra.'
										price: 70
										image: 'jamoniberico.png')
		count: 2.

	self
		addProduct: (SWTSocialShoppingProduct
										title: 'Torta del Casar'
										description:
										'Elaborada por los mtodos tradicionales heredados de padres a hijos durante generaciones, para no perder su autenticidad.'
										price: 25
										image: 'tortadelcasar.png')
		count: 15.


	self
		addProduct: (SWTSocialShoppingProduct
										title: 'Chorizo Ibrico'
										description:
										'Elaborado con magro de cerdo ibrico de bellota, condimentado con sal y pimentn natural. Tras macerar durante 24 horas, se cura mediante secado natural durante al menos 3 meses lo que afina su caracterstico sabor y aroma.'
										price: 10
										image: 'chorizoiberico.png')
		count: 15.
! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:58'!
addProduct: aProduct
	items add: aProduct.
! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 14:00'!
addProduct: aProduct count: anInteger
	
	anInteger timesRepeat: [self addProduct: aProduct].
! !

!SWTSocialShoppingProductHolder methodsFor: 'serialization' stamp: 'dgd 9/6/2006 21:01'!
arrayForProduct: product count: count
	^ self subclassResponsibility! !

!SWTSocialShoppingProductHolder methodsFor: 'serialization' stamp: 'dgd 9/6/2006 21:00'!
asJsonSerializable
	"Answer a representation of the receiver that can be serialized using JSON format"

	| result |

	result := OrderedCollection new.

	(self countsAndProducts asSortedCollection:[:x :y | x value title <= y value title]) do:[:ass |
		| count product |

		count := ass key.
		product := ass value.

		result add: (self arrayForProduct: product count: count)
	].

	^ result.
! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:59'!
countsAndProducts
	^ items sortedCounts! !

!SWTSocialShoppingProductHolder methodsFor: 'initialization' stamp: 'dgd 9/6/2006 13:59'!
initialize
	super initialize.

	items := Bag new.
! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 20:00'!
productById: anInteger 
	^ items detect:[:each | each id = anInteger]! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 20:43'!
productById: anInteger ifAbsent: aBlock
	^ items detect:[:each | each id = anInteger] ifNone: aBlock! !

!SWTSocialShoppingProductHolder methodsFor: 'accessing' stamp: 'dgd 9/6/2006 20:04'!
removeProduct: aProduct 
	items remove: aProduct! !

Object subclass: #SWTSocialShoppingSystem
	instanceVariableNames: 'cart inventory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Examples-SocialShopping-Model'!

SWTSocialShoppingSystem class
	instanceVariableNames: 'instance'!

!SWTSocialShoppingSystem class methodsFor: 'singleton accessing' stamp: 'dgd 9/6/2006 13:55'!
clearInstance
	"Clear the receiver (singleton) instance"

	instance := nil
! !

!SWTSocialShoppingSystem class methodsFor: 'singleton accessing' stamp: 'dgd 9/6/2006 13:43'!
initializeInstance
	instance := super new.! !

!SWTSocialShoppingSystem class methodsFor: 'singleton accessing' stamp: 'dgd 9/6/2006 13:43'!
instance

	instance isNil
		ifTrue:[self initializeInstance].

	^ instance.
! !

!SWTSocialShoppingSystem class methodsFor: 'instance creation' stamp: 'dgd 9/6/2006 13:44'!
new
	^ self error: 'Singleton class, use #instance to get the instance'.
! !

!SWTSocialShoppingSystem methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:46'!
cart
	^ cart! !

!SWTSocialShoppingSystem methodsFor: 'initialization' stamp: 'dgd 9/6/2006 13:46'!
initialize

	super initialize.

	cart := SWTSocialShoppingCart new.
	inventory := SWTSocialShoppingInventory new.
! !

!SWTSocialShoppingSystem methodsFor: 'accessing' stamp: 'dgd 9/6/2006 13:47'!
inventory
	^ inventory! !

!SWTSocialShoppingSystem methodsFor: 'accessing' stamp: 'dgd 9/6/2006 20:44'!
productById: aSmallInteger 
	^ inventory
			productById: aSmallInteger
			ifAbsent:[ cart productById: aSmallInteger ]! !

TestCase subclass: #SWTModelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC-Tests'!

!SWTModelTest methodsFor: 'running' stamp: 'dgd 11/1/2007 10:49'!
testSerialization

	| model context |


	context := SWTServerApplication new.
	model := SWTSampleModel new.

	self assert: (model jsSerializedContext: context) = '(function() {
var o=[ST.SWTRemoteModel.__new__(),[],_a("foo",true,0),_a("bar",false,0),_a("yesNo",false,0),_a("list",true,0),[]];
o[1]=Array.withAll_(o.slice(2,6));
o[0]._asp=o[1];
o[0]._remoteId=1;
o[2]._model=o[0];
o[2]._cached="Read Only String";
o[3]._model=o[0];
o[3]._cached="ReadWrite String";
o[4]._model=o[0];
o[4]._cached=false;
o[5]._model=o[0];
o[5]._cached=o[6];
o[6][0]="item 1";
o[6][1]="item 2";
return o[0];
})()'.
"
	{
		ReferenceStream streamedRepresentationOf: model.
		model jsSerializedContext: context
	} inspect.
"! !

!SWTModelTest methodsFor: 'running' stamp: 'dgd 10/31/2007 13:09'!
testSerialization2

	| model context |


	context := SWTServerApplication new.
	model := SWTStroke points: {1@2. 3@4. 5@6. 7@8} color: Color red width: 2.

	self assert: (model jsSerializedContext: context) =  '(function() {
var o=[ST.SWTStroke.__new__(),[],_c(1,0,0,1),_p(1,2),_p(3,4),_p(5,6),_p(7,8)];
o[1]=Array.withAll_(o.slice(3,7));
o[0]._points=o[1];
o[0]._color=o[2];
o[0]._width=2;
return o[0];
})()'.
! !

TestCase subclass: #SWTOrderedCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-MVC-Tests'!

!SWTOrderedCollectionTest methodsFor: 'running' stamp: 'dgd 11/2/2007 17:41'!
testAccessing

	| collection nativeCollection |

	nativeCollection := {'one'. 'two'. 3} asOrderedCollection.
	collection := SWTOrderedCollection withAll: nativeCollection.

	self should: [ collection size = 3 ].

	self should: [ (collection at: 1) = (nativeCollection at: 1)].
	self should: [ (collection at: 2) = (nativeCollection at: 2)].
	self should: [ (collection at: 3) = (nativeCollection at: 3)].

	self should: [ collection first = nativeCollection first].
	self should: [ collection second = nativeCollection second].
	self should: [ collection third = nativeCollection third].
	self should: [ collection last = nativeCollection last].
! !

!SWTOrderedCollectionTest methodsFor: 'running' stamp: 'dgd 11/10/2007 13:32'!
testAdd

	| collection eventObject eventPosition firstObject secondObject |

	collection := SWTOrderedCollection new.

	eventObject := nil.
	eventPosition := 'not nil'.

	collection
		when: #addedElement
		send: #value:value:
		to: [:newObject :newPosition |
			eventObject := newObject.
			eventPosition := newPosition.
		].

	"no event, still nil"
	self should: [ collection isEmpty ].
	self should: [ eventObject isNil ].
	self should: [ eventPosition notNil ].

	"let's add the very first object"
	firstObject := 'the one'.
	collection add: firstObject.				"#add: and #addLast: have the same semantics"
	self should: [ collection size = 1 ].
	self should: [ eventObject == firstObject ].
	self should: [ eventPosition isNil ].

	"let's add the second object"
	secondObject := 'the second'.
	collection addLast: secondObject.		"#add: and #addLast: have the same semantics"
	self should: [ collection size = 2 ].
	self should: [ eventObject == secondObject ].
	self should: [ eventPosition isNil ].
! !

!SWTOrderedCollectionTest methodsFor: 'running' stamp: 'dgd 11/2/2007 17:46'!
testCopying

	| collection nativeCollection copyWithFirst1 copyWithFirst2 copyWithLast |

	nativeCollection := {'one'. 'two'. 3} asOrderedCollection.
	collection := SWTOrderedCollection withAll: nativeCollection.

	copyWithFirst1 := collection first: 1.
	self shouldnt: [ copyWithFirst1 == collection].
	self should: [ copyWithFirst1 class == collection class].
	self should: [ copyWithFirst1 size = 1].
	self should: [ copyWithFirst1 first = nativeCollection first].

	copyWithFirst2 := collection first: 2.
	self shouldnt: [ copyWithFirst2 == collection].
	self should: [ copyWithFirst2 class == collection class].
	self should: [ copyWithFirst2 size = 2].
	self should: [ copyWithFirst2 second = nativeCollection second].

	copyWithLast := collection last: 1.
	self shouldnt: [ copyWithLast == collection].
	self should: [ copyWithLast class == collection class].
	self should: [ copyWithLast size = 1].
	self should: [ copyWithLast last = nativeCollection last].
! !

!SWTOrderedCollectionTest methodsFor: 'running' stamp: 'dgd 11/2/2007 17:27'!
testRemove

	| collection firstVictim secondVictim thirdVictim eventPosition |

	collection := SWTOrderedCollection withAll: {thirdVictim := 'one'. firstVictim := 'two'. secondVictim := 3}.

	eventPosition := nil.

	collection
		when: #removedElement
		send: #value:
		to: [ :oldPosition |
			eventPosition := oldPosition.
		].

	"no event, still nil"
	self should: [ collection size = 3 ].
	self should: [ eventPosition isNil ].

	"let's remove the first victim"
	collection remove: firstVictim.
	self should: [ collection size = 2 ].
	self should: [ eventPosition = 2 ].

	"let's remove the second victim"
	collection remove: secondVictim.
	self should: [ collection size = 1 ].
	self should: [ eventPosition = 2 ].

	"let's remove the third victim"
	collection remove: thirdVictim.
	self should: [ collection isEmpty ].
	self should: [ eventPosition = 1 ].
! !

ACometSocket subclass: #SWTCometSocket
	instanceVariableNames: 'serverApplication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWT-Core-Application'!

!SWTCometSocket methodsFor: 'connection' stamp: 'dgd 10/15/2007 16:19'!
close

	serverApplication close.

	super close.
! !

!SWTCometSocket methodsFor: 'accessing' stamp: 'dgd 9/5/2006 21:39'!
hasServerApplication
	^serverApplication notNil! !

!SWTCometSocket methodsFor: 'events - connection' stamp: 'dgd 10/15/2007 16:21'!
justConnected

	super justConnected.

	serverApplication justConnected.

! !

!SWTCometSocket methodsFor: 'events - connection' stamp: 'dgd 9/20/2006 17:48'!
justConnected: aSWTCometSocket request: aRequest 

	serverApplication justConnectedSocket: aSWTCometSocket.
! !

!SWTCometSocket methodsFor: 'connection' stamp: 'dgd 9/14/2006 20:13'!
justCreatedFromRequest: aRequest
	"The receiver was just created from the given http request"

	| serverAppName klass |

	super justCreatedFromRequest: aRequest.

	serverAppName := aRequest getFields
											at: 'application'
											ifAbsent:[ ^ self error: 'application name is missing' ].
	klass := Smalltalk
						at: serverAppName asSymbol
						ifAbsent:[ ^ self error: 'invalid application class' ].

	(klass inheritsFrom: SWTServerApplication)
		ifFalse:[ ^ self error: 'invalid application class (not proper class)' ].

	serverApplication := klass socket: self.
! !

!SWTCometSocket methodsFor: 'events - connection' stamp: 'dgd 9/20/2006 17:51'!
justDisconnected: aSWTCometSocket 

	serverApplication justDisconnected: aSWTCometSocket.
! !

!SWTCometSocket methodsFor: 'accessing' stamp: 'dgd 11/7/2007 15:04'!
localAddress
	^ stream socket localAddress.! !

!SWTCometSocket methodsFor: 'accessing' stamp: 'dgd 11/7/2007 15:33'!
localPort
	^ stream socket localPort.! !

!SWTCometSocket methodsFor: 'accessing' stamp: 'dgd 11/7/2007 15:03'!
remoteAddress
	^ stream socket remoteAddress.! !

!SWTCometSocket methodsFor: 'accessing' stamp: 'dgd 11/7/2007 15:33'!
remotePort
	^ stream socket remotePort.! !

!SWTCometSocket methodsFor: 'accessing' stamp: 'dgd 9/5/2006 21:39'!
serverApplication
	^ serverApplication! !

!SWTCometSocket methodsFor: 'accessing' stamp: 'dgd 9/20/2006 17:14'!
userName
	^ '#' , self listenerId asString.
! !

!Form methodsFor: '*SWT-converting' stamp: 'dgd 6/4/2007 20:21'!
asPNGStream

	| stream rw |
	stream := RWBinaryOrTextStream on: (ByteArray new: 10000).

	rw := PNGReadWriter on: stream.
	rw nextPutImage: self.
	rw close.

	stream reset.

	^ stream.
! !

!Form methodsFor: '*SWT-scaling, rotation' stamp: 'dgd 12/13/2006 14:42'!
scaledIntoFormOfSize: aNumberOrPoint 
	"Scale and center the receiver into a form of a given size"
	| extent scale scaledForm result |
	extent := aNumberOrPoint asPoint.
	extent = self extent
		ifTrue: [^ self].
	(self height isZero
			or: [self width isZero])
		ifTrue: [^ Form extent: extent depth: self depth].
	scale := extent y / self height min: extent x / self width.
	scaledForm := self
				magnify: self boundingBox
				by: scale
				smoothing: 8.
	result := Form extent: extent depth: 32.
	result getCanvas translucentImage: scaledForm at: extent - scaledForm extent // 2.
	^ result! !

!S2SObjectExtension methodsFor: '*SWT-views' stamp: 'dgd 11/28/2006 19:51'!
defaultView
	^ SWTText contents: self asString! !

!S2SObjectExtension methodsFor: '*SWT-views' stamp: 'dgd 10/27/2007 19:05'!
defaultViewClass
	^ SWTText! !
SWTApplicationRunner initialize!
SWTRootPanel initialize!
SWTMapServerApplication initialize!
